/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.compositionprogram.impl;


import org.reuseware.coconut.fragment.FragmentFactory;
import java.util.*;
import org.reuseware.coconut.fragment.ComposedFragment;
import java.util.ArrayList;
import org.reuseware.coconut.compositionprogram.CompositionLink;
import org.reuseware.coconut.compositionprogram.FragmentInstance;
import org.reuseware.coconut.fragment.InstantiationSet;
import org.reuseware.coconut.id.IdFactory;
import org.reuseware.coconut.id.ID;


/**
 * @generated
 **/
public abstract class CompositionProgramImpl
{


   public void compose (){
      boolean fujaba__Success = false;
      InstantiationSet is = null;
      EList<org.eclipse.emf.ecore.EObject> context = null;
      Iterator<ComposedFragment> fujaba__IterThisToComposedFragment = null;
      ComposedFragment composedFragment = null;
      Iterator<CompositionLink> fujaba__IterThisToLink = null;
      CompositionLink link = null;
      Object _TmpObject = null;
      Iterator<FragmentInstance> fujaba__IterThisToFi = null;
      FragmentInstance fi = null;

      // story pattern 
      try 
      {
         fujaba__Success = false; 

         // create object
         is = FragmentFactory.eINSTANCE.createInstantiationSet();
         // collabStat call
         context = new org.eclipse.emf.common.util.BasicEList<org.eclipse.emf.ecore.EObject>();
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link composedFragments from this to composedFragment
         fujaba__Success = false;
         fujaba__IterThisToComposedFragment = new ArrayList<ComposedFragment>(this.getComposedFragments()).iterator ();

         while ( fujaba__IterThisToComposedFragment.hasNext () )
         {
            try
            {
               composedFragment = (ComposedFragment) fujaba__IterThisToComposedFragment.next ();

               // check object composedFragment is really bound
               if (!( composedFragment != null )) {throw new Exception("SDMException");};
               // destroy link
               this.getComposedFragments().remove (composedFragment);


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 3
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link compositionLinks from this to link
         fujaba__Success = false;
         fujaba__IterThisToLink = new ArrayList<CompositionLink>(this.getCompositionLinks()).iterator ();

         while ( fujaba__IterThisToLink.hasNext () )
         {
            try
            {
               link = (CompositionLink) fujaba__IterThisToLink.next ();

               // check object link is really bound
               if (!( link != null )) {throw new Exception("SDMException");};
               // collabStat call
               link.match();

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 2
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link fragmentInstances from this to fi
         fujaba__Success = false;
         fujaba__IterThisToFi = new ArrayList<FragmentInstance>(this.getFragmentInstances()).iterator ();

         while ( fujaba__IterThisToFi.hasNext () )
         {
            try
            {
               fi = (FragmentInstance) fujaba__IterThisToFi.next ();

               // check object fi is really bound
               if (!( fi != null )) {throw new Exception("SDMException");};
               // attribute condition
               if (!( fi.isTarget () == true )) {throw new Exception("SDMException");};

               // story pattern 3
               try 
               {
                  fujaba__Success = false; 

                  _TmpObject = fi.compose(is, context);

                  // ensure correct type and really bound of object composedFragment
                  if (!( _TmpObject instanceof ComposedFragment )) {throw new Exception("SDMException");};
                  composedFragment = (ComposedFragment) _TmpObject;

                  // create link
                  this.getComposedFragments().add(composedFragment);

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               if (composedFragment != null) {
               context.addAll(composedFragment.getContents());
               for(FragmentInstance instantiated : this.getFragmentInstances()) {
               	if (instantiated.getInstantiations().size() == 1) {
               		if (!is.getInstantiations().contains(instantiated.getInstantiations().get(0))) {
               			is.getInstantiations().add(instantiated.getInstantiations().get(0));															
               		}
               	}
               	else if (instantiated.getInstantiations().size() > 1) {
               		instantiated.getInstantiations().clear();
               	}
               }
               }

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;

   }


   public ID getUCPIAsID (){
      boolean fujaba__Success = false;
      ID id = null;

      // story pattern successor
      try 
      {
         fujaba__Success = false; 

         // create object
         id = IdFactory.eINSTANCE.createID();
         // assign statement
         id.getSegments ().clear();
         id.getSegments ().addAll(this.getUCPI());
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return id;

   }


   public void removeYou()
   {
      this.getComposedFragments().clear();
      this.getCompositionLinks().clear();
      this.getFragmentInstances().clear();
   }
}


