/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.compositionprogram.impl;


import java.util.*;
import org.reuseware.coconut.compositionprogram.FragmentInstance;
import org.reuseware.coconut.compositionprogram.CompositionprogramFactory;
import org.reuseware.coconut.compositionprogram.PortInstance;
import org.reuseware.coconut.compositionprogram.CompositionLink;
import org.reuseware.coconut.fracol.FragmentCollaboration;
import org.reuseware.coconut.fracol.FragmentRole;
import org.reuseware.coconut.fracol.PortType;
import org.reuseware.coconut.fracol.CompositionAssociation;
import org.reuseware.coconut.fracol.StaticPortType;
import org.reuseware.coconut.fragment.Fragment;
import org.eclipse.emf.ecore.EObject;
import org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding;
import org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator;
import org.reuseware.coconut.compositionprogram.Setting;
import org.reuseware.coconut.reuseextension.SettingDerivationRule;
import java.util.ArrayList;
import org.reuseware.coconut.reuseextension.PortType2SettingBinding;
import org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding;
import org.eclipse.emf.ecore.EClass;
import org.reuseware.coconut.reuseextension.CompositionLanguageSpecification;


/**
 * @generated
 **/
public class DerivedCompositionProgramImpl extends CompositionProgram
{


   public CompositionLink createCompositionLink (Fragment fragment , EObject source , EObject target , CompositionAssociation2CompositionLinkBinding assocBinding , ReuseExtensionActivator activator ){
      boolean fujaba__Success = false;
      FragmentCollaboration cs = null;
      FragmentRole role1 = null;
      PortType portType1 = null;
      CompositionAssociation assoc = null;
      FragmentRole role2 = null;
      PortType portType2 = null;
      java.util.Map<String,String> args = null;
      Iterator<FragmentInstance> fujaba__IterThisToFi1 = null;
      FragmentInstance fi1 = null;
      Iterator<FragmentInstance> fujaba__IterThisToFi2 = null;
      FragmentInstance fi2 = null;
      Object _TmpObject = null;
      StaticPortType port1Type = null;
      String portName = null;
      Iterator<PortInstance> fujaba__IterFi1ToPi1 = null;
      PortInstance pi1 = null;
      StaticPortType port2Type = null;
      Iterator<PortInstance> fujaba__IterFi2ToPi2 = null;
      PortInstance pi2 = null;
      Iterator<CompositionLink> fujaba__IterThisToLink = null;
      CompositionLink link = null;

      // story pattern find types (end 1)
      try 
      {
         fujaba__Success = false; 

         // check object assocBinding is really bound
         if (!( assocBinding != null )) {throw new Exception("SDMException");};
         // bind object
         assoc = assocBinding.getCompositionAssociation ();

         // check object assoc is really bound
         if (!( assoc != null )) {throw new Exception("SDMException");};

         // bind object
         cs = assoc.getFragmentCollaboration ();

         // check object cs is really bound
         if (!( cs != null )) {throw new Exception("SDMException");};


         // bind object
         portType1 = assoc.getEnd1 ();

         // check object portType1 is really bound
         if (!( portType1 != null )) {throw new Exception("SDMException");};

         // bind object
         role1 = portType1.getFragmentRole ();

         // check object role1 is really bound
         if (!( role1 != null )) {throw new Exception("SDMException");};




         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         // story pattern find types (end 2)
         try 
         {
            fujaba__Success = false; 

            // check object assoc is really bound
            if (!( assoc != null )) {throw new Exception("SDMException");};
            // bind object
            portType2 = assoc.getEnd2 ();

            // check object portType2 is really bound
            if (!( portType2 != null )) {throw new Exception("SDMException");};

            // bind object
            role2 = portType2.getFragmentRole ();

            // check object role2 is really bound
            if (!( role2 != null )) {throw new Exception("SDMException");};



            // collabStat call
            args = new java.util.LinkedHashMap<String, String>();
            // collabStat call
            for ( int i = 0;i <= activator.getArguments().size()-1;++i )
            {
            args.put(activator.getArguments().get(i).getParameter(), activator.getArguments().get(i).getValue());
            }
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {
            // story pattern ensure fi1 exists
            try 
            {
               fujaba__Success = false; 

               // iterate to-many link fragmentInstances from this to fi1
               fujaba__Success = false;
               fujaba__IterThisToFi1 = this.getFragmentInstances().iterator ();

               while ( !(fujaba__Success) && fujaba__IterThisToFi1.hasNext () )
               {
                  try
                  {
                     fi1 = (FragmentInstance) fujaba__IterThisToFi1.next ();

                     // check object fi1 is really bound
                     if (!( fi1 != null )) {throw new Exception("SDMException");};
                     // attribute condition
                     if (!( org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(fragment.getUFI(), source, assocBinding.getFragmentInstance1NameExpression(), args).equals(fi1.getName ()) )) {throw new Exception("SDMException");};


                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {

            }
            else
            {
               // story pattern ensure fi1 exists 2
               try 
               {
                  fujaba__Success = false; 

                  // create object
                  fi1 = CompositionprogramFactory.eINSTANCE.createFragmentInstance();
                  // assign statement
                  fi1.setName (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(fragment.getUFI(), source, assocBinding.getFragmentInstance1NameExpression(), args));
                  // create link
                  fi1.setCompositionProgram(this);

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


            }
            // story pattern ensure fi2 exists
            try 
            {
               fujaba__Success = false; 

               // iterate to-many link fragmentInstances from this to fi2
               fujaba__Success = false;
               fujaba__IterThisToFi2 = this.getFragmentInstances().iterator ();

               while ( !(fujaba__Success) && fujaba__IterThisToFi2.hasNext () )
               {
                  try
                  {
                     fi2 = (FragmentInstance) fujaba__IterThisToFi2.next ();

                     // check object fi2 is really bound
                     if (!( fi2 != null )) {throw new Exception("SDMException");};
                     // attribute condition
                     if (!( org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(fragment.getUFI(), target, assocBinding.getFragmentInstance2NameExpression(), args).equals(fi2.getName ()) )) {throw new Exception("SDMException");};


                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {

            }
            else
            {
               // story pattern ensure fi2 exists 2
               try 
               {
                  fujaba__Success = false; 

                  // create object
                  fi2 = CompositionprogramFactory.eINSTANCE.createFragmentInstance();
                  // assign statement
                  fi2.setName (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(fragment.getUFI(), target, assocBinding.getFragmentInstance2NameExpression(), args));
                  // create link
                  fi2.setCompositionProgram(this);

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


            }
            // story pattern static port type 1
            try 
            {
               fujaba__Success = false; 

               // check object assoc is really bound
               if (!( assoc != null )) {throw new Exception("SDMException");};
               // bind object
               _TmpObject = assoc.getEnd1 ();

               // ensure correct type and really bound of object port1Type
               if (!( _TmpObject instanceof StaticPortType )) {throw new Exception("SDMException");};
               port1Type = (StaticPortType) _TmpObject;



               // collabStat call
               portName = port1Type.getName();
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {

            }
            else
            {
               // story pattern 
               try 
               {
                  fujaba__Success = false; 

                  // collabStat call
                  portName = org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(fragment.getUFI(), source, assocBinding.getPortInstance1NameExpression(), args);
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


            }
            // story pattern ensure pi1 exists
            try 
            {
               fujaba__Success = false; 

               // check object fi1 is really bound
               if (!( fi1 != null )) {throw new Exception("SDMException");};
               // iterate to-many link portInstances from fi1 to pi1
               fujaba__Success = false;
               fujaba__IterFi1ToPi1 = fi1.getPortInstances().iterator ();

               while ( !(fujaba__Success) && fujaba__IterFi1ToPi1.hasNext () )
               {
                  try
                  {
                     pi1 = (PortInstance) fujaba__IterFi1ToPi1.next ();

                     // check object pi1 is really bound
                     if (!( pi1 != null )) {throw new Exception("SDMException");};
                     // attribute condition
                     if (!( cs.getFracolName().equals(pi1.getFracolName ()) )) {throw new Exception("SDMException");};

                     // attribute condition
                     if (!( pi1.getFracolNamespace ().equals(cs.getFracolNamespace())
                      )) {throw new Exception("SDMException");};

                     // attribute condition
                     if (!( role1.getName().equals(pi1.getFragmentRoleName ()) )) {throw new Exception("SDMException");};

                     // attribute condition
                     if (!( portName.equals(pi1.getPortName ()) )) {throw new Exception("SDMException");};


                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {

            }
            else
            {
               // story pattern ensure pi1 exists 2
               try 
               {
                  fujaba__Success = false; 

                  // check object fi1 is really bound
                  if (!( fi1 != null )) {throw new Exception("SDMException");};
                  // create object
                  pi1 = CompositionprogramFactory.eINSTANCE.createPortInstance();
                  // assign statement
                  pi1.getFracolNamespace ().clear();
                  pi1.getFracolNamespace ().addAll(cs.getFracolNamespace());
                  // assign statement
                  pi1.setFragmentRoleName (role1.getName());
                  // assign statement
                  pi1.setPortName (portName);
                  // assign statement
                  pi1.setFracolName (cs.getFracolName());
                  // create link
                  pi1.setFragmentInstance(fi1);

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


            }
            // story pattern static port type 2
            try 
            {
               fujaba__Success = false; 

               // check object assoc is really bound
               if (!( assoc != null )) {throw new Exception("SDMException");};
               // bind object
               _TmpObject = assoc.getEnd2 ();

               // ensure correct type and really bound of object port2Type
               if (!( _TmpObject instanceof StaticPortType )) {throw new Exception("SDMException");};
               port2Type = (StaticPortType) _TmpObject;



               // collabStat call
               portName = port2Type.getName();
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {

            }
            else
            {
               // story pattern 
               try 
               {
                  fujaba__Success = false; 

                  // collabStat call
                  portName = org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(fragment.getUFI(), target, assocBinding.getPortInstance2NameExpression(), args);
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


            }
            // story pattern ensure pi2 exists
            try 
            {
               fujaba__Success = false; 

               // check object fi2 is really bound
               if (!( fi2 != null )) {throw new Exception("SDMException");};
               // iterate to-many link portInstances from fi2 to pi2
               fujaba__Success = false;
               fujaba__IterFi2ToPi2 = fi2.getPortInstances().iterator ();

               while ( !(fujaba__Success) && fujaba__IterFi2ToPi2.hasNext () )
               {
                  try
                  {
                     pi2 = (PortInstance) fujaba__IterFi2ToPi2.next ();

                     // check object pi2 is really bound
                     if (!( pi2 != null )) {throw new Exception("SDMException");};
                     // attribute condition
                     if (!( cs.getFracolName().equals(pi2.getFracolName ()) )) {throw new Exception("SDMException");};

                     // attribute condition
                     if (!( pi2.getFracolNamespace ().equals(cs.getFracolNamespace())
                      )) {throw new Exception("SDMException");};

                     // attribute condition
                     if (!( role2.getName().equals(pi2.getFragmentRoleName ()) )) {throw new Exception("SDMException");};

                     // attribute condition
                     if (!( portName.equals(pi2.getPortName ()) )) {throw new Exception("SDMException");};


                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};
               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {

            }
            else
            {
               // story pattern ensure pi2 exists 2
               try 
               {
                  fujaba__Success = false; 

                  // check object fi2 is really bound
                  if (!( fi2 != null )) {throw new Exception("SDMException");};
                  // create object
                  pi2 = CompositionprogramFactory.eINSTANCE.createPortInstance();
                  // assign statement
                  pi2.getFracolNamespace ().clear();
                  pi2.getFracolNamespace ().addAll(cs.getFracolNamespace());
                  // assign statement
                  pi2.setPortName (portName);
                  // assign statement
                  pi2.setFragmentRoleName (role2.getName());
                  // assign statement
                  pi2.setFracolName (cs.getFracolName());
                  // create link
                  pi2.setFragmentInstance(fi2);

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


            }
            // story pattern ensure link exists
            try 
            {
               fujaba__Success = false; 

               // check object pi1 is really bound
               if (!( pi1 != null )) {throw new Exception("SDMException");};
               // check object pi2 is really bound
               if (!( pi2 != null )) {throw new Exception("SDMException");};
               // check object source is really bound
               if (!( source != null )) {throw new Exception("SDMException");};

               // check isomorphic binding between objects pi2 and pi1
               if (!( !pi2.equals (pi1) )) {throw new Exception("SDMException");};

               // iterate to-many link compositionLinks from this to link
               fujaba__Success = false;
               fujaba__IterThisToLink = this.getCompositionLinks().iterator ();

               while ( !(fujaba__Success) && fujaba__IterThisToLink.hasNext () )
               {
                  try
                  {
                     link = (CompositionLink) fujaba__IterThisToLink.next ();

                     // check object link is really bound
                     if (!( link != null )) {throw new Exception("SDMException");};
                     // check link source from link to pi1
                     if (!(pi1.equals (link.getSource ()))) {throw new Exception("SDMException");};

                     // check link target from link to pi2
                     if (!(pi2.equals (link.getTarget ()))) {throw new Exception("SDMException");};


                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};
               // create link
               link.getDerivedFrom().add(source);

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }

            if (fujaba__Success)
            {

            }
            else
            {
               // story pattern ensure link exists 2
               try 
               {
                  fujaba__Success = false; 

                  // check object pi1 is really bound
                  if (!( pi1 != null )) {throw new Exception("SDMException");};
                  // check object pi2 is really bound
                  if (!( pi2 != null )) {throw new Exception("SDMException");};
                  // check object source is really bound
                  if (!( source != null )) {throw new Exception("SDMException");};

                  // check isomorphic binding between objects pi2 and pi1
                  if (!( !pi2.equals (pi1) )) {throw new Exception("SDMException");};

                  // create object
                  link = CompositionprogramFactory.eINSTANCE.createCompositionLink();
                  // create link
                  link.setCompositionProgram(this);

                  // create link
                  pi2.getTargetLinks().add(link);

                  // create link
                  pi1.getSourceLinks().add(link);

                  // create link
                  link.getDerivedFrom().add(source);

                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }


            }
            return link;

         }

      }
      else
      {

      }
      return null;

   }


   public FragmentInstance createFragmentInstance (Fragment fragment , EObject element , FragmentRole2FragmentInstanceBinding roleBinding , ReuseExtensionActivator activator ){
      boolean fujaba__Success = false;
      java.util.Map<String,String> args = null;
      Iterator<FragmentInstance> fujaba__IterThisToFi = null;
      FragmentInstance fi = null;
      Iterator<PortInstance> fujaba__IterFiToPi = null;
      PortInstance pi = null;
      Iterator<Setting> fujaba__IterPiToSetting = null;
      Setting setting = null;
      Iterator<SettingDerivationRule> fujaba__IterPortTypeBindingToSettingRule = null;
      SettingDerivationRule settingRule = null;
      PortType portType = null;
      Iterator<PortType2SettingBinding> fujaba__IterRoleBindingToPortTypeBinding = null;
      PortType2SettingBinding portTypeBinding = null;
      FragmentCollaboration cs = null;
      FragmentRole role = null;

      // story pattern 
      try 
      {
         fujaba__Success = false; 

         // collabStat call
         args = new java.util.LinkedHashMap<String, String>();
         // collabStat call
         for ( int i = 0;i <= activator.getArguments().size()-1;++i )
         {
         args.put(activator.getArguments().get(i).getParameter(), activator.getArguments().get(i).getValue());
         }
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern ensure fi exists
      try 
      {
         fujaba__Success = false; 

         // check object element is really bound
         if (!( element != null )) {throw new Exception("SDMException");};
         // iterate to-many link fragmentInstances from this to fi
         fujaba__Success = false;
         fujaba__IterThisToFi = this.getFragmentInstances().iterator ();

         while ( !(fujaba__Success) && fujaba__IterThisToFi.hasNext () )
         {
            try
            {
               fi = (FragmentInstance) fujaba__IterThisToFi.next ();

               // check object fi is really bound
               if (!( fi != null )) {throw new Exception("SDMException");};
               // attribute condition
               if (!( org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(fragment.getUFI(), element, roleBinding.getNameExpression(), args).equals(fi.getName ()) )) {throw new Exception("SDMException");};


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         // assign statement
         fi.getUFI ().clear();
         fi.getUFI ().addAll(org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.deriveID(fragment.getUFI(), element, roleBinding.getUfiExpression(), args));
         // assign statement
         fi.setReference (roleBinding instanceof org.reuseware.coconut.reuseextension.FragmentRole2FragmentReferenceBinding);
         // create link
         fi.getDerivedFrom().add(element);

         // collabStat call
         fi.getArguments().putAll(args);
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {

      }
      else
      {
         // story pattern ensure fi exists 2
         try 
         {
            fujaba__Success = false; 

            // check object element is really bound
            if (!( element != null )) {throw new Exception("SDMException");};
            // create object
            fi = CompositionprogramFactory.eINSTANCE.createFragmentInstance();
            // assign statement
            fi.setName (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(fragment.getUFI(), element, roleBinding.getNameExpression(), args));
            // assign statement
            fi.setReference (roleBinding instanceof org.reuseware.coconut.reuseextension.FragmentRole2FragmentReferenceBinding);
            // assign statement
            fi.getUFI ().clear();
            fi.getUFI ().addAll(org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.deriveID(fragment.getUFI(), element, roleBinding.getUfiExpression(), args));
            // create link
            fi.getDerivedFrom().add(element);

            // create link
            fi.setCompositionProgram(this);

            // collabStat call
            fi.getArguments().putAll(args);
            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }


      }
      // story pattern set target ufi
      try 
      {
         fujaba__Success = false; 

         // check object fi is really bound
         if (!( fi != null )) {throw new Exception("SDMException");};
         // constraint roleBinding.getTargetUfiExpression() != null
         if (!( roleBinding.getTargetUfiExpression() != null )) {throw new Exception("SDMException");};
         // assign statement
         fi.getTargetUFI ().clear();
         fi.getTargetUFI ().addAll(org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.deriveID(fragment.getUFI(), element, roleBinding.getTargetUfiExpression(), args));
         // assign statement
         fi.setTarget (true);
         // assign statement
         fi.setTargetPhysicalLocation (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(fragment.getUFI(), element, roleBinding.getTargetPhysicalLocationExpression(), args));
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern derive settings
      try 
      {
         fujaba__Success = false; 

         // check object roleBinding is really bound
         if (!( roleBinding != null )) {throw new Exception("SDMException");};
         // bind object
         role = roleBinding.getFragmentRole ();

         // check object role is really bound
         if (!( role != null )) {throw new Exception("SDMException");};

         // bind object
         cs = role.getFragmentCollaboration ();

         // check object cs is really bound
         if (!( cs != null )) {throw new Exception("SDMException");};

         // iterate to-many link portTypeBindings from roleBinding to portTypeBinding
         fujaba__Success = false;
         fujaba__IterRoleBindingToPortTypeBinding = new ArrayList<PortType2SettingBinding>(roleBinding.getPortTypeBindings()).iterator ();

         while ( fujaba__IterRoleBindingToPortTypeBinding.hasNext () )
         {
            try
            {
               portTypeBinding = (PortType2SettingBinding) fujaba__IterRoleBindingToPortTypeBinding.next ();

               // check object portTypeBinding is really bound
               if (!( portTypeBinding != null )) {throw new Exception("SDMException");};
               // bind object
               portType = portTypeBinding.getPortType ();

               // check object portType is really bound
               if (!( portType != null )) {throw new Exception("SDMException");};

               // iterate to-many link derivationRules from portTypeBinding to settingRule
               fujaba__Success = false;
               fujaba__IterPortTypeBindingToSettingRule = new ArrayList<SettingDerivationRule>(portTypeBinding.getDerivationRules()).iterator ();

               while ( fujaba__IterPortTypeBindingToSettingRule.hasNext () )
               {
                  try
                  {
                     settingRule = (SettingDerivationRule) fujaba__IterPortTypeBindingToSettingRule.next ();

                     // check object settingRule is really bound
                     if (!( settingRule != null )) {throw new Exception("SDMException");};
                     // story pattern ensure pi exisits
                     try 
                     {
                        fujaba__Success = false; 

                        // check object fi is really bound
                        if (!( fi != null )) {throw new Exception("SDMException");};
                        // iterate to-many link portInstances from fi to pi
                        fujaba__Success = false;
                        fujaba__IterFiToPi = fi.getPortInstances().iterator ();

                        while ( !(fujaba__Success) && fujaba__IterFiToPi.hasNext () )
                        {
                           try
                           {
                              pi = (PortInstance) fujaba__IterFiToPi.next ();

                              // check object pi is really bound
                              if (!( pi != null )) {throw new Exception("SDMException");};
                              // attribute condition
                              if (!( cs.getFracolName().equals(pi.getFracolName ()) )) {throw new Exception("SDMException");};

                              // attribute condition
                              if (!( pi.getFracolNamespace ().equals(cs.getFracolNamespace())
                               )) {throw new Exception("SDMException");};

                              // attribute condition
                              if (!( role.getName().equals(pi.getFragmentRoleName ()) )) {throw new Exception("SDMException");};

                              // attribute condition
                              if (!( portType.getName().equals(pi.getPortName ()) )) {throw new Exception("SDMException");};


                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};
                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }

                     if (fujaba__Success)
                     {

                     }
                     else
                     {
                        // story pattern ensure pi exisits 2
                        try 
                        {
                           fujaba__Success = false; 

                           // check object fi is really bound
                           if (!( fi != null )) {throw new Exception("SDMException");};
                           // create object
                           pi = CompositionprogramFactory.eINSTANCE.createPortInstance();
                           // assign statement
                           pi.setPortName (portType.getName());
                           // assign statement
                           pi.setFragmentRoleName (role.getName());
                           // assign statement
                           pi.getFracolNamespace ().clear();
                           pi.getFracolNamespace ().addAll(cs.getFracolNamespace());
                           // assign statement
                           pi.setFracolName (cs.getFracolName());
                           // create link
                           pi.setFragmentInstance(fi);

                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                     }
                     // story pattern derive settings 2
                     try 
                     {
                        fujaba__Success = false; 

                        // check object pi is really bound
                        if (!( pi != null )) {throw new Exception("SDMException");};
                        // iterate to-many link settings from pi to setting
                        fujaba__Success = false;
                        fujaba__IterPiToSetting = pi.getSettings().iterator ();

                        while ( !(fujaba__Success) && fujaba__IterPiToSetting.hasNext () )
                        {
                           try
                           {
                              setting = (Setting) fujaba__IterPiToSetting.next ();

                              // check object setting is really bound
                              if (!( setting != null )) {throw new Exception("SDMException");};
                              // attribute condition
                              if (!( org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(fragment.getUFI(), element, settingRule.getPropertyExpression(), args).equals(setting.getProperty ()) )) {throw new Exception("SDMException");};


                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};
                        // assign statement
                        setting.setValue (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(fragment.getUFI(), element, settingRule.getValueExpression(), args));
                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }

                     if (fujaba__Success)
                     {

                     }
                     else
                     {
                        // story pattern derive settings 3
                        try 
                        {
                           fujaba__Success = false; 

                           // check object pi is really bound
                           if (!( pi != null )) {throw new Exception("SDMException");};
                           // create object
                           setting = CompositionprogramFactory.eINSTANCE.createSetting();
                           // assign statement
                           setting.setValue (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(fragment.getUFI(), element, settingRule.getValueExpression(), args));
                           // assign statement
                           setting.setProperty (org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.derive(fragment.getUFI(), element, settingRule.getPropertyExpression(), args));
                           // create link
                           pi.getSettings().add(setting);

                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                     }

                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};


         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return fi;

   }


   public void extractCompositionProgram (){
      boolean fujaba__Success = false;
      Iterator<CompositionLink> fujaba__IterThisToLink = null;
      CompositionLink link = null;
      Iterator<FragmentInstance> fujaba__IterThisToFi = null;
      FragmentInstance fi = null;
      java.util.Map<String,String> args = null;
      EClass eClass = null;
      Iterator<FragmentRole2FragmentInstanceBinding> fujaba__IterRexToRoleBinding = null;
      FragmentRole2FragmentInstanceBinding roleBinding = null;
      Iterator<?> fujaba__IterThisToTarget = null;
      Object _TmpObject = null;
      EObject target = null;
      Iterator<?> fujaba__IterThisToSource = null;
      EObject source = null;
      Iterator<CompositionAssociation2CompositionLinkBinding> fujaba__IterRexToAssocBinding = null;
      CompositionAssociation2CompositionLinkBinding assocBinding = null;
      Iterator<?> fujaba__IterThisToElement = null;
      EObject element = null;
      CompositionLanguageSpecification rex = null;
      Iterator<ReuseExtensionActivator> fujaba__IterFragmentToActivator = null;
      ReuseExtensionActivator activator = null;
      Iterator<Fragment> fujaba__IterThisToFragment = null;
      Fragment fragment = null;

      // story pattern remove all old links
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link compositionLinks from this to link
         fujaba__Success = false;
         fujaba__IterThisToLink = new ArrayList<CompositionLink>(this.getCompositionLinks()).iterator ();

         while ( fujaba__IterThisToLink.hasNext () )
         {
            try
            {
               link = (CompositionLink) fujaba__IterThisToLink.next ();

               // check object link is really bound
               if (!( link != null )) {throw new Exception("SDMException");};
               // destroy link
               link.setCompositionProgram (null);

               // delete object
               link.removeYou ();


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern remove all old instances
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link fragmentInstances from this to fi
         fujaba__Success = false;
         fujaba__IterThisToFi = new ArrayList<FragmentInstance>(this.getFragmentInstances()).iterator ();

         while ( fujaba__IterThisToFi.hasNext () )
         {
            try
            {
               fi = (FragmentInstance) fujaba__IterThisToFi.next ();

               // check object fi is really bound
               if (!( fi != null )) {throw new Exception("SDMException");};
               // destroy link
               fi.setCompositionProgram (null);

               // delete object
               fi.removeYou ();


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern Find all rex of intrest
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link deriveFrom from this to fragment
         fujaba__Success = false;
         fujaba__IterThisToFragment = new ArrayList<Fragment>(this.getDeriveFrom()).iterator ();

         while ( fujaba__IterThisToFragment.hasNext () )
         {
            try
            {
               fragment = (Fragment) fujaba__IterThisToFragment.next ();

               // check object fragment is really bound
               if (!( fragment != null )) {throw new Exception("SDMException");};
               // iterate to-many link compositionLanguageActivators from fragment to activator
               fujaba__Success = false;
               fujaba__IterFragmentToActivator = new ArrayList<ReuseExtensionActivator>(fragment.getCompositionLanguageActivators()).iterator ();

               while ( fujaba__IterFragmentToActivator.hasNext () )
               {
                  try
                  {
                     activator = (ReuseExtensionActivator) fujaba__IterFragmentToActivator.next ();

                     // check object activator is really bound
                     if (!( activator != null )) {throw new Exception("SDMException");};
                     // bind object
                     _TmpObject = activator.getReuseExtension ();

                     // ensure correct type and really bound of object rex
                     if (!( _TmpObject instanceof CompositionLanguageSpecification )) {throw new Exception("SDMException");};
                     rex = (CompositionLanguageSpecification) _TmpObject;


                     // collabStat call
                     args = new java.util.LinkedHashMap <String, String>();
                     // collabStat call
                     for ( int i = 0;i <= activator.getArguments().size()-1;++i )
                     {
                     args.put(activator.getArguments().get(i).getParameter(), activator.getArguments().get(i).getValue());
                     }
                     // story pattern iterate model tree
                     try 
                     {
                        fujaba__Success = false; 

                        // iterate to-many link $link.InstanceOf.Name from this to element
                        fujaba__Success = false;
                        _TmpObject = org.eclipse.emf.ecore.util.EcoreUtil.getAllContents(fragment.getContents());
                        if (_TmpObject instanceof Iterator<?>) {
                            fujaba__IterThisToElement = (Iterator<?>)_TmpObject;    
                        }
                        else if (_TmpObject instanceof Iterable<?>) {
                            fujaba__IterThisToElement = ((Iterable<?>)_TmpObject).iterator();
                        }
                        else {
                            fujaba__IterThisToElement = Collections.singletonList(_TmpObject).iterator();
                        }
                        while ( fujaba__IterThisToElement.hasNext () )
                        {
                           try
                           {
                              _TmpObject =  fujaba__IterThisToElement.next ();

                              // ensure correct type and really bound of object element
                              if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                              element = (EObject) _TmpObject;

                              // story pattern visit role bindings
                              try 
                              {
                                 fujaba__Success = false; 

                                 // check object rex is really bound
                                 if (!( rex != null )) {throw new Exception("SDMException");};
                                 // iterate to-many link fragmentRoleBindings from rex to roleBinding
                                 fujaba__Success = false;
                                 fujaba__IterRexToRoleBinding = new ArrayList<FragmentRole2FragmentInstanceBinding>(rex.getFragmentRoleBindings()).iterator ();

                                 while ( fujaba__IterRexToRoleBinding.hasNext () )
                                 {
                                    try
                                    {
                                       roleBinding = (FragmentRole2FragmentInstanceBinding) fujaba__IterRexToRoleBinding.next ();

                                       // check object roleBinding is really bound
                                       if (!( roleBinding != null )) {throw new Exception("SDMException");};
                                       // bind object
                                       eClass = roleBinding.getEBoundClass ();

                                       // check object eClass is really bound
                                       if (!( eClass != null )) {throw new Exception("SDMException");};

                                       if (eClass.isInstance(element) && org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.eval(fragment.getUFI(), element, roleBinding.getIsExpression(), args))
                                       {
                                          // story pattern successor
                                          try 
                                          {
                                             fujaba__Success = false; 

                                             fi = createFragmentInstance(fragment, element, roleBinding, activator);

                                             // check object fi is really bound
                                             if (!( fi != null )) {throw new Exception("SDMException");};
                                             fujaba__Success = true;
                                          }
                                          catch ( Exception fujaba__InternalException )
                                          {
                                             fujaba__Success = false;
                                          }


                                       }
                                       else
                                       {

                                       }


                                       fujaba__Success = true;
                                    }
                                    catch ( Exception fujaba__InternalException )
                                    {
                                       fujaba__Success = false;
                                    }
                                 }
                                 if (!(fujaba__Success)) {throw new Exception("SDMException");};
                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }


                              // story pattern visit assoc bindings
                              try 
                              {
                                 fujaba__Success = false; 

                                 // check object rex is really bound
                                 if (!( rex != null )) {throw new Exception("SDMException");};
                                 // iterate to-many link compositionAssociationBindings from rex to assocBinding
                                 fujaba__Success = false;
                                 fujaba__IterRexToAssocBinding = new ArrayList<CompositionAssociation2CompositionLinkBinding>(rex.getCompositionAssociationBindings()).iterator ();

                                 while ( fujaba__IterRexToAssocBinding.hasNext () )
                                 {
                                    try
                                    {
                                       assocBinding = (CompositionAssociation2CompositionLinkBinding) fujaba__IterRexToAssocBinding.next ();

                                       // check object assocBinding is really bound
                                       if (!( assocBinding != null )) {throw new Exception("SDMException");};
                                       // bind object
                                       eClass = assocBinding.getEBoundClass ();

                                       // check object eClass is really bound
                                       if (!( eClass != null )) {throw new Exception("SDMException");};

                                       if (eClass.isInstance(element) && org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.eval(fragment.getUFI(), element, assocBinding.getIsExpression(), args))
                                       {
                                          // story pattern forEach1
                                          try 
                                          {
                                             fujaba__Success = false; 

                                             // iterate to-many link $link.InstanceOf.Name from this to source
                                             fujaba__Success = false;
                                             _TmpObject = org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.deriveElementList(fragment.getUFI(), element, assocBinding.getForEach1Expression(), args);
                                             if (_TmpObject instanceof Iterator<?>) {
                                                 fujaba__IterThisToSource = (Iterator<?>)_TmpObject;    
                                             }
                                             else if (_TmpObject instanceof Iterable<?>) {
                                                 fujaba__IterThisToSource = ((Iterable<?>)_TmpObject).iterator();
                                             }
                                             else {
                                                 fujaba__IterThisToSource = Collections.singletonList(_TmpObject).iterator();
                                             }
                                             while ( fujaba__IterThisToSource.hasNext () )
                                             {
                                                try
                                                {
                                                   _TmpObject =  fujaba__IterThisToSource.next ();

                                                   // ensure correct type and really bound of object source
                                                   if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                                                   source = (EObject) _TmpObject;

                                                   // story pattern forEach2
                                                   try 
                                                   {
                                                      fujaba__Success = false; 

                                                      // iterate to-many link $link.InstanceOf.Name from this to target
                                                      fujaba__Success = false;
                                                      _TmpObject = org.reuseware.coconut.reuseextension.evaluator.EvaluatorUtil.deriveElementList(fragment.getUFI(), element, assocBinding.getForEach2Expression(), args);
                                                      if (_TmpObject instanceof Iterator<?>) {
                                                          fujaba__IterThisToTarget = (Iterator<?>)_TmpObject;    
                                                      }
                                                      else if (_TmpObject instanceof Iterable<?>) {
                                                          fujaba__IterThisToTarget = ((Iterable<?>)_TmpObject).iterator();
                                                      }
                                                      else {
                                                          fujaba__IterThisToTarget = Collections.singletonList(_TmpObject).iterator();
                                                      }
                                                      while ( fujaba__IterThisToTarget.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            _TmpObject =  fujaba__IterThisToTarget.next ();

                                                            // ensure correct type and really bound of object target
                                                            if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                                                            target = (EObject) _TmpObject;

                                                            // story pattern create link
                                                            try 
                                                            {
                                                               fujaba__Success = false; 

                                                               link = createCompositionLink(fragment, source, target, assocBinding, activator);

                                                               // check object link is really bound
                                                               if (!( link != null )) {throw new Exception("SDMException");};
                                                               fujaba__Success = true;
                                                            }
                                                            catch ( Exception fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false;
                                                            }


                                                            fujaba__Success = true;
                                                         }
                                                         catch ( Exception fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false;
                                                         }
                                                      }
                                                      if (!(fujaba__Success)) {throw new Exception("SDMException");};
                                                      fujaba__Success = true;
                                                   }
                                                   catch ( Exception fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false;
                                                   }


                                                   fujaba__Success = true;
                                                }
                                                catch ( Exception fujaba__InternalException )
                                                {
                                                   fujaba__Success = false;
                                                }
                                             }
                                             if (!(fujaba__Success)) {throw new Exception("SDMException");};
                                             fujaba__Success = true;
                                          }
                                          catch ( Exception fujaba__InternalException )
                                          {
                                             fujaba__Success = false;
                                          }


                                       }
                                       else
                                       {

                                       }


                                       fujaba__Success = true;
                                    }
                                    catch ( Exception fujaba__InternalException )
                                    {
                                       fujaba__Success = false;
                                    }
                                 }
                                 if (!(fujaba__Success)) {throw new Exception("SDMException");};
                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }


                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};
                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }



                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;

   }


   public void removeYou()
   {
      this.getDeriveFrom().clear();
super.removeYou ();   }
}


