/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.compositionprogram.impl;


import org.reuseware.coconut.fragment.FragmentFactory;
import java.util.*;
import org.reuseware.coconut.fragment.AddressablePoint;
import java.util.ArrayList;
import org.reuseware.coconut.fragment.ValuePrototype;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.reuseware.coconut.fragment.ValueHook;
import org.reuseware.coconut.fragment.HeterogeneousPort;
import org.reuseware.coconut.compositionprogram.PortInstance;
import org.reuseware.coconut.fragment.ComposedFragment;


/**
 * @generated
 **/
public class SettingImpl
{


   public void execute (ComposedFragment composedTarget ){
      boolean fujaba__Success = false;
      ValuePrototype valuePrototype = null;
      Iterator<?> fujaba__IterValueHookNodeToValueHookNodeCopy = null;
      Object _TmpObject = null;
      EObject valueHookNodeCopy = null;
      EObject valueHookNode = null;
      EStructuralFeature feature = null;
      Iterator<AddressablePoint> fujaba__IterPortToValueHook = null;
      ValueHook valueHook = null;
      Iterator<?> fujaba__IterPortInstanceToPort = null;
      HeterogeneousPort port = null;
      PortInstance portInstance = null;

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // bind object
         portInstance = this.getPortInstance ();

         // check object portInstance is really bound
         if (!( portInstance != null )) {throw new Exception("SDMException");};

         // attribute condition
         if (!( !"".equals(this.getValue ()) )) {throw new Exception("SDMException");};

         // attribute condition
         if (!( null != this.getValue () )) {throw new Exception("SDMException");};

         // iterate to-many link $link.InstanceOf.Name from portInstance to port
         fujaba__Success = false;
         _TmpObject = portInstance.allPorts();
         if (_TmpObject instanceof Iterator<?>) {
             fujaba__IterPortInstanceToPort = (Iterator<?>)_TmpObject;    
         }
         else if (_TmpObject instanceof Iterable<?>) {
             fujaba__IterPortInstanceToPort = ((Iterable<?>)_TmpObject).iterator();
         }
         else {
             fujaba__IterPortInstanceToPort = Collections.singletonList(_TmpObject).iterator();
         }
         while ( fujaba__IterPortInstanceToPort.hasNext () )
         {
            try
            {
               _TmpObject =  fujaba__IterPortInstanceToPort.next ();

               // ensure correct type and really bound of object port
               if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
               port = (HeterogeneousPort) _TmpObject;

               // iterate to-many link addressablePoints from port to valueHook
               fujaba__Success = false;
               fujaba__IterPortToValueHook = new ArrayList<AddressablePoint>(port.getAddressablePoints()).iterator ();

               while ( fujaba__IterPortToValueHook.hasNext () )
               {
                  try
                  {
                     _TmpObject =  fujaba__IterPortToValueHook.next ();

                     // ensure correct type and really bound of object valueHook
                     if (!( _TmpObject instanceof ValueHook )) {throw new Exception("SDMException");};
                     valueHook = (ValueHook) _TmpObject;

                     // bind object
                     feature = valueHook.getVarTypedEStructuralFeature ();

                     // check object feature is really bound
                     if (!( feature != null )) {throw new Exception("SDMException");};

                     // bind object
                     valueHookNode = valueHook.getVarTypedEObject ();

                     // check object valueHookNode is really bound
                     if (!( valueHookNode != null )) {throw new Exception("SDMException");};


                     // check isomorphic binding between objects valueHookNode and feature
                     if (!( !valueHookNode.equals (feature) )) {throw new Exception("SDMException");};

                     // attribute condition
                     if (!( this.property.equals(valueHook.getName ()) )) {throw new Exception("SDMException");};

                     // iterate to-many link $link.InstanceOf.Name from valueHookNode to valueHookNodeCopy
                     fujaba__Success = false;
                     _TmpObject = org.reuseware.coconut.fragment.util.SyncEcoreUtil.getCopy(valueHookNode, composedTarget, composedTarget.getContents());
                     if (_TmpObject instanceof Iterator<?>) {
                         fujaba__IterValueHookNodeToValueHookNodeCopy = (Iterator<?>)_TmpObject;    
                     }
                     else if (_TmpObject instanceof Iterable<?>) {
                         fujaba__IterValueHookNodeToValueHookNodeCopy = ((Iterable<?>)_TmpObject).iterator();
                     }
                     else {
                         fujaba__IterValueHookNodeToValueHookNodeCopy = Collections.singletonList(_TmpObject).iterator();
                     }
                     while ( fujaba__IterValueHookNodeToValueHookNodeCopy.hasNext () )
                     {
                        try
                        {
                           _TmpObject =  fujaba__IterValueHookNodeToValueHookNodeCopy.next ();

                           // ensure correct type and really bound of object valueHookNodeCopy
                           if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                           valueHookNodeCopy = (EObject) _TmpObject;


                           // check isomorphic binding between objects valueHookNodeCopy and feature
                           if (!( !valueHookNodeCopy.equals (feature) )) {throw new Exception("SDMException");};


                           // disabled isomorphic binding check between EObjects valueHookNodeCopy and valueHookNode"

                           // create object
                           valuePrototype = FragmentFactory.eINSTANCE.createValuePrototype();
                           // assign statement
                           valuePrototype.setValue (this.getValue());
                           // collabStat call
                           valueHook.basicCompose(valueHookNodeCopy, feature, valuePrototype, null);

                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }
                     }
                     if (!(fujaba__Success)) {throw new Exception("SDMException");};



                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};

         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;

   }


   public void removeYou()
   {
      this.setPortInstance (null);
   }
}


