/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fragment.impl;


import java.util.*;
import org.reuseware.coconut.fragment.APMatch;
import java.util.ArrayList;
import org.eclipse.emf.ecore.EObject;
import org.reuseware.coconut.fragment.VariationPoint;
import org.reuseware.coconut.fragment.ReferencePoint;
import org.reuseware.coconut.fragment.Fragment;
import org.reuseware.coconut.fragment.ComposedFragment;


/**
 * @generated
 **/
public class APMatchGroupImpl
{


   public void execute (Fragment composedSource , Fragment composedTarget , ComposedFragment result , EList<EObject> additionalContext ){
      boolean fujaba__Success = false;
      EList<EObject> context = null;
      Iterator<?> fujaba__IterReferenceNodeToReferenceNodeCopy = null;
      Object _TmpObject = null;
      EObject referenceNodeCopy = null;
      Iterator<?> fujaba__IterVariationNodeToVariationNodeCopy = null;
      EObject variationNodeCopy = null;
      EObject variationNode = null;
      VariationPoint vp = null;
      EObject referenceNode = null;
      ReferencePoint rp = null;
      Iterator<APMatch> fujaba__IterThisToMatch = null;
      APMatch match = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // collabStat call
         context = new org.eclipse.emf.common.util.BasicEList<EObject>();
         // collabStat call
         context.addAll(composedSource.getContents());
         // collabStat call
         context.addAll(composedTarget.getContents());
         // collabStat call
         context.addAll(result.getContents());
         // collabStat call
         context.addAll(additionalContext);
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 2
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link singleMatches from this to match
         fujaba__Success = false;
         fujaba__IterThisToMatch = new ArrayList<APMatch>(this.getSingleMatches()).iterator ();

         while ( fujaba__IterThisToMatch.hasNext () )
         {
            try
            {
               match = (APMatch) fujaba__IterThisToMatch.next ();

               // check object match is really bound
               if (!( match != null )) {throw new Exception("SDMException");};
               // bind object
               rp = match.getSource ();

               // check object rp is really bound
               if (!( rp != null )) {throw new Exception("SDMException");};

               // bind object
               referenceNode = rp.getVarTypedEObject ();

               // check object referenceNode is really bound
               if (!( referenceNode != null )) {throw new Exception("SDMException");};

               // bind object
               vp = match.getTarget ();

               // check object vp is really bound
               if (!( vp != null )) {throw new Exception("SDMException");};

               // bind object
               variationNode = vp.getVarTypedEObject ();

               // check object variationNode is really bound
               if (!( variationNode != null )) {throw new Exception("SDMException");};


               // disabled isomorphic binding check between EObjects variationNode and referenceNode"

               // attribute condition
               if (!( match.isInverse () == false )) {throw new Exception("SDMException");};

               // iterate to-many link $link.InstanceOf.Name from variationNode to variationNodeCopy
               fujaba__Success = false;
               _TmpObject = org.reuseware.coconut.fragment.util.SyncEcoreUtil.getCopy(variationNode, composedTarget, context);
               if (_TmpObject instanceof Iterator<?>) {
                   fujaba__IterVariationNodeToVariationNodeCopy = (Iterator<?>)_TmpObject;    
               }
               else if (_TmpObject instanceof Iterable<?>) {
                   fujaba__IterVariationNodeToVariationNodeCopy = ((Iterable<?>)_TmpObject).iterator();
               }
               else {
                   fujaba__IterVariationNodeToVariationNodeCopy = Collections.singletonList(_TmpObject).iterator();
               }
               while ( fujaba__IterVariationNodeToVariationNodeCopy.hasNext () )
               {
                  try
                  {
                     _TmpObject =  fujaba__IterVariationNodeToVariationNodeCopy.next ();

                     // ensure correct type and really bound of object variationNodeCopy
                     if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                     variationNodeCopy = (EObject) _TmpObject;


                     // disabled isomorphic binding check between EObjects variationNodeCopy and referenceNode"


                     // disabled isomorphic binding check between EObjects variationNodeCopy and variationNode"

                     {
                        // story pattern 2.1
                        try 
                        {
                           fujaba__Success = false; 

                           // check object referenceNode is really bound
                           if (!( referenceNode != null )) {throw new Exception("SDMException");};
                           // iterate to-many link $link.InstanceOf.Name from referenceNode to referenceNodeCopy
                           fujaba__Success = false;
                           _TmpObject = org.reuseware.coconut.fragment.util.SyncEcoreUtil.getCopy(referenceNode, composedSource, context);
                           if (_TmpObject instanceof Iterator<?>) {
                               fujaba__IterReferenceNodeToReferenceNodeCopy = (Iterator<?>)_TmpObject;    
                           }
                           else if (_TmpObject instanceof Iterable<?>) {
                               fujaba__IterReferenceNodeToReferenceNodeCopy = ((Iterable<?>)_TmpObject).iterator();
                           }
                           else {
                               fujaba__IterReferenceNodeToReferenceNodeCopy = Collections.singletonList(_TmpObject).iterator();
                           }
                           while ( !(fujaba__Success) && fujaba__IterReferenceNodeToReferenceNodeCopy.hasNext () )
                           {
                              try
                              {
                                 _TmpObject =  fujaba__IterReferenceNodeToReferenceNodeCopy.next ();

                                 // ensure correct type and really bound of object referenceNodeCopy
                                 if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                                 referenceNodeCopy = (EObject) _TmpObject;


                                 // disabled isomorphic binding check between EObjects referenceNodeCopy and referenceNode"


                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};
                           // collabStat call
                           vp.compose(rp, variationNodeCopy, referenceNodeCopy, result, context);
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                       if (fujaba__Success)
                        {
                           continue;
                        }
                        // story pattern 2.2
                        try 
                        {
                           fujaba__Success = false; 

                           // collabStat call
                           vp.compose(rp, variationNodeCopy, referenceNode, result, context);
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                     }

                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};





               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 3
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link singleMatches from this to match
         fujaba__Success = false;
         fujaba__IterThisToMatch = new ArrayList<APMatch>(this.getSingleMatches()).iterator ();

         while ( fujaba__IterThisToMatch.hasNext () )
         {
            try
            {
               match = (APMatch) fujaba__IterThisToMatch.next ();

               // check object match is really bound
               if (!( match != null )) {throw new Exception("SDMException");};
               // bind object
               vp = match.getTarget ();

               // check object vp is really bound
               if (!( vp != null )) {throw new Exception("SDMException");};

               // bind object
               variationNode = vp.getVarTypedEObject ();

               // check object variationNode is really bound
               if (!( variationNode != null )) {throw new Exception("SDMException");};

               // bind object
               rp = match.getSource ();

               // check object rp is really bound
               if (!( rp != null )) {throw new Exception("SDMException");};

               // bind object
               referenceNode = rp.getVarTypedEObject ();

               // check object referenceNode is really bound
               if (!( referenceNode != null )) {throw new Exception("SDMException");};


               // disabled isomorphic binding check between EObjects variationNode and referenceNode"

               // attribute condition
               if (!( match.isInverse () == true )) {throw new Exception("SDMException");};

               // iterate to-many link $link.InstanceOf.Name from variationNode to variationNodeCopy
               fujaba__Success = false;
               _TmpObject = org.reuseware.coconut.fragment.util.SyncEcoreUtil.getCopy(variationNode, composedSource, context);
               if (_TmpObject instanceof Iterator<?>) {
                   fujaba__IterVariationNodeToVariationNodeCopy = (Iterator<?>)_TmpObject;    
               }
               else if (_TmpObject instanceof Iterable<?>) {
                   fujaba__IterVariationNodeToVariationNodeCopy = ((Iterable<?>)_TmpObject).iterator();
               }
               else {
                   fujaba__IterVariationNodeToVariationNodeCopy = Collections.singletonList(_TmpObject).iterator();
               }
               while ( fujaba__IterVariationNodeToVariationNodeCopy.hasNext () )
               {
                  try
                  {
                     _TmpObject =  fujaba__IterVariationNodeToVariationNodeCopy.next ();

                     // ensure correct type and really bound of object variationNodeCopy
                     if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                     variationNodeCopy = (EObject) _TmpObject;


                     // disabled isomorphic binding check between EObjects variationNodeCopy and referenceNode"


                     // disabled isomorphic binding check between EObjects variationNodeCopy and variationNode"

                     {
                        // story pattern 3.1
                        try 
                        {
                           fujaba__Success = false; 

                           // check object referenceNode is really bound
                           if (!( referenceNode != null )) {throw new Exception("SDMException");};
                           // iterate to-many link $link.InstanceOf.Name from referenceNode to referenceNodeCopy
                           fujaba__Success = false;
                           _TmpObject = org.reuseware.coconut.fragment.util.SyncEcoreUtil.getCopy(referenceNode, composedTarget, context);
                           if (_TmpObject instanceof Iterator<?>) {
                               fujaba__IterReferenceNodeToReferenceNodeCopy = (Iterator<?>)_TmpObject;    
                           }
                           else if (_TmpObject instanceof Iterable<?>) {
                               fujaba__IterReferenceNodeToReferenceNodeCopy = ((Iterable<?>)_TmpObject).iterator();
                           }
                           else {
                               fujaba__IterReferenceNodeToReferenceNodeCopy = Collections.singletonList(_TmpObject).iterator();
                           }
                           while ( !(fujaba__Success) && fujaba__IterReferenceNodeToReferenceNodeCopy.hasNext () )
                           {
                              try
                              {
                                 _TmpObject =  fujaba__IterReferenceNodeToReferenceNodeCopy.next ();

                                 // ensure correct type and really bound of object referenceNodeCopy
                                 if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                                 referenceNodeCopy = (EObject) _TmpObject;


                                 // disabled isomorphic binding check between EObjects referenceNodeCopy and referenceNode"


                                 fujaba__Success = true;
                              }
                              catch ( Exception fujaba__InternalException )
                              {
                                 fujaba__Success = false;
                              }
                           }
                           if (!(fujaba__Success)) {throw new Exception("SDMException");};
                           // collabStat call
                           vp.compose(rp, variationNodeCopy, referenceNodeCopy, result, context);
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                       if (fujaba__Success)
                        {
                           continue;
                        }
                        // story pattern 3.2
                        try 
                        {
                           fujaba__Success = false; 

                           // collabStat call
                           vp.compose(rp, variationNodeCopy, referenceNode, result, context);
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                     }

                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};





               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;

   }


   public void removeYou()
   {
      this.getSingleMatches().clear();
   }
}


