/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fragment.impl;


import java.util.*;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature.Setting;
import org.reuseware.coconut.fragment.VariationPoint;


/**
 * @generated
 **/
public class ComposedFragmentImpl extends Fragment
{


   public void removeVariationPoints (){
      boolean fujaba__Success = false;
      org.eclipse.emf.common.util.EList<EObject> context = null;
      EStructuralFeature varTypedFeature = null;
      Iterator<?> fujaba__IterVariationNodeToFeature = null;
      Object _TmpObject = null;
      EReference feature = null;
      Iterator<?> fujaba__IterVariationNodeToContainer = null;
      EObject container = null;
      Iterator<?> fujaba__IterVariationNodeToSetting = null;
      Setting setting = null;
      EObject variationNode = null;
      Iterator<?> fujaba__IterThisToVariationPoint = null;
      VariationPoint variationPoint = null;

      // story pattern 
      try 
      {
         fujaba__Success = false; 

         // collabStat call
         context = new org.eclipse.emf.common.util.BasicEList<EObject>();
         // collabStat call
         context.addAll(this.getContents());
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link $link.InstanceOf.Name from this to variationPoint
         fujaba__Success = false;
         _TmpObject = this.getAllAddressablePoints();
         if (_TmpObject instanceof Iterator<?>) {
             fujaba__IterThisToVariationPoint = (Iterator<?>)_TmpObject;    
         }
         else if (_TmpObject instanceof Iterable<?>) {
             fujaba__IterThisToVariationPoint = ((Iterable<?>)_TmpObject).iterator();
         }
         else {
             fujaba__IterThisToVariationPoint = Collections.singletonList(_TmpObject).iterator();
         }
         while ( fujaba__IterThisToVariationPoint.hasNext () )
         {
            try
            {
               _TmpObject =  fujaba__IterThisToVariationPoint.next ();

               // ensure correct type and really bound of object variationPoint
               if (!( _TmpObject instanceof VariationPoint )) {throw new Exception("SDMException");};
               variationPoint = (VariationPoint) _TmpObject;

               // bind object
               variationNode = variationPoint.getVarTypedEObject ();

               // check object variationNode is really bound
               if (!( variationNode != null )) {throw new Exception("SDMException");};

               // check negative bindings
               try
               {
                  fujaba__Success = false;

                  // bind object
                  varTypedFeature = variationPoint.getVarTypedEStructuralFeature ();

                  // check object varTypedFeature is really bound
                  if (!( varTypedFeature != null )) {throw new Exception("SDMException");};


                  // check isomorphic binding between objects varTypedFeature and variationNode
                  if (!( !varTypedFeature.equals (variationNode) )) {throw new Exception("SDMException");};



                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               fujaba__Success = !(fujaba__Success);

               if (!( fujaba__Success )) {throw new Exception("SDMException");};
               // attribute condition
               if (!( variationPoint.isRemove () == true )) {throw new Exception("SDMException");};

               // story pattern 2
               try 
               {
                  fujaba__Success = false; 

                  // check object variationNode is really bound
                  if (!( variationNode != null )) {throw new Exception("SDMException");};
                  // iterate to-many link $link.InstanceOf.Name from variationNode to container
                  fujaba__Success = false;
                  _TmpObject = ((InternalEObject) variationNode).eContainer();
                  if (_TmpObject instanceof Iterator<?>) {
                      fujaba__IterVariationNodeToContainer = (Iterator<?>)_TmpObject;    
                  }
                  else if (_TmpObject instanceof Iterable<?>) {
                      fujaba__IterVariationNodeToContainer = ((Iterable<?>)_TmpObject).iterator();
                  }
                  else {
                      fujaba__IterVariationNodeToContainer = Collections.singletonList(_TmpObject).iterator();
                  }
                  while ( !(fujaba__Success) && fujaba__IterVariationNodeToContainer.hasNext () )
                  {
                     try
                     {
                        _TmpObject =  fujaba__IterVariationNodeToContainer.next ();

                        // ensure correct type and really bound of object container
                        if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                        container = (EObject) _TmpObject;


                        // disabled isomorphic binding check between EObjects variationNode and container"

                        // iterate to-many link $link.InstanceOf.Name from variationNode to feature
                        fujaba__Success = false;
                        _TmpObject = ((InternalEObject) variationNode).eContainingFeature();
                        if (_TmpObject instanceof Iterator<?>) {
                            fujaba__IterVariationNodeToFeature = (Iterator<?>)_TmpObject;    
                        }
                        else if (_TmpObject instanceof Iterable<?>) {
                            fujaba__IterVariationNodeToFeature = ((Iterable<?>)_TmpObject).iterator();
                        }
                        else {
                            fujaba__IterVariationNodeToFeature = Collections.singletonList(_TmpObject).iterator();
                        }
                        while ( !(fujaba__Success) && fujaba__IterVariationNodeToFeature.hasNext () )
                        {
                           try
                           {
                              _TmpObject =  fujaba__IterVariationNodeToFeature.next ();

                              // ensure correct type and really bound of object feature
                              if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
                              feature = (EReference) _TmpObject;


                              // check isomorphic binding between objects feature and container
                              if (!( !feature.equals (container) )) {throw new Exception("SDMException");};


                              // check isomorphic binding between objects variationNode and feature
                              if (!( !variationNode.equals (feature) )) {throw new Exception("SDMException");};


                              fujaba__Success = true;
                           }
                           catch ( Exception fujaba__InternalException )
                           {
                              fujaba__Success = false;
                           }
                        }
                        if (!(fujaba__Success)) {throw new Exception("SDMException");};

                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};
                  // collabStat call
                  variationPoint.remove(container, feature, variationNode);
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }

               // story pattern 4
               try 
               {
                  fujaba__Success = false; 

                  // check object variationNode is really bound
                  if (!( variationNode != null )) {throw new Exception("SDMException");};
                  // iterate to-many link $link.InstanceOf.Name from variationNode to setting
                  fujaba__Success = false;
                  _TmpObject = org.eclipse.emf.ecore.util.EcoreUtil.CrossReferencer.find(context).get(variationNode);
                  if (_TmpObject instanceof Iterator<?>) {
                      fujaba__IterVariationNodeToSetting = (Iterator<?>)_TmpObject;    
                  }
                  else if (_TmpObject instanceof Iterable<?>) {
                      fujaba__IterVariationNodeToSetting = ((Iterable<?>)_TmpObject).iterator();
                  }
                  else {
                      fujaba__IterVariationNodeToSetting = Collections.singletonList(_TmpObject).iterator();
                  }
                  while ( fujaba__IterVariationNodeToSetting.hasNext () )
                  {
                     try
                     {
                        _TmpObject =  fujaba__IterVariationNodeToSetting.next ();

                        // ensure correct type and really bound of object setting
                        if (!( _TmpObject instanceof Setting )) {throw new Exception("SDMException");};
                        setting = (Setting) _TmpObject;

                        // story pattern 5
                        try 
                        {
                           fujaba__Success = false; 

                           // check object setting is really bound
                           if (!( setting != null )) {throw new Exception("SDMException");};
                           // bind object
                           container = setting.getEObject ();

                           // check object container is really bound
                           if (!( container != null )) {throw new Exception("SDMException");};

                           // bind object
                           _TmpObject = setting.getEStructuralFeature ();

                           // ensure correct type and really bound of object feature
                           if (!( _TmpObject instanceof EReference )) {throw new Exception("SDMException");};
                           feature = (EReference) _TmpObject;



                           // check isomorphic binding between objects feature and container
                           if (!( !feature.equals (container) )) {throw new Exception("SDMException");};



                           // collabStat call
                           variationPoint.remove(container, feature, variationNode);
                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }


                        fujaba__Success = true;
                     }
                     catch ( Exception fujaba__InternalException )
                     {
                        fujaba__Success = false;
                     }
                  }
                  if (!(fujaba__Success)) {throw new Exception("SDMException");};
                  fujaba__Success = true;
               }
               catch ( Exception fujaba__InternalException )
               {
                  fujaba__Success = false;
               }



               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;

   }


}


