/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.compositionprogram;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

import org.reuseware.coconut.fracol.CompositionAssociation;

import org.reuseware.coconut.fragment.APMatchGroup;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Composition Link</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.compositionprogram.CompositionLink#getCompositionProgram <em>Composition Program</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.CompositionLink#isContributes <em>Contributes</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.CompositionLink#getDerivedFrom <em>Derived From</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.CompositionLink#isEmpty <em>Empty</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.CompositionLink#getMatches <em>Matches</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.CompositionLink#getSource <em>Source</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.CompositionLink#getTarget <em>Target</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.CompositionLink#isValid <em>Valid</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionLink()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='Valid Typed PortsExist'"
 * @generated
 */
public interface CompositionLink extends EObject
{
  /**
   * Returns the value of the '<em><b>Composition Program</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.compositionprogram.CompositionProgram#getCompositionLinks <em>Composition Links</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Program</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Program</em>' container reference.
   * @see #setCompositionProgram(CompositionProgram)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionLink_CompositionProgram()
   * @see org.reuseware.coconut.compositionprogram.CompositionProgram#getCompositionLinks
   * @model opposite="compositionLinks" transient="false" ordered="false"
   * @generated
   */
  CompositionProgram getCompositionProgram();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.CompositionLink#getCompositionProgram <em>Composition Program</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Composition Program</em>' container reference.
   * @see #getCompositionProgram()
   * @generated
   */
  void setCompositionProgram(CompositionProgram value);

  /**
   * Returns the value of the '<em><b>Contributes</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Contributes</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Contributes</em>' attribute.
   * @see #setContributes(boolean)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionLink_Contributes()
   * @model required="true" transient="true"
   * @generated
   */
  boolean isContributes();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.CompositionLink#isContributes <em>Contributes</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Contributes</em>' attribute.
   * @see #isContributes()
   * @generated
   */
  void setContributes(boolean value);

  /**
   * Returns the value of the '<em><b>Derived From</b></em>' reference list.
   * The list contents are of type {@link org.eclipse.emf.ecore.EObject}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Derived From</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Derived From</em>' reference list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionLink_DerivedFrom()
   * @model ordered="false"
   * @generated
   */
  EList<EObject> getDerivedFrom();

  /**
   * Returns the value of the '<em><b>Empty</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Empty</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Empty</em>' attribute.
   * @see #setEmpty(boolean)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionLink_Empty()
   * @model required="true"
   * @generated
   */
  boolean isEmpty();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.CompositionLink#isEmpty <em>Empty</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Empty</em>' attribute.
   * @see #isEmpty()
   * @generated
   */
  void setEmpty(boolean value);

  /**
   * Returns the value of the '<em><b>Matches</b></em>' reference list.
   * The list contents are of type {@link org.reuseware.coconut.fragment.APMatchGroup}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Matches</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Matches</em>' reference list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionLink_Matches()
   * @model transient="true" ordered="false"
   * @generated
   */
  EList<APMatchGroup> getMatches();

  /**
   * Returns the value of the '<em><b>Source</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.compositionprogram.PortInstance#getSourceLinks <em>Source Links</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Source</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Source</em>' reference.
   * @see #setSource(PortInstance)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionLink_Source()
   * @see org.reuseware.coconut.compositionprogram.PortInstance#getSourceLinks
   * @model opposite="sourceLinks" required="true" ordered="false"
   * @generated
   */
  PortInstance getSource();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.CompositionLink#getSource <em>Source</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Source</em>' reference.
   * @see #getSource()
   * @generated
   */
  void setSource(PortInstance value);

  /**
   * Returns the value of the '<em><b>Target</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.compositionprogram.PortInstance#getTargetLinks <em>Target Links</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target</em>' reference.
   * @see #setTarget(PortInstance)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionLink_Target()
   * @see org.reuseware.coconut.compositionprogram.PortInstance#getTargetLinks
   * @model opposite="targetLinks" required="true" ordered="false"
   * @generated
   */
  PortInstance getTarget();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.CompositionLink#getTarget <em>Target</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target</em>' reference.
   * @see #getTarget()
   * @generated
   */
  void setTarget(PortInstance value);

  /**
   * Returns the value of the '<em><b>Valid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Valid</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Valid</em>' attribute.
   * @see #setValid(boolean)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionLink_Valid()
   * @model required="true" transient="true"
   * @generated
   */
  boolean isValid();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.CompositionLink#isValid <em>Valid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Valid</em>' attribute.
   * @see #isValid()
   * @generated
   */
  void setValid(boolean value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  CompositionAssociation compositionAssociation();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void match();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // CompositionLink
