/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.compositionprogram;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

import org.reuseware.coconut.fragment.ComposedFragment;

import org.reuseware.coconut.id.ID;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Composition Program</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.compositionprogram.CompositionProgram#getUCPI <em>UCPI</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.CompositionProgram#getComposedFragments <em>Composed Fragments</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.CompositionProgram#getCompositionLinks <em>Composition Links</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.CompositionProgram#getFragmentInstances <em>Fragment Instances</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionProgram()
 * @model abstract="true"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore constraints='TargetDefined'"
 * @generated
 */
public interface CompositionProgram extends EObject
{
  /**
   * Returns the value of the '<em><b>UCPI</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>UCPI</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>UCPI</em>' attribute list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionProgram_UCPI()
   * @model unique="false" required="true"
   * @generated
   */
  EList<String> getUCPI();

  /**
   * Returns the value of the '<em><b>Composed Fragments</b></em>' reference list.
   * The list contents are of type {@link org.reuseware.coconut.fragment.ComposedFragment}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composed Fragments</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composed Fragments</em>' reference list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionProgram_ComposedFragments()
   * @model ordered="false"
   * @generated
   */
  EList<ComposedFragment> getComposedFragments();

  /**
   * Returns the value of the '<em><b>Composition Links</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.compositionprogram.CompositionLink}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.compositionprogram.CompositionLink#getCompositionProgram <em>Composition Program</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Links</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Links</em>' containment reference list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionProgram_CompositionLinks()
   * @see org.reuseware.coconut.compositionprogram.CompositionLink#getCompositionProgram
   * @model opposite="compositionProgram" containment="true" ordered="false"
   * @generated
   */
  EList<CompositionLink> getCompositionLinks();

  /**
   * Returns the value of the '<em><b>Fragment Instances</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.compositionprogram.FragmentInstance}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getCompositionProgram <em>Composition Program</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment Instances</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment Instances</em>' containment reference list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getCompositionProgram_FragmentInstances()
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#getCompositionProgram
   * @model opposite="compositionProgram" containment="true" keys="name" ordered="false"
   * @generated
   */
  EList<FragmentInstance> getFragmentInstances();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void compose();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model kind="operation"
   * @generated
   */
  ID getUCPIAsID();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // CompositionProgram
