/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.compositionprogram;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage
 * @generated
 */
public interface CompositionprogramFactory extends EFactory
{
  /**
   * The singleton instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  CompositionprogramFactory eINSTANCE = org.reuseware.coconut.compositionprogram.impl.CompositionprogramFactoryImpl.init();

  /**
   * Returns a new object of class '<em>Composition Link</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Composition Link</em>'.
   * @generated
   */
  CompositionLink createCompositionLink();

  /**
   * Returns a new object of class '<em>Derived Composition Program</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Derived Composition Program</em>'.
   * @generated
   */
  DerivedCompositionProgram createDerivedCompositionProgram();

  /**
   * Returns a new object of class '<em>Fragment Instance</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Fragment Instance</em>'.
   * @generated
   */
  FragmentInstance createFragmentInstance();

  /**
   * Returns a new object of class '<em>Physical Composition Program</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Physical Composition Program</em>'.
   * @generated
   */
  PhysicalCompositionProgram createPhysicalCompositionProgram();

  /**
   * Returns a new object of class '<em>Port Instance</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Port Instance</em>'.
   * @generated
   */
  PortInstance createPortInstance();

  /**
   * Returns a new object of class '<em>Setting</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Setting</em>'.
   * @generated
   */
  Setting createSetting();

  /**
   * Returns the package supported by this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the package supported by this factory.
   * @generated
   */
  CompositionprogramPackage getCompositionprogramPackage();

} //CompositionprogramFactory
