/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.compositionprogram;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

import org.reuseware.coconut.fragment.HeterogeneousPort;
import org.reuseware.coconut.fragment.Port;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Port Instance</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.compositionprogram.PortInstance#getFracolName <em>Fracol Name</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.PortInstance#getFracolNamespace <em>Fracol Namespace</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.PortInstance#getFragmentInstance <em>Fragment Instance</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.PortInstance#getFragmentRoleName <em>Fragment Role Name</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.PortInstance#getPortName <em>Port Name</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.PortInstance#getSettings <em>Settings</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.PortInstance#getSourceLinks <em>Source Links</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.PortInstance#getTargetLinks <em>Target Links</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getPortInstance()
 * @model
 * @generated
 */
public interface PortInstance extends EObject
{
  /**
   * Returns the value of the '<em><b>Fracol Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fracol Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fracol Name</em>' attribute.
   * @see #setFracolName(String)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getPortInstance_FracolName()
   * @model required="true"
   * @generated
   */
  String getFracolName();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.PortInstance#getFracolName <em>Fracol Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fracol Name</em>' attribute.
   * @see #getFracolName()
   * @generated
   */
  void setFracolName(String value);

  /**
   * Returns the value of the '<em><b>Fracol Namespace</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fracol Namespace</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fracol Namespace</em>' attribute list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getPortInstance_FracolNamespace()
   * @model unique="false"
   * @generated
   */
  EList<String> getFracolNamespace();

  /**
   * Returns the value of the '<em><b>Fragment Instance</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.compositionprogram.FragmentInstance#getPortInstances <em>Port Instances</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment Instance</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment Instance</em>' container reference.
   * @see #setFragmentInstance(FragmentInstance)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getPortInstance_FragmentInstance()
   * @see org.reuseware.coconut.compositionprogram.FragmentInstance#getPortInstances
   * @model opposite="portInstances" transient="false" ordered="false"
   * @generated
   */
  FragmentInstance getFragmentInstance();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.PortInstance#getFragmentInstance <em>Fragment Instance</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fragment Instance</em>' container reference.
   * @see #getFragmentInstance()
   * @generated
   */
  void setFragmentInstance(FragmentInstance value);

  /**
   * Returns the value of the '<em><b>Fragment Role Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment Role Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment Role Name</em>' attribute.
   * @see #setFragmentRoleName(String)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getPortInstance_FragmentRoleName()
   * @model required="true"
   * @generated
   */
  String getFragmentRoleName();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.PortInstance#getFragmentRoleName <em>Fragment Role Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fragment Role Name</em>' attribute.
   * @see #getFragmentRoleName()
   * @generated
   */
  void setFragmentRoleName(String value);

  /**
   * Returns the value of the '<em><b>Port Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Port Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Port Name</em>' attribute.
   * @see #setPortName(String)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getPortInstance_PortName()
   * @model required="true"
   * @generated
   */
  String getPortName();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.PortInstance#getPortName <em>Port Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Port Name</em>' attribute.
   * @see #getPortName()
   * @generated
   */
  void setPortName(String value);

  /**
   * Returns the value of the '<em><b>Settings</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.compositionprogram.Setting}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.compositionprogram.Setting#getPortInstance <em>Port Instance</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Settings</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Settings</em>' containment reference list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getPortInstance_Settings()
   * @see org.reuseware.coconut.compositionprogram.Setting#getPortInstance
   * @model opposite="portInstance" containment="true" ordered="false"
   * @generated
   */
  EList<Setting> getSettings();

  /**
   * Returns the value of the '<em><b>Source Links</b></em>' reference list.
   * The list contents are of type {@link org.reuseware.coconut.compositionprogram.CompositionLink}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.compositionprogram.CompositionLink#getSource <em>Source</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Source Links</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Source Links</em>' reference list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getPortInstance_SourceLinks()
   * @see org.reuseware.coconut.compositionprogram.CompositionLink#getSource
   * @model opposite="source" ordered="false"
   * @generated
   */
  EList<CompositionLink> getSourceLinks();

  /**
   * Returns the value of the '<em><b>Target Links</b></em>' reference list.
   * The list contents are of type {@link org.reuseware.coconut.compositionprogram.CompositionLink}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.compositionprogram.CompositionLink#getTarget <em>Target</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Links</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Links</em>' reference list.
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getPortInstance_TargetLinks()
   * @see org.reuseware.coconut.compositionprogram.CompositionLink#getTarget
   * @model opposite="target" ordered="false"
   * @generated
   */
  EList<CompositionLink> getTargetLinks();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  EList<HeterogeneousPort> allPorts();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  boolean canBeReferenced();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  boolean canContribute();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  boolean canReceive();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model kind="operation"
   * @generated
   */
  boolean isValue();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  Port port();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void update();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // PortInstance
