/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.compositionprogram;

import org.eclipse.emf.ecore.EObject;

import org.reuseware.coconut.fragment.ComposedFragment;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Setting</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.compositionprogram.Setting#getPortInstance <em>Port Instance</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.Setting#getProperty <em>Property</em>}</li>
 *   <li>{@link org.reuseware.coconut.compositionprogram.Setting#getValue <em>Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getSetting()
 * @model
 * @generated
 */
public interface Setting extends EObject
{
  /**
   * Returns the value of the '<em><b>Port Instance</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.compositionprogram.PortInstance#getSettings <em>Settings</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Port Instance</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Port Instance</em>' container reference.
   * @see #setPortInstance(PortInstance)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getSetting_PortInstance()
   * @see org.reuseware.coconut.compositionprogram.PortInstance#getSettings
   * @model opposite="settings" transient="false" ordered="false"
   * @generated
   */
  PortInstance getPortInstance();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.Setting#getPortInstance <em>Port Instance</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Port Instance</em>' container reference.
   * @see #getPortInstance()
   * @generated
   */
  void setPortInstance(PortInstance value);

  /**
   * Returns the value of the '<em><b>Property</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Property</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Property</em>' attribute.
   * @see #setProperty(String)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getSetting_Property()
   * @model required="true"
   * @generated
   */
  String getProperty();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.Setting#getProperty <em>Property</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Property</em>' attribute.
   * @see #getProperty()
   * @generated
   */
  void setProperty(String value);

  /**
   * Returns the value of the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Value</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Value</em>' attribute.
   * @see #setValue(String)
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#getSetting_Value()
   * @model
   * @generated
   */
  String getValue();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.compositionprogram.Setting#getValue <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Value</em>' attribute.
   * @see #getValue()
   * @generated
   */
  void setValue(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void execute(ComposedFragment composedTarget);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // Setting
