/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.compositionprogram.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.reuseware.coconut.compositionprogram.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class CompositionprogramFactoryImpl extends EFactoryImpl implements CompositionprogramFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static CompositionprogramFactory init()
  {
    try
    {
      CompositionprogramFactory theCompositionprogramFactory = (CompositionprogramFactory)EPackage.Registry.INSTANCE.getEFactory("http://reuseware.org/coconut/compositionprogram"); 
      if (theCompositionprogramFactory != null)
      {
        return theCompositionprogramFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new CompositionprogramFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionprogramFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case CompositionprogramPackage.COMPOSITION_LINK: return createCompositionLink();
      case CompositionprogramPackage.DERIVED_COMPOSITION_PROGRAM: return createDerivedCompositionProgram();
      case CompositionprogramPackage.FRAGMENT_INSTANCE: return createFragmentInstance();
      case CompositionprogramPackage.PHYSICAL_COMPOSITION_PROGRAM: return createPhysicalCompositionProgram();
      case CompositionprogramPackage.PORT_INSTANCE: return createPortInstance();
      case CompositionprogramPackage.SETTING: return createSetting();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionLink createCompositionLink()
  {
    CompositionLinkImpl compositionLink = new CompositionLinkImpl();
    return compositionLink;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DerivedCompositionProgram createDerivedCompositionProgram()
  {
    DerivedCompositionProgramImpl derivedCompositionProgram = new DerivedCompositionProgramImpl();
    return derivedCompositionProgram;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentInstance createFragmentInstance()
  {
    FragmentInstanceImpl fragmentInstance = new FragmentInstanceImpl();
    return fragmentInstance;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PhysicalCompositionProgram createPhysicalCompositionProgram()
  {
    PhysicalCompositionProgramImpl physicalCompositionProgram = new PhysicalCompositionProgramImpl();
    return physicalCompositionProgram;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortInstance createPortInstance()
  {
    PortInstanceImpl portInstance = new PortInstanceImpl();
    return portInstance;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Setting createSetting()
  {
    SettingImpl setting = new SettingImpl();
    return setting;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionprogramPackage getCompositionprogramPackage()
  {
    return (CompositionprogramPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static CompositionprogramPackage getPackage()
  {
    return CompositionprogramPackage.eINSTANCE;
  }

} //CompositionprogramFactoryImpl
