/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.compositionprogram.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;
import org.eclipse.emf.ecore.EcorePackage;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.reuseware.coconut.compositionprogram.CompositionLink;
import org.reuseware.coconut.compositionprogram.CompositionProgram;
import org.reuseware.coconut.compositionprogram.CompositionprogramFactory;
import org.reuseware.coconut.compositionprogram.CompositionprogramPackage;
import org.reuseware.coconut.compositionprogram.DerivedCompositionProgram;
import org.reuseware.coconut.compositionprogram.FragmentInstance;
import org.reuseware.coconut.compositionprogram.PhysicalCompositionProgram;
import org.reuseware.coconut.compositionprogram.PortInstance;
import org.reuseware.coconut.compositionprogram.Setting;

import org.reuseware.coconut.compositionprogram.util.CompositionprogramValidator;

import org.reuseware.coconut.fracol.FracolPackage;

import org.reuseware.coconut.fragment.FragmentPackage;

import org.reuseware.coconut.id.IdPackage;

import org.reuseware.coconut.reuseextension.ReuseextensionPackage;

import org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class CompositionprogramPackageImpl extends EPackageImpl implements CompositionprogramPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass compositionLinkEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass compositionProgramEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass derivedCompositionProgramEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass fragmentInstanceEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass physicalCompositionProgramEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass portInstanceEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass settingEClass = null;

  /**
   * Creates an instance of the model <b>Package</b>, registered with
   * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
   * package URI value.
   * <p>Note: the correct way to create the package is via the static
   * factory method {@link #init init()}, which also performs
   * initialization of the package, or returns the registered package,
   * if one already exists.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.ecore.EPackage.Registry
   * @see org.reuseware.coconut.compositionprogram.CompositionprogramPackage#eNS_URI
   * @see #init()
   * @generated
   */
  private CompositionprogramPackageImpl()
  {
    super(eNS_URI, CompositionprogramFactory.eINSTANCE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static boolean isInited = false;

  /**
   * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
   * 
   * <p>This method is used to initialize {@link CompositionprogramPackage#eINSTANCE} when that field is accessed.
   * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #eNS_URI
   * @see #createPackageContents()
   * @see #initializePackageContents()
   * @generated
   */
  public static CompositionprogramPackage init()
  {
    if (isInited) return (CompositionprogramPackage)EPackage.Registry.INSTANCE.getEPackage(CompositionprogramPackage.eNS_URI);

    // Obtain or create and register package
    CompositionprogramPackageImpl theCompositionprogramPackage = (CompositionprogramPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof CompositionprogramPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new CompositionprogramPackageImpl());

    isInited = true;

    // Initialize simple dependencies
    FragmentPackage.eINSTANCE.eClass();

    // Create package meta-data objects
    theCompositionprogramPackage.createPackageContents();

    // Initialize created meta-data
    theCompositionprogramPackage.initializePackageContents();

    // Register package validator
    EValidator.Registry.INSTANCE.put
      (theCompositionprogramPackage, 
       new EValidator.Descriptor()
       {
         public EValidator getEValidator()
         {
           return CompositionprogramValidator.INSTANCE;
         }
       });

    // Mark meta-data to indicate it can't be changed
    theCompositionprogramPackage.freeze();

  
    // Update the registry and return the package
    EPackage.Registry.INSTANCE.put(CompositionprogramPackage.eNS_URI, theCompositionprogramPackage);
    return theCompositionprogramPackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getCompositionLink()
  {
    return compositionLinkEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionLink_CompositionProgram()
  {
    return (EReference)compositionLinkEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getCompositionLink_Contributes()
  {
    return (EAttribute)compositionLinkEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionLink_DerivedFrom()
  {
    return (EReference)compositionLinkEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getCompositionLink_Empty()
  {
    return (EAttribute)compositionLinkEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionLink_Matches()
  {
    return (EReference)compositionLinkEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionLink_Source()
  {
    return (EReference)compositionLinkEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionLink_Target()
  {
    return (EReference)compositionLinkEClass.getEStructuralFeatures().get(6);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getCompositionLink_Valid()
  {
    return (EAttribute)compositionLinkEClass.getEStructuralFeatures().get(7);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getCompositionProgram()
  {
    return compositionProgramEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getCompositionProgram_UCPI()
  {
    return (EAttribute)compositionProgramEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionProgram_ComposedFragments()
  {
    return (EReference)compositionProgramEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionProgram_CompositionLinks()
  {
    return (EReference)compositionProgramEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionProgram_FragmentInstances()
  {
    return (EReference)compositionProgramEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getDerivedCompositionProgram()
  {
    return derivedCompositionProgramEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getDerivedCompositionProgram_DeriveFrom()
  {
    return (EReference)derivedCompositionProgramEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getFragmentInstance()
  {
    return fragmentInstanceEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentInstance_UFI()
  {
    return (EAttribute)fragmentInstanceEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentInstance_Arguments()
  {
    return (EReference)fragmentInstanceEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentInstance_CompositionProgram()
  {
    return (EReference)fragmentInstanceEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentInstance_DerivedFrom()
  {
    return (EReference)fragmentInstanceEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentInstance_Fragment()
  {
    return (EReference)fragmentInstanceEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentInstance_Instantiations()
  {
    return (EReference)fragmentInstanceEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentInstance_Name()
  {
    return (EAttribute)fragmentInstanceEClass.getEStructuralFeatures().get(6);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentInstance_PortInstances()
  {
    return (EReference)fragmentInstanceEClass.getEStructuralFeatures().get(7);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentInstance_Reference()
  {
    return (EAttribute)fragmentInstanceEClass.getEStructuralFeatures().get(8);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentInstance_TargetPhysicalLocation()
  {
    return (EAttribute)fragmentInstanceEClass.getEStructuralFeatures().get(9);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentInstance_TargetUFI()
  {
    return (EAttribute)fragmentInstanceEClass.getEStructuralFeatures().get(10);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentInstance_Target()
  {
    return (EAttribute)fragmentInstanceEClass.getEStructuralFeatures().get(11);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getPhysicalCompositionProgram()
  {
    return physicalCompositionProgramEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getPortInstance()
  {
    return portInstanceEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getPortInstance_FracolName()
  {
    return (EAttribute)portInstanceEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getPortInstance_FracolNamespace()
  {
    return (EAttribute)portInstanceEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPortInstance_FragmentInstance()
  {
    return (EReference)portInstanceEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getPortInstance_FragmentRoleName()
  {
    return (EAttribute)portInstanceEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getPortInstance_PortName()
  {
    return (EAttribute)portInstanceEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPortInstance_Settings()
  {
    return (EReference)portInstanceEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPortInstance_SourceLinks()
  {
    return (EReference)portInstanceEClass.getEStructuralFeatures().get(6);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPortInstance_TargetLinks()
  {
    return (EReference)portInstanceEClass.getEStructuralFeatures().get(7);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getSetting()
  {
    return settingEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getSetting_PortInstance()
  {
    return (EReference)settingEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getSetting_Property()
  {
    return (EAttribute)settingEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getSetting_Value()
  {
    return (EAttribute)settingEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionprogramFactory getCompositionprogramFactory()
  {
    return (CompositionprogramFactory)getEFactoryInstance();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isCreated = false;

  /**
   * Creates the meta-model objects for the package.  This method is
   * guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void createPackageContents()
  {
    if (isCreated) return;
    isCreated = true;

    // Create classes and their features
    compositionLinkEClass = createEClass(COMPOSITION_LINK);
    createEReference(compositionLinkEClass, COMPOSITION_LINK__COMPOSITION_PROGRAM);
    createEAttribute(compositionLinkEClass, COMPOSITION_LINK__CONTRIBUTES);
    createEReference(compositionLinkEClass, COMPOSITION_LINK__DERIVED_FROM);
    createEAttribute(compositionLinkEClass, COMPOSITION_LINK__EMPTY);
    createEReference(compositionLinkEClass, COMPOSITION_LINK__MATCHES);
    createEReference(compositionLinkEClass, COMPOSITION_LINK__SOURCE);
    createEReference(compositionLinkEClass, COMPOSITION_LINK__TARGET);
    createEAttribute(compositionLinkEClass, COMPOSITION_LINK__VALID);

    compositionProgramEClass = createEClass(COMPOSITION_PROGRAM);
    createEAttribute(compositionProgramEClass, COMPOSITION_PROGRAM__UCPI);
    createEReference(compositionProgramEClass, COMPOSITION_PROGRAM__COMPOSED_FRAGMENTS);
    createEReference(compositionProgramEClass, COMPOSITION_PROGRAM__COMPOSITION_LINKS);
    createEReference(compositionProgramEClass, COMPOSITION_PROGRAM__FRAGMENT_INSTANCES);

    derivedCompositionProgramEClass = createEClass(DERIVED_COMPOSITION_PROGRAM);
    createEReference(derivedCompositionProgramEClass, DERIVED_COMPOSITION_PROGRAM__DERIVE_FROM);

    fragmentInstanceEClass = createEClass(FRAGMENT_INSTANCE);
    createEAttribute(fragmentInstanceEClass, FRAGMENT_INSTANCE__UFI);
    createEReference(fragmentInstanceEClass, FRAGMENT_INSTANCE__ARGUMENTS);
    createEReference(fragmentInstanceEClass, FRAGMENT_INSTANCE__COMPOSITION_PROGRAM);
    createEReference(fragmentInstanceEClass, FRAGMENT_INSTANCE__DERIVED_FROM);
    createEReference(fragmentInstanceEClass, FRAGMENT_INSTANCE__FRAGMENT);
    createEReference(fragmentInstanceEClass, FRAGMENT_INSTANCE__INSTANTIATIONS);
    createEAttribute(fragmentInstanceEClass, FRAGMENT_INSTANCE__NAME);
    createEReference(fragmentInstanceEClass, FRAGMENT_INSTANCE__PORT_INSTANCES);
    createEAttribute(fragmentInstanceEClass, FRAGMENT_INSTANCE__REFERENCE);
    createEAttribute(fragmentInstanceEClass, FRAGMENT_INSTANCE__TARGET_PHYSICAL_LOCATION);
    createEAttribute(fragmentInstanceEClass, FRAGMENT_INSTANCE__TARGET_UFI);
    createEAttribute(fragmentInstanceEClass, FRAGMENT_INSTANCE__TARGET);

    physicalCompositionProgramEClass = createEClass(PHYSICAL_COMPOSITION_PROGRAM);

    portInstanceEClass = createEClass(PORT_INSTANCE);
    createEAttribute(portInstanceEClass, PORT_INSTANCE__FRACOL_NAME);
    createEAttribute(portInstanceEClass, PORT_INSTANCE__FRACOL_NAMESPACE);
    createEReference(portInstanceEClass, PORT_INSTANCE__FRAGMENT_INSTANCE);
    createEAttribute(portInstanceEClass, PORT_INSTANCE__FRAGMENT_ROLE_NAME);
    createEAttribute(portInstanceEClass, PORT_INSTANCE__PORT_NAME);
    createEReference(portInstanceEClass, PORT_INSTANCE__SETTINGS);
    createEReference(portInstanceEClass, PORT_INSTANCE__SOURCE_LINKS);
    createEReference(portInstanceEClass, PORT_INSTANCE__TARGET_LINKS);

    settingEClass = createEClass(SETTING);
    createEReference(settingEClass, SETTING__PORT_INSTANCE);
    createEAttribute(settingEClass, SETTING__PROPERTY);
    createEAttribute(settingEClass, SETTING__VALUE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isInitialized = false;

  /**
   * Complete the initialization of the package and its meta-model.  This
   * method is guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void initializePackageContents()
  {
    if (isInitialized) return;
    isInitialized = true;

    // Initialize package
    setName(eNAME);
    setNsPrefix(eNS_PREFIX);
    setNsURI(eNS_URI);

    // Obtain other dependent packages
    EcorePackage theEcorePackage = (EcorePackage)EPackage.Registry.INSTANCE.getEPackage(EcorePackage.eNS_URI);
    FragmentPackage theFragmentPackage = (FragmentPackage)EPackage.Registry.INSTANCE.getEPackage(FragmentPackage.eNS_URI);
    FracolPackage theFracolPackage = (FracolPackage)EPackage.Registry.INSTANCE.getEPackage(FracolPackage.eNS_URI);
    IdPackage theIdPackage = (IdPackage)EPackage.Registry.INSTANCE.getEPackage(IdPackage.eNS_URI);
    ReuseextensionPackage theReuseextensionPackage = (ReuseextensionPackage)EPackage.Registry.INSTANCE.getEPackage(ReuseextensionPackage.eNS_URI);
    ReuseextensionactivatorPackage theReuseextensionactivatorPackage = (ReuseextensionactivatorPackage)EPackage.Registry.INSTANCE.getEPackage(ReuseextensionactivatorPackage.eNS_URI);

    // Create type parameters

    // Set bounds for type parameters

    // Add supertypes to classes
    derivedCompositionProgramEClass.getESuperTypes().add(this.getCompositionProgram());
    physicalCompositionProgramEClass.getESuperTypes().add(this.getCompositionProgram());

    // Initialize classes and features; add operations and parameters
    initEClass(compositionLinkEClass, CompositionLink.class, "CompositionLink", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getCompositionLink_CompositionProgram(), this.getCompositionProgram(), this.getCompositionProgram_CompositionLinks(), "compositionProgram", null, 0, 1, CompositionLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getCompositionLink_Contributes(), ecorePackage.getEBoolean(), "contributes", null, 1, 1, CompositionLink.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getCompositionLink_DerivedFrom(), theEcorePackage.getEObject(), null, "derivedFrom", null, 0, -1, CompositionLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getCompositionLink_Empty(), ecorePackage.getEBoolean(), "empty", null, 1, 1, CompositionLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getCompositionLink_Matches(), theFragmentPackage.getAPMatchGroup(), null, "matches", null, 0, -1, CompositionLink.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getCompositionLink_Source(), this.getPortInstance(), this.getPortInstance_SourceLinks(), "source", null, 1, 1, CompositionLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getCompositionLink_Target(), this.getPortInstance(), this.getPortInstance_TargetLinks(), "target", null, 1, 1, CompositionLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getCompositionLink_Valid(), ecorePackage.getEBoolean(), "valid", null, 1, 1, CompositionLink.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(compositionLinkEClass, theFracolPackage.getCompositionAssociation(), "compositionAssociation", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(compositionLinkEClass, null, "match", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(compositionLinkEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(compositionProgramEClass, CompositionProgram.class, "CompositionProgram", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getCompositionProgram_UCPI(), ecorePackage.getEString(), "UCPI", null, 1, -1, CompositionProgram.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getCompositionProgram_ComposedFragments(), theFragmentPackage.getComposedFragment(), null, "composedFragments", null, 0, -1, CompositionProgram.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getCompositionProgram_CompositionLinks(), this.getCompositionLink(), this.getCompositionLink_CompositionProgram(), "compositionLinks", null, 0, -1, CompositionProgram.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getCompositionProgram_FragmentInstances(), this.getFragmentInstance(), this.getFragmentInstance_CompositionProgram(), "fragmentInstances", null, 0, -1, CompositionProgram.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    getCompositionProgram_FragmentInstances().getEKeys().add(this.getFragmentInstance_Name());

    addEOperation(compositionProgramEClass, null, "compose", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(compositionProgramEClass, theIdPackage.getID(), "getUCPIAsID", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(compositionProgramEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(derivedCompositionProgramEClass, DerivedCompositionProgram.class, "DerivedCompositionProgram", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getDerivedCompositionProgram_DeriveFrom(), theFragmentPackage.getFragment(), null, "deriveFrom", null, 0, -1, DerivedCompositionProgram.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    EOperation op = addEOperation(derivedCompositionProgramEClass, this.getCompositionLink(), "createCompositionLink", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theFragmentPackage.getFragment(), "fragment", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "source", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "target", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theReuseextensionPackage.getCompositionAssociation2CompositionLinkBinding(), "assocBinding", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theReuseextensionactivatorPackage.getReuseExtensionActivator(), "activator", 0, 1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(derivedCompositionProgramEClass, this.getFragmentInstance(), "createFragmentInstance", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theFragmentPackage.getFragment(), "fragment", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "element", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theReuseextensionPackage.getFragmentRole2FragmentInstanceBinding(), "roleBinding", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theReuseextensionactivatorPackage.getReuseExtensionActivator(), "activator", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(derivedCompositionProgramEClass, null, "extractCompositionProgram", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(derivedCompositionProgramEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(fragmentInstanceEClass, FragmentInstance.class, "FragmentInstance", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getFragmentInstance_UFI(), ecorePackage.getEString(), "UFI", null, 1, -1, FragmentInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getFragmentInstance_Arguments(), theEcorePackage.getEStringToStringMapEntry(), null, "arguments", null, 0, -1, FragmentInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getFragmentInstance_CompositionProgram(), this.getCompositionProgram(), this.getCompositionProgram_FragmentInstances(), "compositionProgram", null, 0, 1, FragmentInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getFragmentInstance_DerivedFrom(), theEcorePackage.getEObject(), null, "derivedFrom", null, 0, -1, FragmentInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getFragmentInstance_Fragment(), theFragmentPackage.getFragment(), null, "fragment", null, 1, 1, FragmentInstance.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getFragmentInstance_Instantiations(), theFragmentPackage.getFragment(), null, "instantiations", null, 0, -1, FragmentInstance.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getFragmentInstance_Name(), ecorePackage.getEString(), "name", null, 1, 1, FragmentInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getFragmentInstance_PortInstances(), this.getPortInstance(), this.getPortInstance_FragmentInstance(), "portInstances", null, 0, -1, FragmentInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    getFragmentInstance_PortInstances().getEKeys().add(this.getPortInstance_PortName());
    getFragmentInstance_PortInstances().getEKeys().add(this.getPortInstance_FragmentRoleName());
    getFragmentInstance_PortInstances().getEKeys().add(this.getPortInstance_FracolNamespace());
    initEAttribute(getFragmentInstance_Reference(), ecorePackage.getEBoolean(), "reference", null, 1, 1, FragmentInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getFragmentInstance_TargetPhysicalLocation(), ecorePackage.getEString(), "targetPhysicalLocation", null, 0, 1, FragmentInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getFragmentInstance_TargetUFI(), ecorePackage.getEString(), "targetUFI", null, 0, -1, FragmentInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getFragmentInstance_Target(), ecorePackage.getEBoolean(), "target", null, 1, 1, FragmentInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    op = addEOperation(fragmentInstanceEClass, null, "completeInstantiation", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theFragmentPackage.getInstantiationSet(), "is", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theFragmentPackage.getComposedFragment(), "result", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theFragmentPackage.getInstantiationSet(), "additionalInstantiations", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "additionalContext", 0, -1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(fragmentInstanceEClass, theFragmentPackage.getComposedFragment(), "compose", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theFragmentPackage.getInstantiationSet(), "additionalInstantiations", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theEcorePackage.getEObject(), "additionalContext", 0, -1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(fragmentInstanceEClass, this.getSetting(), "getSetting", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, ecorePackage.getEString(), "port", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, ecorePackage.getEString(), "property", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(fragmentInstanceEClass, theIdPackage.getID(), "getTargetUFIAsID", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(fragmentInstanceEClass, theIdPackage.getID(), "getUFIAsID", 0, 1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(fragmentInstanceEClass, null, "setTargetUFIAsString", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, ecorePackage.getEString(), "targetUFIString", 0, 1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(fragmentInstanceEClass, null, "setUFIAsString", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, ecorePackage.getEString(), "ufiString", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(fragmentInstanceEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(fragmentInstanceEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(physicalCompositionProgramEClass, PhysicalCompositionProgram.class, "PhysicalCompositionProgram", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(physicalCompositionProgramEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(portInstanceEClass, PortInstance.class, "PortInstance", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getPortInstance_FracolName(), ecorePackage.getEString(), "fracolName", null, 1, 1, PortInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getPortInstance_FracolNamespace(), ecorePackage.getEString(), "fracolNamespace", null, 0, -1, PortInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getPortInstance_FragmentInstance(), this.getFragmentInstance(), this.getFragmentInstance_PortInstances(), "fragmentInstance", null, 0, 1, PortInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getPortInstance_FragmentRoleName(), ecorePackage.getEString(), "fragmentRoleName", null, 1, 1, PortInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getPortInstance_PortName(), ecorePackage.getEString(), "portName", null, 1, 1, PortInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getPortInstance_Settings(), this.getSetting(), this.getSetting_PortInstance(), "settings", null, 0, -1, PortInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getPortInstance_SourceLinks(), this.getCompositionLink(), this.getCompositionLink_Source(), "sourceLinks", null, 0, -1, PortInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getPortInstance_TargetLinks(), this.getCompositionLink(), this.getCompositionLink_Target(), "targetLinks", null, 0, -1, PortInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

    addEOperation(portInstanceEClass, theFragmentPackage.getHeterogeneousPort(), "allPorts", 0, -1, IS_UNIQUE, IS_ORDERED);

    addEOperation(portInstanceEClass, ecorePackage.getEBoolean(), "canBeReferenced", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(portInstanceEClass, ecorePackage.getEBoolean(), "canContribute", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(portInstanceEClass, ecorePackage.getEBoolean(), "canReceive", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(portInstanceEClass, ecorePackage.getEBoolean(), "isValue", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(portInstanceEClass, theFragmentPackage.getPort(), "port", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(portInstanceEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(portInstanceEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(settingEClass, Setting.class, "Setting", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getSetting_PortInstance(), this.getPortInstance(), this.getPortInstance_Settings(), "portInstance", null, 0, 1, Setting.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getSetting_Property(), ecorePackage.getEString(), "property", null, 1, 1, Setting.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getSetting_Value(), ecorePackage.getEString(), "value", null, 0, 1, Setting.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    op = addEOperation(settingEClass, null, "execute", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, theFragmentPackage.getComposedFragment(), "composedTarget", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(settingEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    // Create resource
    createResource(eNS_URI);

    // Create annotations
    // http://www.eclipse.org/emf/2002/Ecore
    createEcoreAnnotations();
  }

  /**
   * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createEcoreAnnotations()
  {
    String source = "http://www.eclipse.org/emf/2002/Ecore";		
    addAnnotation
      (compositionLinkEClass, 
       source, 
       new String[] 
       {
       "constraints", "Valid Typed PortsExist"
       });		
    addAnnotation
      (compositionProgramEClass, 
       source, 
       new String[] 
       {
       "constraints", "TargetDefined"
       });
  }

} //CompositionprogramPackageImpl
