/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.compositionprogram.impl;


import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.reuseware.coconut.compositionprogram.CompositionprogramPackage;
import org.reuseware.coconut.fragment.FragmentFactory;
import java.util.*;
import org.reuseware.coconut.fragment.AddressablePoint;
import java.util.ArrayList;
import org.reuseware.coconut.fragment.ValuePrototype;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.reuseware.coconut.fragment.ValueHook;
import org.reuseware.coconut.fragment.HeterogeneousPort;
import org.reuseware.coconut.compositionprogram.PortInstance;
import org.reuseware.coconut.compositionprogram.Setting;
import org.reuseware.coconut.fragment.ComposedFragment;


/**
 * @generated
 **/
public class SettingImpl extends EObjectImpl implements Setting
{


   /**
   * The default value of the '{@link #getProperty() <em>Property</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getProperty()
   * @generated
   * @ordered
   */
  protected static final String PROPERTY_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getProperty() <em>Property</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getProperty()
   * @generated
   * @ordered
   */
  protected String property = PROPERTY_EDEFAULT;
  /**
   * The default value of the '{@link #getValue() <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValue()
   * @generated
   * @ordered
   */
  protected static final String VALUE_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getValue() <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValue()
   * @generated
   * @ordered
   */
  protected String value = VALUE_EDEFAULT;


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SettingImpl()
  {
    super();
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return CompositionprogramPackage.Literals.SETTING;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortInstance getPortInstance()
  {
    if (eContainerFeatureID() != CompositionprogramPackage.SETTING__PORT_INSTANCE) return null;
    return (PortInstance)eContainer();
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetPortInstance(PortInstance newPortInstance, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newPortInstance, CompositionprogramPackage.SETTING__PORT_INSTANCE, msgs);
    return msgs;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPortInstance(PortInstance newPortInstance)
  {
    if (newPortInstance != eInternalContainer() || (eContainerFeatureID() != CompositionprogramPackage.SETTING__PORT_INSTANCE && newPortInstance != null))
    {
      if (EcoreUtil.isAncestor(this, newPortInstance))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newPortInstance != null)
        msgs = ((InternalEObject)newPortInstance).eInverseAdd(this, CompositionprogramPackage.PORT_INSTANCE__SETTINGS, PortInstance.class, msgs);
      msgs = basicSetPortInstance(newPortInstance, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, CompositionprogramPackage.SETTING__PORT_INSTANCE, newPortInstance, newPortInstance));
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getProperty()
  {
    return property;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setProperty(String newProperty)
  {
    String oldProperty = property;
    property = newProperty;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, CompositionprogramPackage.SETTING__PROPERTY, oldProperty, property));
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getValue()
  {
    return value;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setValue(String newValue)
  {
    String oldValue = value;
    value = newValue;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, CompositionprogramPackage.SETTING__VALUE, oldValue, value));
  }


  public void execute (ComposedFragment composedTarget ){
      boolean fujaba__Success = false;
      ValuePrototype valuePrototype = null;
      Iterator<?> fujaba__IterValueHookNodeToValueHookNodeCopy = null;
      Object _TmpObject = null;
      EObject valueHookNodeCopy = null;
      EObject valueHookNode = null;
      EStructuralFeature feature = null;
      Iterator<AddressablePoint> fujaba__IterPortToValueHook = null;
      ValueHook valueHook = null;
      Iterator<?> fujaba__IterPortInstanceToPort = null;
      HeterogeneousPort port = null;
      PortInstance portInstance = null;

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // bind object
         portInstance = this.getPortInstance ();

         // check object portInstance is really bound
         if (!( portInstance != null )) {throw new Exception("SDMException");};

         // attribute condition
         if (!( !"".equals(this.getValue ()) )) {throw new Exception("SDMException");};

         // attribute condition
         if (!( null != this.getValue () )) {throw new Exception("SDMException");};

         // iterate to-many link $link.InstanceOf.Name from portInstance to port
         fujaba__Success = false;
         _TmpObject = portInstance.allPorts();
         if (_TmpObject instanceof Iterator<?>) {
             fujaba__IterPortInstanceToPort = (Iterator<?>)_TmpObject;    
         }
         else if (_TmpObject instanceof Iterable<?>) {
             fujaba__IterPortInstanceToPort = ((Iterable<?>)_TmpObject).iterator();
         }
         else {
             fujaba__IterPortInstanceToPort = Collections.singletonList(_TmpObject).iterator();
         }
         while ( fujaba__IterPortInstanceToPort.hasNext () )
         {
            try
            {
               _TmpObject =  fujaba__IterPortInstanceToPort.next ();

               // ensure correct type and really bound of object port
               if (!( _TmpObject instanceof HeterogeneousPort )) {throw new Exception("SDMException");};
               port = (HeterogeneousPort) _TmpObject;

               // iterate to-many link addressablePoints from port to valueHook
               fujaba__Success = false;
               fujaba__IterPortToValueHook = new ArrayList<AddressablePoint>(port.getAddressablePoints()).iterator ();

               while ( fujaba__IterPortToValueHook.hasNext () )
               {
                  try
                  {
                     _TmpObject =  fujaba__IterPortToValueHook.next ();

                     // ensure correct type and really bound of object valueHook
                     if (!( _TmpObject instanceof ValueHook )) {throw new Exception("SDMException");};
                     valueHook = (ValueHook) _TmpObject;

                     // bind object
                     feature = valueHook.getVarTypedEStructuralFeature ();

                     // check object feature is really bound
                     if (!( feature != null )) {throw new Exception("SDMException");};

                     // bind object
                     valueHookNode = valueHook.getVarTypedEObject ();

                     // check object valueHookNode is really bound
                     if (!( valueHookNode != null )) {throw new Exception("SDMException");};


                     // check isomorphic binding between objects valueHookNode and feature
                     if (!( !valueHookNode.equals (feature) )) {throw new Exception("SDMException");};

                     // attribute condition
                     if (!( this.property.equals(valueHook.getName ()) )) {throw new Exception("SDMException");};

                     // iterate to-many link $link.InstanceOf.Name from valueHookNode to valueHookNodeCopy
                     fujaba__Success = false;
                     _TmpObject = org.reuseware.coconut.fragment.util.SyncEcoreUtil.getCopy(valueHookNode, composedTarget, composedTarget.getContents());
                     if (_TmpObject instanceof Iterator<?>) {
                         fujaba__IterValueHookNodeToValueHookNodeCopy = (Iterator<?>)_TmpObject;    
                     }
                     else if (_TmpObject instanceof Iterable<?>) {
                         fujaba__IterValueHookNodeToValueHookNodeCopy = ((Iterable<?>)_TmpObject).iterator();
                     }
                     else {
                         fujaba__IterValueHookNodeToValueHookNodeCopy = Collections.singletonList(_TmpObject).iterator();
                     }
                     while ( fujaba__IterValueHookNodeToValueHookNodeCopy.hasNext () )
                     {
                        try
                        {
                           _TmpObject =  fujaba__IterValueHookNodeToValueHookNodeCopy.next ();

                           // ensure correct type and really bound of object valueHookNodeCopy
                           if (!( _TmpObject instanceof EObject )) {throw new Exception("SDMException");};
                           valueHookNodeCopy = (EObject) _TmpObject;


                           // check isomorphic binding between objects valueHookNodeCopy and feature
                           if (!( !valueHookNodeCopy.equals (feature) )) {throw new Exception("SDMException");};


                           // disabled isomorphic binding check between EObjects valueHookNodeCopy and valueHookNode"

                           // create object
                           valuePrototype = FragmentFactory.eINSTANCE.createValuePrototype();
                           // assign statement
                           valuePrototype.setValue (this.getValue());
                           // collabStat call
                           valueHook.basicCompose(valueHookNodeCopy, feature, valuePrototype, null);

                           fujaba__Success = true;
                        }
                        catch ( Exception fujaba__InternalException )
                        {
                           fujaba__Success = false;
                        }
                     }
                     if (!(fujaba__Success)) {throw new Exception("SDMException");};



                     fujaba__Success = true;
                  }
                  catch ( Exception fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               if (!(fujaba__Success)) {throw new Exception("SDMException");};

               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};

         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;

   }


   public void removeYou()
   {
      this.setPortInstance (null);
   }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.SETTING__PORT_INSTANCE:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetPortInstance((PortInstance)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.SETTING__PORT_INSTANCE:
        return basicSetPortInstance(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case CompositionprogramPackage.SETTING__PORT_INSTANCE:
        return eInternalContainer().eInverseRemove(this, CompositionprogramPackage.PORT_INSTANCE__SETTINGS, PortInstance.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.SETTING__PORT_INSTANCE:
        return getPortInstance();
      case CompositionprogramPackage.SETTING__PROPERTY:
        return getProperty();
      case CompositionprogramPackage.SETTING__VALUE:
        return getValue();
    }
    return super.eGet(featureID, resolve, coreType);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.SETTING__PORT_INSTANCE:
        setPortInstance((PortInstance)newValue);
        return;
      case CompositionprogramPackage.SETTING__PROPERTY:
        setProperty((String)newValue);
        return;
      case CompositionprogramPackage.SETTING__VALUE:
        setValue((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.SETTING__PORT_INSTANCE:
        setPortInstance((PortInstance)null);
        return;
      case CompositionprogramPackage.SETTING__PROPERTY:
        setProperty(PROPERTY_EDEFAULT);
        return;
      case CompositionprogramPackage.SETTING__VALUE:
        setValue(VALUE_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case CompositionprogramPackage.SETTING__PORT_INSTANCE:
        return getPortInstance() != null;
      case CompositionprogramPackage.SETTING__PROPERTY:
        return PROPERTY_EDEFAULT == null ? property != null : !PROPERTY_EDEFAULT.equals(property);
      case CompositionprogramPackage.SETTING__VALUE:
        return VALUE_EDEFAULT == null ? value != null : !VALUE_EDEFAULT.equals(value);
    }
    return super.eIsSet(featureID);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (property: ");
    result.append(property);
    result.append(", value: ");
    result.append(value);
    result.append(')');
    return result.toString();
  }
}


