/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fracol;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Composition Association</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd1Role <em>End1 Role</em>}</li>
 *   <li>{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd1 <em>End1</em>}</li>
 *   <li>{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd2Role <em>End2 Role</em>}</li>
 *   <li>{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd2 <em>End2</em>}</li>
 *   <li>{@link org.reuseware.coconut.fracol.CompositionAssociation#getFragmentCollaboration <em>Fragment Collaboration</em>}</li>
 *   <li>{@link org.reuseware.coconut.fracol.CompositionAssociation#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.fracol.FracolPackage#getCompositionAssociation()
 * @model abstract="true"
 * @generated
 */
public interface CompositionAssociation extends EObject
{
  /**
   * Returns the value of the '<em><b>End1 Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>End1 Role</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>End1 Role</em>' reference.
   * @see #setEnd1Role(FragmentRole)
   * @see org.reuseware.coconut.fracol.FracolPackage#getCompositionAssociation_End1Role()
   * @model required="true" ordered="false"
   * @generated
   */
  FragmentRole getEnd1Role();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd1Role <em>End1 Role</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>End1 Role</em>' reference.
   * @see #getEnd1Role()
   * @generated
   */
  void setEnd1Role(FragmentRole value);

  /**
   * Returns the value of the '<em><b>End1</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fracol.PortType#getCompositionAssociations <em>Composition Associations</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>End1</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>End1</em>' reference.
   * @see #setEnd1(PortType)
   * @see org.reuseware.coconut.fracol.FracolPackage#getCompositionAssociation_End1()
   * @see org.reuseware.coconut.fracol.PortType#getCompositionAssociations
   * @model opposite="compositionAssociations" required="true" ordered="false"
   * @generated
   */
  PortType getEnd1();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd1 <em>End1</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>End1</em>' reference.
   * @see #getEnd1()
   * @generated
   */
  void setEnd1(PortType value);

  /**
   * Returns the value of the '<em><b>End2 Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>End2 Role</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>End2 Role</em>' reference.
   * @see #setEnd2Role(FragmentRole)
   * @see org.reuseware.coconut.fracol.FracolPackage#getCompositionAssociation_End2Role()
   * @model required="true" ordered="false"
   * @generated
   */
  FragmentRole getEnd2Role();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd2Role <em>End2 Role</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>End2 Role</em>' reference.
   * @see #getEnd2Role()
   * @generated
   */
  void setEnd2Role(FragmentRole value);

  /**
   * Returns the value of the '<em><b>End2</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fracol.PortType#getCompositionAssociations2 <em>Composition Associations2</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>End2</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>End2</em>' reference.
   * @see #setEnd2(PortType)
   * @see org.reuseware.coconut.fracol.FracolPackage#getCompositionAssociation_End2()
   * @see org.reuseware.coconut.fracol.PortType#getCompositionAssociations2
   * @model opposite="compositionAssociations2" required="true" ordered="false"
   * @generated
   */
  PortType getEnd2();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd2 <em>End2</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>End2</em>' reference.
   * @see #getEnd2()
   * @generated
   */
  void setEnd2(PortType value);

  /**
   * Returns the value of the '<em><b>Fragment Collaboration</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fracol.FragmentCollaboration#getCompositionAssociations <em>Composition Associations</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment Collaboration</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment Collaboration</em>' container reference.
   * @see #setFragmentCollaboration(FragmentCollaboration)
   * @see org.reuseware.coconut.fracol.FracolPackage#getCompositionAssociation_FragmentCollaboration()
   * @see org.reuseware.coconut.fracol.FragmentCollaboration#getCompositionAssociations
   * @model opposite="compositionAssociations" transient="false" ordered="false"
   * @generated
   */
  FragmentCollaboration getFragmentCollaboration();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fracol.CompositionAssociation#getFragmentCollaboration <em>Fragment Collaboration</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fragment Collaboration</em>' container reference.
   * @see #getFragmentCollaboration()
   * @generated
   */
  void setFragmentCollaboration(FragmentCollaboration value);

  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see org.reuseware.coconut.fracol.FracolPackage#getCompositionAssociation_Name()
   * @model required="true"
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fracol.CompositionAssociation#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // CompositionAssociation
