/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fracol;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Fragment Collaboration</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.fracol.FragmentCollaboration#getCompositionAssociations <em>Composition Associations</em>}</li>
 *   <li>{@link org.reuseware.coconut.fracol.FragmentCollaboration#getFracolName <em>Fracol Name</em>}</li>
 *   <li>{@link org.reuseware.coconut.fracol.FragmentCollaboration#getFracolNamespace <em>Fracol Namespace</em>}</li>
 *   <li>{@link org.reuseware.coconut.fracol.FragmentCollaboration#getFragmentRoles <em>Fragment Roles</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.fracol.FracolPackage#getFragmentCollaboration()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='All'"
 * @generated
 */
public interface FragmentCollaboration extends EObject
{
  /**
   * Returns the value of the '<em><b>Composition Associations</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.fracol.CompositionAssociation}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fracol.CompositionAssociation#getFragmentCollaboration <em>Fragment Collaboration</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Associations</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Associations</em>' containment reference list.
   * @see org.reuseware.coconut.fracol.FracolPackage#getFragmentCollaboration_CompositionAssociations()
   * @see org.reuseware.coconut.fracol.CompositionAssociation#getFragmentCollaboration
   * @model opposite="fragmentCollaboration" containment="true" keys="name" ordered="false"
   * @generated
   */
  EList<CompositionAssociation> getCompositionAssociations();

  /**
   * Returns the value of the '<em><b>Fracol Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fracol Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fracol Name</em>' attribute.
   * @see #setFracolName(String)
   * @see org.reuseware.coconut.fracol.FracolPackage#getFragmentCollaboration_FracolName()
   * @model required="true"
   * @generated
   */
  String getFracolName();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fracol.FragmentCollaboration#getFracolName <em>Fracol Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fracol Name</em>' attribute.
   * @see #getFracolName()
   * @generated
   */
  void setFracolName(String value);

  /**
   * Returns the value of the '<em><b>Fracol Namespace</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fracol Namespace</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fracol Namespace</em>' attribute list.
   * @see org.reuseware.coconut.fracol.FracolPackage#getFragmentCollaboration_FracolNamespace()
   * @model unique="false"
   * @generated
   */
  EList<String> getFracolNamespace();

  /**
   * Returns the value of the '<em><b>Fragment Roles</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.fracol.FragmentRole}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fracol.FragmentRole#getFragmentCollaboration <em>Fragment Collaboration</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment Roles</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment Roles</em>' containment reference list.
   * @see org.reuseware.coconut.fracol.FracolPackage#getFragmentCollaboration_FragmentRoles()
   * @see org.reuseware.coconut.fracol.FragmentRole#getFragmentCollaboration
   * @model opposite="fragmentCollaboration" containment="true" keys="name" ordered="false"
   * @generated
   */
  EList<FragmentRole> getFragmentRoles();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  CompositionAssociation getCompositionAssociation(String name);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  FragmentRole getFragmentRole(String fragmentRoleName);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // FragmentCollaboration
