/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fracol;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Port Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.fracol.PortType#getCompositionAssociations2 <em>Composition Associations2</em>}</li>
 *   <li>{@link org.reuseware.coconut.fracol.PortType#getCompositionAssociations <em>Composition Associations</em>}</li>
 *   <li>{@link org.reuseware.coconut.fracol.PortType#getFragmentRole <em>Fragment Role</em>}</li>
 *   <li>{@link org.reuseware.coconut.fracol.PortType#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.fracol.FracolPackage#getPortType()
 * @model abstract="true"
 * @generated
 */
public interface PortType extends EObject
{
  /**
   * Returns the value of the '<em><b>Composition Associations2</b></em>' reference list.
   * The list contents are of type {@link org.reuseware.coconut.fracol.CompositionAssociation}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd2 <em>End2</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Associations2</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Associations2</em>' reference list.
   * @see org.reuseware.coconut.fracol.FracolPackage#getPortType_CompositionAssociations2()
   * @see org.reuseware.coconut.fracol.CompositionAssociation#getEnd2
   * @model opposite="end2" ordered="false"
   * @generated
   */
  EList<CompositionAssociation> getCompositionAssociations2();

  /**
   * Returns the value of the '<em><b>Composition Associations</b></em>' reference list.
   * The list contents are of type {@link org.reuseware.coconut.fracol.CompositionAssociation}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fracol.CompositionAssociation#getEnd1 <em>End1</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Associations</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Associations</em>' reference list.
   * @see org.reuseware.coconut.fracol.FracolPackage#getPortType_CompositionAssociations()
   * @see org.reuseware.coconut.fracol.CompositionAssociation#getEnd1
   * @model opposite="end1" ordered="false"
   * @generated
   */
  EList<CompositionAssociation> getCompositionAssociations();

  /**
   * Returns the value of the '<em><b>Fragment Role</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fracol.FragmentRole#getPortTypes <em>Port Types</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment Role</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment Role</em>' container reference.
   * @see #setFragmentRole(FragmentRole)
   * @see org.reuseware.coconut.fracol.FracolPackage#getPortType_FragmentRole()
   * @see org.reuseware.coconut.fracol.FragmentRole#getPortTypes
   * @model opposite="portTypes" transient="false" ordered="false"
   * @generated
   */
  FragmentRole getFragmentRole();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fracol.PortType#getFragmentRole <em>Fragment Role</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fragment Role</em>' container reference.
   * @see #getFragmentRole()
   * @generated
   */
  void setFragmentRole(FragmentRole value);

  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see org.reuseware.coconut.fracol.FracolPackage#getPortType_Name()
   * @model required="true"
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fracol.PortType#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // PortType
