/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fracol.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.reuseware.coconut.fracol.CompositionAssociation;
import org.reuseware.coconut.fracol.FracolPackage;
import org.reuseware.coconut.fracol.FragmentCollaboration;
import org.reuseware.coconut.fracol.FragmentRole;
import org.reuseware.coconut.fracol.PortType;




/**
 * @generated
 **/
public abstract class CompositionAssociationImpl extends EObjectImpl implements CompositionAssociation
{


   /**
   * The cached value of the '{@link #getEnd1Role() <em>End1 Role</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEnd1Role()
   * @generated
   * @ordered
   */
  protected FragmentRole end1Role;
  /**
   * The cached value of the '{@link #getEnd1() <em>End1</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEnd1()
   * @generated
   * @ordered
   */
  protected PortType end1;
  /**
   * The cached value of the '{@link #getEnd2Role() <em>End2 Role</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEnd2Role()
   * @generated
   * @ordered
   */
  protected FragmentRole end2Role;
  /**
   * The cached value of the '{@link #getEnd2() <em>End2</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEnd2()
   * @generated
   * @ordered
   */
  protected PortType end2;
  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CompositionAssociationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return FracolPackage.Literals.COMPOSITION_ASSOCIATION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole getEnd1Role()
  {
    if (end1Role != null && end1Role.eIsProxy())
    {
      InternalEObject oldEnd1Role = (InternalEObject)end1Role;
      end1Role = (FragmentRole)eResolveProxy(oldEnd1Role);
      if (end1Role != oldEnd1Role)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, FracolPackage.COMPOSITION_ASSOCIATION__END1_ROLE, oldEnd1Role, end1Role));
      }
    }
    return end1Role;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole basicGetEnd1Role()
  {
    return end1Role;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEnd1Role(FragmentRole newEnd1Role)
  {
    FragmentRole oldEnd1Role = end1Role;
    end1Role = newEnd1Role;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FracolPackage.COMPOSITION_ASSOCIATION__END1_ROLE, oldEnd1Role, end1Role));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType getEnd1()
  {
    if (end1 != null && end1.eIsProxy())
    {
      InternalEObject oldEnd1 = (InternalEObject)end1;
      end1 = (PortType)eResolveProxy(oldEnd1);
      if (end1 != oldEnd1)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, FracolPackage.COMPOSITION_ASSOCIATION__END1, oldEnd1, end1));
      }
    }
    return end1;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType basicGetEnd1()
  {
    return end1;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetEnd1(PortType newEnd1, NotificationChain msgs)
  {
    PortType oldEnd1 = end1;
    end1 = newEnd1;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, FracolPackage.COMPOSITION_ASSOCIATION__END1, oldEnd1, newEnd1);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEnd1(PortType newEnd1)
  {
    if (newEnd1 != end1)
    {
      NotificationChain msgs = null;
      if (end1 != null)
        msgs = ((InternalEObject)end1).eInverseRemove(this, FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS, PortType.class, msgs);
      if (newEnd1 != null)
        msgs = ((InternalEObject)newEnd1).eInverseAdd(this, FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS, PortType.class, msgs);
      msgs = basicSetEnd1(newEnd1, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FracolPackage.COMPOSITION_ASSOCIATION__END1, newEnd1, newEnd1));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole getEnd2Role()
  {
    if (end2Role != null && end2Role.eIsProxy())
    {
      InternalEObject oldEnd2Role = (InternalEObject)end2Role;
      end2Role = (FragmentRole)eResolveProxy(oldEnd2Role);
      if (end2Role != oldEnd2Role)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, FracolPackage.COMPOSITION_ASSOCIATION__END2_ROLE, oldEnd2Role, end2Role));
      }
    }
    return end2Role;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole basicGetEnd2Role()
  {
    return end2Role;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEnd2Role(FragmentRole newEnd2Role)
  {
    FragmentRole oldEnd2Role = end2Role;
    end2Role = newEnd2Role;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FracolPackage.COMPOSITION_ASSOCIATION__END2_ROLE, oldEnd2Role, end2Role));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType getEnd2()
  {
    if (end2 != null && end2.eIsProxy())
    {
      InternalEObject oldEnd2 = (InternalEObject)end2;
      end2 = (PortType)eResolveProxy(oldEnd2);
      if (end2 != oldEnd2)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, FracolPackage.COMPOSITION_ASSOCIATION__END2, oldEnd2, end2));
      }
    }
    return end2;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType basicGetEnd2()
  {
    return end2;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetEnd2(PortType newEnd2, NotificationChain msgs)
  {
    PortType oldEnd2 = end2;
    end2 = newEnd2;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, FracolPackage.COMPOSITION_ASSOCIATION__END2, oldEnd2, newEnd2);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEnd2(PortType newEnd2)
  {
    if (newEnd2 != end2)
    {
      NotificationChain msgs = null;
      if (end2 != null)
        msgs = ((InternalEObject)end2).eInverseRemove(this, FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS2, PortType.class, msgs);
      if (newEnd2 != null)
        msgs = ((InternalEObject)newEnd2).eInverseAdd(this, FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS2, PortType.class, msgs);
      msgs = basicSetEnd2(newEnd2, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FracolPackage.COMPOSITION_ASSOCIATION__END2, newEnd2, newEnd2));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentCollaboration getFragmentCollaboration()
  {
    if (eContainerFeatureID() != FracolPackage.COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION) return null;
    return (FragmentCollaboration)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetFragmentCollaboration(FragmentCollaboration newFragmentCollaboration, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newFragmentCollaboration, FracolPackage.COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFragmentCollaboration(FragmentCollaboration newFragmentCollaboration)
  {
    if (newFragmentCollaboration != eInternalContainer() || (eContainerFeatureID() != FracolPackage.COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION && newFragmentCollaboration != null))
    {
      if (EcoreUtil.isAncestor(this, newFragmentCollaboration))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newFragmentCollaboration != null)
        msgs = ((InternalEObject)newFragmentCollaboration).eInverseAdd(this, FracolPackage.FRAGMENT_COLLABORATION__COMPOSITION_ASSOCIATIONS, FragmentCollaboration.class, msgs);
      msgs = basicSetFragmentCollaboration(newFragmentCollaboration, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FracolPackage.COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION, newFragmentCollaboration, newFragmentCollaboration));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FracolPackage.COMPOSITION_ASSOCIATION__NAME, oldName, name));
  }

  public void removeYou()
   {
      this.setEnd1Role (null);
      this.setEnd1 (null);
      this.setEnd2Role (null);
      this.setEnd2 (null);
      this.setFragmentCollaboration (null);
   }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FracolPackage.COMPOSITION_ASSOCIATION__END1:
        if (end1 != null)
          msgs = ((InternalEObject)end1).eInverseRemove(this, FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS, PortType.class, msgs);
        return basicSetEnd1((PortType)otherEnd, msgs);
      case FracolPackage.COMPOSITION_ASSOCIATION__END2:
        if (end2 != null)
          msgs = ((InternalEObject)end2).eInverseRemove(this, FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS2, PortType.class, msgs);
        return basicSetEnd2((PortType)otherEnd, msgs);
      case FracolPackage.COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetFragmentCollaboration((FragmentCollaboration)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FracolPackage.COMPOSITION_ASSOCIATION__END1:
        return basicSetEnd1(null, msgs);
      case FracolPackage.COMPOSITION_ASSOCIATION__END2:
        return basicSetEnd2(null, msgs);
      case FracolPackage.COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION:
        return basicSetFragmentCollaboration(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case FracolPackage.COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION:
        return eInternalContainer().eInverseRemove(this, FracolPackage.FRAGMENT_COLLABORATION__COMPOSITION_ASSOCIATIONS, FragmentCollaboration.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case FracolPackage.COMPOSITION_ASSOCIATION__END1_ROLE:
        if (resolve) return getEnd1Role();
        return basicGetEnd1Role();
      case FracolPackage.COMPOSITION_ASSOCIATION__END1:
        if (resolve) return getEnd1();
        return basicGetEnd1();
      case FracolPackage.COMPOSITION_ASSOCIATION__END2_ROLE:
        if (resolve) return getEnd2Role();
        return basicGetEnd2Role();
      case FracolPackage.COMPOSITION_ASSOCIATION__END2:
        if (resolve) return getEnd2();
        return basicGetEnd2();
      case FracolPackage.COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION:
        return getFragmentCollaboration();
      case FracolPackage.COMPOSITION_ASSOCIATION__NAME:
        return getName();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case FracolPackage.COMPOSITION_ASSOCIATION__END1_ROLE:
        setEnd1Role((FragmentRole)newValue);
        return;
      case FracolPackage.COMPOSITION_ASSOCIATION__END1:
        setEnd1((PortType)newValue);
        return;
      case FracolPackage.COMPOSITION_ASSOCIATION__END2_ROLE:
        setEnd2Role((FragmentRole)newValue);
        return;
      case FracolPackage.COMPOSITION_ASSOCIATION__END2:
        setEnd2((PortType)newValue);
        return;
      case FracolPackage.COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION:
        setFragmentCollaboration((FragmentCollaboration)newValue);
        return;
      case FracolPackage.COMPOSITION_ASSOCIATION__NAME:
        setName((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case FracolPackage.COMPOSITION_ASSOCIATION__END1_ROLE:
        setEnd1Role((FragmentRole)null);
        return;
      case FracolPackage.COMPOSITION_ASSOCIATION__END1:
        setEnd1((PortType)null);
        return;
      case FracolPackage.COMPOSITION_ASSOCIATION__END2_ROLE:
        setEnd2Role((FragmentRole)null);
        return;
      case FracolPackage.COMPOSITION_ASSOCIATION__END2:
        setEnd2((PortType)null);
        return;
      case FracolPackage.COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION:
        setFragmentCollaboration((FragmentCollaboration)null);
        return;
      case FracolPackage.COMPOSITION_ASSOCIATION__NAME:
        setName(NAME_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case FracolPackage.COMPOSITION_ASSOCIATION__END1_ROLE:
        return end1Role != null;
      case FracolPackage.COMPOSITION_ASSOCIATION__END1:
        return end1 != null;
      case FracolPackage.COMPOSITION_ASSOCIATION__END2_ROLE:
        return end2Role != null;
      case FracolPackage.COMPOSITION_ASSOCIATION__END2:
        return end2 != null;
      case FracolPackage.COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION:
        return getFragmentCollaboration() != null;
      case FracolPackage.COMPOSITION_ASSOCIATION__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(')');
    return result.toString();
  }
}


