/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fracol.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.reuseware.coconut.fracol.CompositionAssociation;
import org.reuseware.coconut.fracol.Configuration;
import org.reuseware.coconut.fracol.Contribution;
import org.reuseware.coconut.fracol.DynamicPortType;
import org.reuseware.coconut.fracol.FracolFactory;
import org.reuseware.coconut.fracol.FracolPackage;
import org.reuseware.coconut.fracol.FragmentCollaboration;
import org.reuseware.coconut.fracol.FragmentRole;
import org.reuseware.coconut.fracol.PortType;
import org.reuseware.coconut.fracol.StaticPortType;

import org.reuseware.coconut.fracol.util.FracolValidator;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class FracolPackageImpl extends EPackageImpl implements FracolPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass compositionAssociationEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass configurationEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass contributionEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass dynamicPortTypeEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass fragmentCollaborationEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass fragmentRoleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass portTypeEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass staticPortTypeEClass = null;

  /**
   * Creates an instance of the model <b>Package</b>, registered with
   * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
   * package URI value.
   * <p>Note: the correct way to create the package is via the static
   * factory method {@link #init init()}, which also performs
   * initialization of the package, or returns the registered package,
   * if one already exists.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.ecore.EPackage.Registry
   * @see org.reuseware.coconut.fracol.FracolPackage#eNS_URI
   * @see #init()
   * @generated
   */
  private FracolPackageImpl()
  {
    super(eNS_URI, FracolFactory.eINSTANCE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static boolean isInited = false;

  /**
   * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
   * 
   * <p>This method is used to initialize {@link FracolPackage#eINSTANCE} when that field is accessed.
   * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #eNS_URI
   * @see #createPackageContents()
   * @see #initializePackageContents()
   * @generated
   */
  public static FracolPackage init()
  {
    if (isInited) return (FracolPackage)EPackage.Registry.INSTANCE.getEPackage(FracolPackage.eNS_URI);

    // Obtain or create and register package
    FracolPackageImpl theFracolPackage = (FracolPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof FracolPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new FracolPackageImpl());

    isInited = true;

    // Create package meta-data objects
    theFracolPackage.createPackageContents();

    // Initialize created meta-data
    theFracolPackage.initializePackageContents();

    // Register package validator
    EValidator.Registry.INSTANCE.put
      (theFracolPackage, 
       new EValidator.Descriptor()
       {
         public EValidator getEValidator()
         {
           return FracolValidator.INSTANCE;
         }
       });

    // Mark meta-data to indicate it can't be changed
    theFracolPackage.freeze();

  
    // Update the registry and return the package
    EPackage.Registry.INSTANCE.put(FracolPackage.eNS_URI, theFracolPackage);
    return theFracolPackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getCompositionAssociation()
  {
    return compositionAssociationEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionAssociation_End1Role()
  {
    return (EReference)compositionAssociationEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionAssociation_End1()
  {
    return (EReference)compositionAssociationEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionAssociation_End2Role()
  {
    return (EReference)compositionAssociationEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionAssociation_End2()
  {
    return (EReference)compositionAssociationEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getCompositionAssociation_FragmentCollaboration()
  {
    return (EReference)compositionAssociationEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getCompositionAssociation_Name()
  {
    return (EAttribute)compositionAssociationEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getConfiguration()
  {
    return configurationEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getContribution()
  {
    return contributionEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getDynamicPortType()
  {
    return dynamicPortTypeEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getFragmentCollaboration()
  {
    return fragmentCollaborationEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentCollaboration_CompositionAssociations()
  {
    return (EReference)fragmentCollaborationEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentCollaboration_FracolName()
  {
    return (EAttribute)fragmentCollaborationEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentCollaboration_FracolNamespace()
  {
    return (EAttribute)fragmentCollaborationEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentCollaboration_FragmentRoles()
  {
    return (EReference)fragmentCollaborationEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getFragmentRole()
  {
    return fragmentRoleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentRole_FragmentCollaboration()
  {
    return (EReference)fragmentRoleEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getFragmentRole_Name()
  {
    return (EAttribute)fragmentRoleEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getFragmentRole_PortTypes()
  {
    return (EReference)fragmentRoleEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getPortType()
  {
    return portTypeEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPortType_CompositionAssociations2()
  {
    return (EReference)portTypeEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPortType_CompositionAssociations()
  {
    return (EReference)portTypeEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getPortType_FragmentRole()
  {
    return (EReference)portTypeEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getPortType_Name()
  {
    return (EAttribute)portTypeEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getStaticPortType()
  {
    return staticPortTypeEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FracolFactory getFracolFactory()
  {
    return (FracolFactory)getEFactoryInstance();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isCreated = false;

  /**
   * Creates the meta-model objects for the package.  This method is
   * guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void createPackageContents()
  {
    if (isCreated) return;
    isCreated = true;

    // Create classes and their features
    compositionAssociationEClass = createEClass(COMPOSITION_ASSOCIATION);
    createEReference(compositionAssociationEClass, COMPOSITION_ASSOCIATION__END1_ROLE);
    createEReference(compositionAssociationEClass, COMPOSITION_ASSOCIATION__END1);
    createEReference(compositionAssociationEClass, COMPOSITION_ASSOCIATION__END2_ROLE);
    createEReference(compositionAssociationEClass, COMPOSITION_ASSOCIATION__END2);
    createEReference(compositionAssociationEClass, COMPOSITION_ASSOCIATION__FRAGMENT_COLLABORATION);
    createEAttribute(compositionAssociationEClass, COMPOSITION_ASSOCIATION__NAME);

    configurationEClass = createEClass(CONFIGURATION);

    contributionEClass = createEClass(CONTRIBUTION);

    dynamicPortTypeEClass = createEClass(DYNAMIC_PORT_TYPE);

    fragmentCollaborationEClass = createEClass(FRAGMENT_COLLABORATION);
    createEReference(fragmentCollaborationEClass, FRAGMENT_COLLABORATION__COMPOSITION_ASSOCIATIONS);
    createEAttribute(fragmentCollaborationEClass, FRAGMENT_COLLABORATION__FRACOL_NAME);
    createEAttribute(fragmentCollaborationEClass, FRAGMENT_COLLABORATION__FRACOL_NAMESPACE);
    createEReference(fragmentCollaborationEClass, FRAGMENT_COLLABORATION__FRAGMENT_ROLES);

    fragmentRoleEClass = createEClass(FRAGMENT_ROLE);
    createEReference(fragmentRoleEClass, FRAGMENT_ROLE__FRAGMENT_COLLABORATION);
    createEAttribute(fragmentRoleEClass, FRAGMENT_ROLE__NAME);
    createEReference(fragmentRoleEClass, FRAGMENT_ROLE__PORT_TYPES);

    portTypeEClass = createEClass(PORT_TYPE);
    createEReference(portTypeEClass, PORT_TYPE__COMPOSITION_ASSOCIATIONS2);
    createEReference(portTypeEClass, PORT_TYPE__COMPOSITION_ASSOCIATIONS);
    createEReference(portTypeEClass, PORT_TYPE__FRAGMENT_ROLE);
    createEAttribute(portTypeEClass, PORT_TYPE__NAME);

    staticPortTypeEClass = createEClass(STATIC_PORT_TYPE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isInitialized = false;

  /**
   * Complete the initialization of the package and its meta-model.  This
   * method is guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void initializePackageContents()
  {
    if (isInitialized) return;
    isInitialized = true;

    // Initialize package
    setName(eNAME);
    setNsPrefix(eNS_PREFIX);
    setNsURI(eNS_URI);

    // Create type parameters

    // Set bounds for type parameters

    // Add supertypes to classes
    configurationEClass.getESuperTypes().add(this.getCompositionAssociation());
    contributionEClass.getESuperTypes().add(this.getCompositionAssociation());
    dynamicPortTypeEClass.getESuperTypes().add(this.getPortType());
    staticPortTypeEClass.getESuperTypes().add(this.getPortType());

    // Initialize classes and features; add operations and parameters
    initEClass(compositionAssociationEClass, CompositionAssociation.class, "CompositionAssociation", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getCompositionAssociation_End1Role(), this.getFragmentRole(), null, "end1Role", null, 1, 1, CompositionAssociation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getCompositionAssociation_End1(), this.getPortType(), this.getPortType_CompositionAssociations(), "end1", null, 1, 1, CompositionAssociation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getCompositionAssociation_End2Role(), this.getFragmentRole(), null, "end2Role", null, 1, 1, CompositionAssociation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getCompositionAssociation_End2(), this.getPortType(), this.getPortType_CompositionAssociations2(), "end2", null, 1, 1, CompositionAssociation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getCompositionAssociation_FragmentCollaboration(), this.getFragmentCollaboration(), this.getFragmentCollaboration_CompositionAssociations(), "fragmentCollaboration", null, 0, 1, CompositionAssociation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getCompositionAssociation_Name(), ecorePackage.getEString(), "name", null, 1, 1, CompositionAssociation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(compositionAssociationEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(configurationEClass, Configuration.class, "Configuration", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(configurationEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(contributionEClass, Contribution.class, "Contribution", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(contributionEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(dynamicPortTypeEClass, DynamicPortType.class, "DynamicPortType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(dynamicPortTypeEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(fragmentCollaborationEClass, FragmentCollaboration.class, "FragmentCollaboration", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getFragmentCollaboration_CompositionAssociations(), this.getCompositionAssociation(), this.getCompositionAssociation_FragmentCollaboration(), "compositionAssociations", null, 0, -1, FragmentCollaboration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    getFragmentCollaboration_CompositionAssociations().getEKeys().add(this.getCompositionAssociation_Name());
    initEAttribute(getFragmentCollaboration_FracolName(), ecorePackage.getEString(), "fracolName", null, 1, 1, FragmentCollaboration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getFragmentCollaboration_FracolNamespace(), ecorePackage.getEString(), "fracolNamespace", null, 0, -1, FragmentCollaboration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getFragmentCollaboration_FragmentRoles(), this.getFragmentRole(), this.getFragmentRole_FragmentCollaboration(), "fragmentRoles", null, 0, -1, FragmentCollaboration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    getFragmentCollaboration_FragmentRoles().getEKeys().add(this.getFragmentRole_Name());

    EOperation op = addEOperation(fragmentCollaborationEClass, this.getCompositionAssociation(), "getCompositionAssociation", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, ecorePackage.getEString(), "name", 0, 1, IS_UNIQUE, IS_ORDERED);

    op = addEOperation(fragmentCollaborationEClass, this.getFragmentRole(), "getFragmentRole", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, ecorePackage.getEString(), "fragmentRoleName", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(fragmentCollaborationEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(fragmentRoleEClass, FragmentRole.class, "FragmentRole", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getFragmentRole_FragmentCollaboration(), this.getFragmentCollaboration(), this.getFragmentCollaboration_FragmentRoles(), "fragmentCollaboration", null, 0, 1, FragmentRole.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getFragmentRole_Name(), ecorePackage.getEString(), "name", null, 1, 1, FragmentRole.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getFragmentRole_PortTypes(), this.getPortType(), this.getPortType_FragmentRole(), "portTypes", null, 0, -1, FragmentRole.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    getFragmentRole_PortTypes().getEKeys().add(this.getPortType_Name());

    op = addEOperation(fragmentRoleEClass, this.getPortType(), "getPortType", 0, 1, IS_UNIQUE, IS_ORDERED);
    addEParameter(op, ecorePackage.getEString(), "portTypeName", 0, 1, IS_UNIQUE, IS_ORDERED);

    addEOperation(fragmentRoleEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(portTypeEClass, PortType.class, "PortType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getPortType_CompositionAssociations2(), this.getCompositionAssociation(), this.getCompositionAssociation_End2(), "compositionAssociations2", null, 0, -1, PortType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getPortType_CompositionAssociations(), this.getCompositionAssociation(), this.getCompositionAssociation_End1(), "compositionAssociations", null, 0, -1, PortType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEReference(getPortType_FragmentRole(), this.getFragmentRole(), this.getFragmentRole_PortTypes(), "fragmentRole", null, 0, 1, PortType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
    initEAttribute(getPortType_Name(), ecorePackage.getEString(), "name", null, 1, 1, PortType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    addEOperation(portTypeEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    initEClass(staticPortTypeEClass, StaticPortType.class, "StaticPortType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    addEOperation(staticPortTypeEClass, null, "removeYou", 0, 1, IS_UNIQUE, IS_ORDERED);

    // Create resource
    createResource(eNS_URI);

    // Create annotations
    // http://www.eclipse.org/emf/2002/Ecore
    createEcoreAnnotations();
  }

  /**
   * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createEcoreAnnotations()
  {
    String source = "http://www.eclipse.org/emf/2002/Ecore";		
    addAnnotation
      (fragmentCollaborationEClass, 
       source, 
       new String[] 
       {
       "constraints", "All"
       });
  }

} //FracolPackageImpl
