/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fracol.impl;


import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.fracol.FracolPackage;
import org.reuseware.coconut.fracol.FragmentCollaboration;
import org.reuseware.coconut.fracol.FragmentRole;
import java.util.*;
import org.reuseware.coconut.fracol.PortType;


/**
 * @generated
 **/
public class FragmentRoleImpl extends EObjectImpl implements FragmentRole
{


   /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;
  /**
   * The cached value of the '{@link #getPortTypes() <em>Port Types</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPortTypes()
   * @generated
   * @ordered
   */
  protected EList<PortType> portTypes;


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FragmentRoleImpl()
  {
    super();
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return FracolPackage.Literals.FRAGMENT_ROLE;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentCollaboration getFragmentCollaboration()
  {
    if (eContainerFeatureID() != FracolPackage.FRAGMENT_ROLE__FRAGMENT_COLLABORATION) return null;
    return (FragmentCollaboration)eContainer();
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetFragmentCollaboration(FragmentCollaboration newFragmentCollaboration, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newFragmentCollaboration, FracolPackage.FRAGMENT_ROLE__FRAGMENT_COLLABORATION, msgs);
    return msgs;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFragmentCollaboration(FragmentCollaboration newFragmentCollaboration)
  {
    if (newFragmentCollaboration != eInternalContainer() || (eContainerFeatureID() != FracolPackage.FRAGMENT_ROLE__FRAGMENT_COLLABORATION && newFragmentCollaboration != null))
    {
      if (EcoreUtil.isAncestor(this, newFragmentCollaboration))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newFragmentCollaboration != null)
        msgs = ((InternalEObject)newFragmentCollaboration).eInverseAdd(this, FracolPackage.FRAGMENT_COLLABORATION__FRAGMENT_ROLES, FragmentCollaboration.class, msgs);
      msgs = basicSetFragmentCollaboration(newFragmentCollaboration, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FracolPackage.FRAGMENT_ROLE__FRAGMENT_COLLABORATION, newFragmentCollaboration, newFragmentCollaboration));
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FracolPackage.FRAGMENT_ROLE__NAME, oldName, name));
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<PortType> getPortTypes()
  {
    if (portTypes == null)
    {
      portTypes = new EObjectContainmentWithInverseEList<PortType>(PortType.class, this, FracolPackage.FRAGMENT_ROLE__PORT_TYPES, FracolPackage.PORT_TYPE__FRAGMENT_ROLE);
    }
    return portTypes;
  }


  public PortType getPortType (String portTypeName ){
      boolean fujaba__Success = false;
      Iterator<PortType> fujaba__IterThisToStaticPortType = null;
      PortType staticPortType = null;

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link portTypes from this to staticPortType
         fujaba__Success = false;
         fujaba__IterThisToStaticPortType = this.getPortTypes().iterator ();

         while ( !(fujaba__Success) && fujaba__IterThisToStaticPortType.hasNext () )
         {
            try
            {
               staticPortType = (PortType) fujaba__IterThisToStaticPortType.next ();

               // check object staticPortType is really bound
               if (!( staticPortType != null )) {throw new Exception("SDMException");};
               // attribute condition
               if (!( portTypeName.equals(staticPortType.getName ()) )) {throw new Exception("SDMException");};


               fujaba__Success = true;
            }
            catch ( Exception fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         if (!(fujaba__Success)) {throw new Exception("SDMException");};
         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         return staticPortType;

      }
      else
      {
         return null;

      }

   }


   public void removeYou()
   {
      this.setFragmentCollaboration (null);
      this.getPortTypes().clear();
   }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FracolPackage.FRAGMENT_ROLE__FRAGMENT_COLLABORATION:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetFragmentCollaboration((FragmentCollaboration)otherEnd, msgs);
      case FracolPackage.FRAGMENT_ROLE__PORT_TYPES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getPortTypes()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FracolPackage.FRAGMENT_ROLE__FRAGMENT_COLLABORATION:
        return basicSetFragmentCollaboration(null, msgs);
      case FracolPackage.FRAGMENT_ROLE__PORT_TYPES:
        return ((InternalEList<?>)getPortTypes()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case FracolPackage.FRAGMENT_ROLE__FRAGMENT_COLLABORATION:
        return eInternalContainer().eInverseRemove(this, FracolPackage.FRAGMENT_COLLABORATION__FRAGMENT_ROLES, FragmentCollaboration.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case FracolPackage.FRAGMENT_ROLE__FRAGMENT_COLLABORATION:
        return getFragmentCollaboration();
      case FracolPackage.FRAGMENT_ROLE__NAME:
        return getName();
      case FracolPackage.FRAGMENT_ROLE__PORT_TYPES:
        return getPortTypes();
    }
    return super.eGet(featureID, resolve, coreType);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case FracolPackage.FRAGMENT_ROLE__FRAGMENT_COLLABORATION:
        setFragmentCollaboration((FragmentCollaboration)newValue);
        return;
      case FracolPackage.FRAGMENT_ROLE__NAME:
        setName((String)newValue);
        return;
      case FracolPackage.FRAGMENT_ROLE__PORT_TYPES:
        getPortTypes().clear();
        getPortTypes().addAll((Collection<? extends PortType>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case FracolPackage.FRAGMENT_ROLE__FRAGMENT_COLLABORATION:
        setFragmentCollaboration((FragmentCollaboration)null);
        return;
      case FracolPackage.FRAGMENT_ROLE__NAME:
        setName(NAME_EDEFAULT);
        return;
      case FracolPackage.FRAGMENT_ROLE__PORT_TYPES:
        getPortTypes().clear();
        return;
    }
    super.eUnset(featureID);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case FracolPackage.FRAGMENT_ROLE__FRAGMENT_COLLABORATION:
        return getFragmentCollaboration() != null;
      case FracolPackage.FRAGMENT_ROLE__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case FracolPackage.FRAGMENT_ROLE__PORT_TYPES:
        return portTypes != null && !portTypes.isEmpty();
    }
    return super.eIsSet(featureID);
  }


  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(')');
    return result.toString();
  }
}


