/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fracol.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.fracol.CompositionAssociation;
import org.reuseware.coconut.fracol.FracolPackage;
import org.reuseware.coconut.fracol.FragmentRole;
import org.reuseware.coconut.fracol.PortType;




/**
 * @generated
 **/
public abstract class PortTypeImpl extends EObjectImpl implements PortType
{


   /**
   * The cached value of the '{@link #getCompositionAssociations2() <em>Composition Associations2</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCompositionAssociations2()
   * @generated
   * @ordered
   */
  protected EList<CompositionAssociation> compositionAssociations2;
  /**
   * The cached value of the '{@link #getCompositionAssociations() <em>Composition Associations</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCompositionAssociations()
   * @generated
   * @ordered
   */
  protected EList<CompositionAssociation> compositionAssociations;
  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PortTypeImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return FracolPackage.Literals.PORT_TYPE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<CompositionAssociation> getCompositionAssociations2()
  {
    if (compositionAssociations2 == null)
    {
      compositionAssociations2 = new EObjectWithInverseResolvingEList<CompositionAssociation>(CompositionAssociation.class, this, FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS2, FracolPackage.COMPOSITION_ASSOCIATION__END2);
    }
    return compositionAssociations2;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<CompositionAssociation> getCompositionAssociations()
  {
    if (compositionAssociations == null)
    {
      compositionAssociations = new EObjectWithInverseResolvingEList<CompositionAssociation>(CompositionAssociation.class, this, FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS, FracolPackage.COMPOSITION_ASSOCIATION__END1);
    }
    return compositionAssociations;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole getFragmentRole()
  {
    if (eContainerFeatureID() != FracolPackage.PORT_TYPE__FRAGMENT_ROLE) return null;
    return (FragmentRole)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetFragmentRole(FragmentRole newFragmentRole, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newFragmentRole, FracolPackage.PORT_TYPE__FRAGMENT_ROLE, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFragmentRole(FragmentRole newFragmentRole)
  {
    if (newFragmentRole != eInternalContainer() || (eContainerFeatureID() != FracolPackage.PORT_TYPE__FRAGMENT_ROLE && newFragmentRole != null))
    {
      if (EcoreUtil.isAncestor(this, newFragmentRole))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newFragmentRole != null)
        msgs = ((InternalEObject)newFragmentRole).eInverseAdd(this, FracolPackage.FRAGMENT_ROLE__PORT_TYPES, FragmentRole.class, msgs);
      msgs = basicSetFragmentRole(newFragmentRole, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FracolPackage.PORT_TYPE__FRAGMENT_ROLE, newFragmentRole, newFragmentRole));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FracolPackage.PORT_TYPE__NAME, oldName, name));
  }

  public void removeYou()
   {
      this.getCompositionAssociations2().clear();
      this.getCompositionAssociations().clear();
      this.setFragmentRole (null);
   }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS2:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getCompositionAssociations2()).basicAdd(otherEnd, msgs);
      case FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getCompositionAssociations()).basicAdd(otherEnd, msgs);
      case FracolPackage.PORT_TYPE__FRAGMENT_ROLE:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetFragmentRole((FragmentRole)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS2:
        return ((InternalEList<?>)getCompositionAssociations2()).basicRemove(otherEnd, msgs);
      case FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS:
        return ((InternalEList<?>)getCompositionAssociations()).basicRemove(otherEnd, msgs);
      case FracolPackage.PORT_TYPE__FRAGMENT_ROLE:
        return basicSetFragmentRole(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case FracolPackage.PORT_TYPE__FRAGMENT_ROLE:
        return eInternalContainer().eInverseRemove(this, FracolPackage.FRAGMENT_ROLE__PORT_TYPES, FragmentRole.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS2:
        return getCompositionAssociations2();
      case FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS:
        return getCompositionAssociations();
      case FracolPackage.PORT_TYPE__FRAGMENT_ROLE:
        return getFragmentRole();
      case FracolPackage.PORT_TYPE__NAME:
        return getName();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS2:
        getCompositionAssociations2().clear();
        getCompositionAssociations2().addAll((Collection<? extends CompositionAssociation>)newValue);
        return;
      case FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS:
        getCompositionAssociations().clear();
        getCompositionAssociations().addAll((Collection<? extends CompositionAssociation>)newValue);
        return;
      case FracolPackage.PORT_TYPE__FRAGMENT_ROLE:
        setFragmentRole((FragmentRole)newValue);
        return;
      case FracolPackage.PORT_TYPE__NAME:
        setName((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS2:
        getCompositionAssociations2().clear();
        return;
      case FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS:
        getCompositionAssociations().clear();
        return;
      case FracolPackage.PORT_TYPE__FRAGMENT_ROLE:
        setFragmentRole((FragmentRole)null);
        return;
      case FracolPackage.PORT_TYPE__NAME:
        setName(NAME_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS2:
        return compositionAssociations2 != null && !compositionAssociations2.isEmpty();
      case FracolPackage.PORT_TYPE__COMPOSITION_ASSOCIATIONS:
        return compositionAssociations != null && !compositionAssociations.isEmpty();
      case FracolPackage.PORT_TYPE__FRAGMENT_ROLE:
        return getFragmentRole() != null;
      case FracolPackage.PORT_TYPE__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(')');
    return result.toString();
  }
}


