/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.fracol.resource.fracol.grammar;

/**
 * This class provides the follow sets for all terminals of the grammar. These
 * sets are used during code completion.
 */
public class FracolFollowSetProvider {
	
	public final static org.reuseware.coconut.fracol.resource.fracol.IFracolExpectedElement TERMINALS[] = new org.reuseware.coconut.fracol.resource.fracol.IFracolExpectedElement[45];
	
	public final static org.eclipse.emf.ecore.EStructuralFeature[] FEATURES = new org.eclipse.emf.ecore.EStructuralFeature[3];
	
	public final static org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] LINKS = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[31];
	
	public final static org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] EMPTY_LINK_ARRAY = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[0];
	
	public static void initializeTerminals0() {
		TERMINALS[0] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_0_0_0_0);
		TERMINALS[1] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_0_0_0_1_0_0_0);
		TERMINALS[2] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_0_0_0_2);
		TERMINALS[3] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_0_0_0_1_0_0_1);
		TERMINALS[4] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_0_0_0_3);
		TERMINALS[5] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_1_0_0_1);
		TERMINALS[6] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_4_0_0_1);
		TERMINALS[7] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_5_0_0_1);
		TERMINALS[8] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_0_0_0_6);
		TERMINALS[9] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_1_0_0_2);
		TERMINALS[10] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_1_0_0_3);
		TERMINALS[11] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_1_0_0_5);
		TERMINALS[12] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_2_0_0_1);
		TERMINALS[13] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_3_0_0_1);
		TERMINALS[14] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_1_0_0_8);
		TERMINALS[15] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_2_0_0_2);
		TERMINALS[16] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_2_0_0_3);
		TERMINALS[17] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_2_0_0_4);
		TERMINALS[18] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_2_0_0_5);
		TERMINALS[19] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_3_0_0_2);
		TERMINALS[20] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_3_0_0_3);
		TERMINALS[21] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_3_0_0_4);
		TERMINALS[22] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_3_0_0_5);
		TERMINALS[23] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_4_0_0_2);
		TERMINALS[24] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_4_0_0_3);
		TERMINALS[25] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_4_0_0_5);
		TERMINALS[26] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_4_0_0_7);
		TERMINALS[27] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_4_0_0_8);
		TERMINALS[28] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_4_0_0_9);
		TERMINALS[29] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_4_0_0_11);
		TERMINALS[30] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_4_0_0_13);
		TERMINALS[31] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_4_0_0_14);
		TERMINALS[32] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_4_0_0_15);
		TERMINALS[33] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_4_0_0_17);
		TERMINALS[34] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_5_0_0_2);
		TERMINALS[35] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_5_0_0_3);
		TERMINALS[36] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_5_0_0_5);
		TERMINALS[37] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_5_0_0_7);
		TERMINALS[38] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_5_0_0_8);
		TERMINALS[39] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_5_0_0_9);
		TERMINALS[40] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_5_0_0_11);
		TERMINALS[41] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_5_0_0_13);
		TERMINALS[42] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_5_0_0_14);
		TERMINALS[43] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedStructuralFeature(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_5_0_0_15);
		TERMINALS[44] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolExpectedCsString(org.reuseware.coconut.fracol.resource.fracol.grammar.FracolGrammarInformationProvider.FRACOL_5_0_0_17);
	}
	
	public static void initializeTerminals() {
		initializeTerminals0();
	}
	
	public static void initializeFeatures0() {
		FEATURES[0] = org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentCollaboration().getEStructuralFeature(org.reuseware.coconut.fracol.FracolPackage.FRAGMENT_COLLABORATION__FRAGMENT_ROLES);
		FEATURES[1] = org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentCollaboration().getEStructuralFeature(org.reuseware.coconut.fracol.FracolPackage.FRAGMENT_COLLABORATION__COMPOSITION_ASSOCIATIONS);
		FEATURES[2] = org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentRole().getEStructuralFeature(org.reuseware.coconut.fracol.FracolPackage.FRAGMENT_ROLE__PORT_TYPES);
	}
	
	public static void initializeFeatures() {
		initializeFeatures0();
	}
	
	public static void initializeLinks0() {
		LINKS[0] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentRole(), FEATURES[0]);
		LINKS[1] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getConfiguration(), FEATURES[1]);
		LINKS[2] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getContribution(), FEATURES[1]);
		LINKS[3] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentRole(), FEATURES[0]);
		LINKS[4] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getConfiguration(), FEATURES[1]);
		LINKS[5] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getContribution(), FEATURES[1]);
		LINKS[6] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentRole(), FEATURES[0]);
		LINKS[7] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getConfiguration(), FEATURES[1]);
		LINKS[8] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getContribution(), FEATURES[1]);
		LINKS[9] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentRole(), FEATURES[0]);
		LINKS[10] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getConfiguration(), FEATURES[1]);
		LINKS[11] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getContribution(), FEATURES[1]);
		LINKS[12] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getStaticPortType(), FEATURES[2]);
		LINKS[13] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getDynamicPortType(), FEATURES[2]);
		LINKS[14] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getStaticPortType(), FEATURES[2]);
		LINKS[15] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getDynamicPortType(), FEATURES[2]);
		LINKS[16] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getStaticPortType(), FEATURES[2]);
		LINKS[17] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getDynamicPortType(), FEATURES[2]);
		LINKS[18] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentRole(), FEATURES[0]);
		LINKS[19] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getConfiguration(), FEATURES[1]);
		LINKS[20] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getContribution(), FEATURES[1]);
		LINKS[21] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getStaticPortType(), FEATURES[2]);
		LINKS[22] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getDynamicPortType(), FEATURES[2]);
		LINKS[23] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getStaticPortType(), FEATURES[2]);
		LINKS[24] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getDynamicPortType(), FEATURES[2]);
		LINKS[25] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentRole(), FEATURES[0]);
		LINKS[26] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getConfiguration(), FEATURES[1]);
		LINKS[27] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getContribution(), FEATURES[1]);
		LINKS[28] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentRole(), FEATURES[0]);
		LINKS[29] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getConfiguration(), FEATURES[1]);
		LINKS[30] = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getContribution(), FEATURES[1]);
	}
	
	public static void initializeLinks() {
		initializeLinks0();
	}
	
	public static void wire0() {
		TERMINALS[0].addFollower(TERMINALS[1], EMPTY_LINK_ARRAY);
		TERMINALS[0].addFollower(TERMINALS[2], EMPTY_LINK_ARRAY);
		TERMINALS[1].addFollower(TERMINALS[3], EMPTY_LINK_ARRAY);
		TERMINALS[3].addFollower(TERMINALS[1], EMPTY_LINK_ARRAY);
		TERMINALS[3].addFollower(TERMINALS[2], EMPTY_LINK_ARRAY);
		TERMINALS[2].addFollower(TERMINALS[4], EMPTY_LINK_ARRAY);
		TERMINALS[4].addFollower(TERMINALS[5], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentRole(), FEATURES[0]), });
		TERMINALS[4].addFollower(TERMINALS[6], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getConfiguration(), FEATURES[1]), });
		TERMINALS[4].addFollower(TERMINALS[7], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getContribution(), FEATURES[1]), });
		TERMINALS[4].addFollower(TERMINALS[8], EMPTY_LINK_ARRAY);
		TERMINALS[5].addFollower(TERMINALS[9], EMPTY_LINK_ARRAY);
		TERMINALS[9].addFollower(TERMINALS[10], EMPTY_LINK_ARRAY);
		TERMINALS[10].addFollower(TERMINALS[11], EMPTY_LINK_ARRAY);
		TERMINALS[11].addFollower(TERMINALS[12], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getStaticPortType(), FEATURES[2]), });
		TERMINALS[11].addFollower(TERMINALS[13], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getDynamicPortType(), FEATURES[2]), });
		TERMINALS[11].addFollower(TERMINALS[14], EMPTY_LINK_ARRAY);
		TERMINALS[14].addFollower(TERMINALS[5], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentRole(), FEATURES[0]), });
		TERMINALS[14].addFollower(TERMINALS[6], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getConfiguration(), FEATURES[1]), });
		TERMINALS[14].addFollower(TERMINALS[7], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getContribution(), FEATURES[1]), });
		TERMINALS[14].addFollower(TERMINALS[8], EMPTY_LINK_ARRAY);
		TERMINALS[12].addFollower(TERMINALS[15], EMPTY_LINK_ARRAY);
		TERMINALS[15].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[16].addFollower(TERMINALS[17], EMPTY_LINK_ARRAY);
		TERMINALS[17].addFollower(TERMINALS[18], EMPTY_LINK_ARRAY);
		TERMINALS[18].addFollower(TERMINALS[12], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getStaticPortType(), FEATURES[2]), });
		TERMINALS[18].addFollower(TERMINALS[13], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getDynamicPortType(), FEATURES[2]), });
		TERMINALS[18].addFollower(TERMINALS[14], EMPTY_LINK_ARRAY);
		TERMINALS[13].addFollower(TERMINALS[19], EMPTY_LINK_ARRAY);
		TERMINALS[19].addFollower(TERMINALS[20], EMPTY_LINK_ARRAY);
		TERMINALS[20].addFollower(TERMINALS[21], EMPTY_LINK_ARRAY);
		TERMINALS[21].addFollower(TERMINALS[22], EMPTY_LINK_ARRAY);
		TERMINALS[22].addFollower(TERMINALS[12], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getStaticPortType(), FEATURES[2]), });
		TERMINALS[22].addFollower(TERMINALS[13], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getDynamicPortType(), FEATURES[2]), });
		TERMINALS[22].addFollower(TERMINALS[14], EMPTY_LINK_ARRAY);
		TERMINALS[6].addFollower(TERMINALS[23], EMPTY_LINK_ARRAY);
		TERMINALS[23].addFollower(TERMINALS[24], EMPTY_LINK_ARRAY);
		TERMINALS[24].addFollower(TERMINALS[25], EMPTY_LINK_ARRAY);
		TERMINALS[25].addFollower(TERMINALS[26], EMPTY_LINK_ARRAY);
		TERMINALS[26].addFollower(TERMINALS[27], EMPTY_LINK_ARRAY);
		TERMINALS[27].addFollower(TERMINALS[28], EMPTY_LINK_ARRAY);
		TERMINALS[28].addFollower(TERMINALS[29], EMPTY_LINK_ARRAY);
		TERMINALS[29].addFollower(TERMINALS[30], EMPTY_LINK_ARRAY);
		TERMINALS[30].addFollower(TERMINALS[31], EMPTY_LINK_ARRAY);
		TERMINALS[31].addFollower(TERMINALS[32], EMPTY_LINK_ARRAY);
		TERMINALS[32].addFollower(TERMINALS[33], EMPTY_LINK_ARRAY);
		TERMINALS[33].addFollower(TERMINALS[5], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentRole(), FEATURES[0]), });
		TERMINALS[33].addFollower(TERMINALS[6], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getConfiguration(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[7], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getContribution(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[8], EMPTY_LINK_ARRAY);
		TERMINALS[7].addFollower(TERMINALS[34], EMPTY_LINK_ARRAY);
		TERMINALS[34].addFollower(TERMINALS[35], EMPTY_LINK_ARRAY);
		TERMINALS[35].addFollower(TERMINALS[36], EMPTY_LINK_ARRAY);
		TERMINALS[36].addFollower(TERMINALS[37], EMPTY_LINK_ARRAY);
		TERMINALS[37].addFollower(TERMINALS[38], EMPTY_LINK_ARRAY);
		TERMINALS[38].addFollower(TERMINALS[39], EMPTY_LINK_ARRAY);
		TERMINALS[39].addFollower(TERMINALS[40], EMPTY_LINK_ARRAY);
		TERMINALS[40].addFollower(TERMINALS[41], EMPTY_LINK_ARRAY);
		TERMINALS[41].addFollower(TERMINALS[42], EMPTY_LINK_ARRAY);
		TERMINALS[42].addFollower(TERMINALS[43], EMPTY_LINK_ARRAY);
		TERMINALS[43].addFollower(TERMINALS[44], EMPTY_LINK_ARRAY);
		TERMINALS[44].addFollower(TERMINALS[5], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getFragmentRole(), FEATURES[0]), });
		TERMINALS[44].addFollower(TERMINALS[6], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getConfiguration(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[7], new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature[] {new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolContainedFeature(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getContribution(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[8], EMPTY_LINK_ARRAY);
	}
	
	public static void wire() {
		wire0();
	}
	
	static {
		// initialize the arrays
		initializeTerminals();
		initializeFeatures();
		initializeLinks();
		// wire the terminals
		wire();
	}
}
