/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.fracol.resource.fracol.mopp;

public class FracolMetaInformation implements org.reuseware.coconut.fracol.resource.fracol.IFracolMetaInformation {
	
	public String getSyntaxName() {
		return "fracol";
	}
	
	public String getURI() {
		return "http://reuseware.org/coconut/fracol";
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.IFracolTextScanner createLexer() {
		return new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolAntlrScanner(new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolLexer());
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.IFracolTextParser createParser(java.io.InputStream inputStream, String encoding) {
		return new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolParser().createInstance(inputStream, encoding);
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.IFracolTextPrinter createPrinter(java.io.OutputStream outputStream, org.reuseware.coconut.fracol.resource.fracol.IFracolTextResource resource) {
		return new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolPrinter2(outputStream, resource);
	}
	
	public org.eclipse.emf.ecore.EClass[] getClassesWithSyntax() {
		return new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolSyntaxCoverageInformationProvider().getClassesWithSyntax();
	}
	
	public org.eclipse.emf.ecore.EClass[] getStartSymbols() {
		return new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolSyntaxCoverageInformationProvider().getStartSymbols();
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolverSwitch getReferenceResolverSwitch() {
		return new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolReferenceResolverSwitch();
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.IFracolTokenResolverFactory getTokenResolverFactory() {
		return new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolTokenResolverFactory();
	}
	
	public String getPathToCSDefinition() {
		return "org.reuseware.coconut.fracol/model/fracol.cs";
	}
	
	public String[] getTokenNames() {
		return org.reuseware.coconut.fracol.resource.fracol.mopp.FracolParser.tokenNames;
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.IFracolTokenStyle getDefaultTokenStyle(String tokenName) {
		return new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolTokenStyleInformationProvider().getDefaultTokenStyle(tokenName);
	}
	
	public java.util.Collection<org.reuseware.coconut.fracol.resource.fracol.IFracolBracketPair> getBracketPairs() {
		return new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolBracketInformationProvider().getBracketPairs();
	}
	
	public org.eclipse.emf.ecore.EClass[] getFoldableClasses() {
		return new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolFoldingInformationProvider().getFoldableClasses();
	}
	
	public org.eclipse.emf.ecore.resource.Resource.Factory createResourceFactory() {
		return new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolResourceFactory();
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.mopp.FracolNewFileContentProvider getNewFileContentProvider() {
		return new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolNewFileContentProvider();
	}
	
	public void registerResourceFactory() {
		org.eclipse.emf.ecore.resource.Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put(getSyntaxName(), new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolResourceFactory());
	}
	
	/**
	 * Returns the key of the option that can be used to register a preprocessor that
	 * is used as a pipe when loading resources. This key is language-specific. To
	 * register one preprocessor for multiple resource types, it must be registered
	 * individually using all keys.
	 */
	public String getInputStreamPreprocessorProviderOptionKey() {
		return getSyntaxName() + "_" + "INPUT_STREAM_PREPROCESSOR_PROVIDER";
	}
	
	/**
	 * Returns the key of the option that can be used to register a post-processors
	 * that are invoked after loading resources. This key is language-specific. To
	 * register one post-processor for multiple resource types, it must be registered
	 * individually using all keys.
	 */
	public String getResourcePostProcessorProviderOptionKey() {
		return getSyntaxName() + "_" + "RESOURCE_POSTPROCESSOR_PROVIDER";
	}
	
	public String getLaunchConfigurationType() {
		return "org.reuseware.comogen.fracol.ui.launchConfigurationType";
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.IFracolNameProvider createNameProvider() {
		return new org.reuseware.coconut.fracol.resource.fracol.analysis.FracolDefaultNameProvider();
	}
	
	public String[] getSyntaxHighlightableTokenNames() {
		org.reuseware.coconut.fracol.resource.fracol.mopp.FracolAntlrTokenHelper tokenHelper = new org.reuseware.coconut.fracol.resource.fracol.mopp.FracolAntlrTokenHelper();
		java.util.List<String> highlightableTokens = new java.util.ArrayList<String>();
		String[] parserTokenNames = getTokenNames();
		for (int i = 0; i < parserTokenNames.length; i++) {
			// If ANTLR is used we need to normalize the token names
			if (!tokenHelper.canBeUsedForSyntaxHighlighting(i)) {
				continue;
			}
			String tokenName = tokenHelper.getTokenName(parserTokenNames, i);
			if (tokenName == null) {
				continue;
			}
			highlightableTokens.add(tokenName);
		}
		highlightableTokens.add(org.reuseware.coconut.fracol.resource.fracol.mopp.FracolTokenStyleInformationProvider.TASK_ITEM_TOKEN_NAME);
		return highlightableTokens.toArray(new String[highlightableTokens.size()]);
	}
	
}
