/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.fracol.resource.fracol.mopp;

public class FracolReferenceResolverSwitch implements org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolverSwitch {
	
	/**
	 * This map stores a copy of the options the were set for loading the resource.
	 */
	private java.util.Map<Object, Object> options;
	
	protected org.reuseware.coconut.fracol.resource.fracol.analysis.CompositionAssociationEnd1RoleReferenceResolver compositionAssociationEnd1RoleReferenceResolver = new org.reuseware.coconut.fracol.resource.fracol.analysis.CompositionAssociationEnd1RoleReferenceResolver();
	protected org.reuseware.coconut.fracol.resource.fracol.analysis.CompositionAssociationEnd1ReferenceResolver compositionAssociationEnd1ReferenceResolver = new org.reuseware.coconut.fracol.resource.fracol.analysis.CompositionAssociationEnd1ReferenceResolver();
	protected org.reuseware.coconut.fracol.resource.fracol.analysis.CompositionAssociationEnd2RoleReferenceResolver compositionAssociationEnd2RoleReferenceResolver = new org.reuseware.coconut.fracol.resource.fracol.analysis.CompositionAssociationEnd2RoleReferenceResolver();
	protected org.reuseware.coconut.fracol.resource.fracol.analysis.CompositionAssociationEnd2ReferenceResolver compositionAssociationEnd2ReferenceResolver = new org.reuseware.coconut.fracol.resource.fracol.analysis.CompositionAssociationEnd2ReferenceResolver();
	
	public org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolver<org.reuseware.coconut.fracol.CompositionAssociation, org.reuseware.coconut.fracol.FragmentRole> getCompositionAssociationEnd1RoleReferenceResolver() {
		return getResolverChain(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getCompositionAssociation_End1Role(), compositionAssociationEnd1RoleReferenceResolver);
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolver<org.reuseware.coconut.fracol.CompositionAssociation, org.reuseware.coconut.fracol.PortType> getCompositionAssociationEnd1ReferenceResolver() {
		return getResolverChain(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getCompositionAssociation_End1(), compositionAssociationEnd1ReferenceResolver);
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolver<org.reuseware.coconut.fracol.CompositionAssociation, org.reuseware.coconut.fracol.FragmentRole> getCompositionAssociationEnd2RoleReferenceResolver() {
		return getResolverChain(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getCompositionAssociation_End2Role(), compositionAssociationEnd2RoleReferenceResolver);
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolver<org.reuseware.coconut.fracol.CompositionAssociation, org.reuseware.coconut.fracol.PortType> getCompositionAssociationEnd2ReferenceResolver() {
		return getResolverChain(org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getCompositionAssociation_End2(), compositionAssociationEnd2ReferenceResolver);
	}
	
	public void setOptions(java.util.Map<?, ?> options) {
		if (options != null) {
			this.options = new java.util.LinkedHashMap<Object, Object>();
			this.options.putAll(options);
		}
		compositionAssociationEnd1RoleReferenceResolver.setOptions(options);
		compositionAssociationEnd1ReferenceResolver.setOptions(options);
		compositionAssociationEnd2RoleReferenceResolver.setOptions(options);
		compositionAssociationEnd2ReferenceResolver.setOptions(options);
	}
	
	public void resolveFuzzy(String identifier, org.eclipse.emf.ecore.EObject container, org.eclipse.emf.ecore.EReference reference, int position, org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolveResult<org.eclipse.emf.ecore.EObject> result) {
		if (container == null) {
			return;
		}
		if (org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getCompositionAssociation().isInstance(container)) {
			FracolFuzzyResolveResult<org.reuseware.coconut.fracol.FragmentRole> frr = new FracolFuzzyResolveResult<org.reuseware.coconut.fracol.FragmentRole>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("end1Role")) {
				compositionAssociationEnd1RoleReferenceResolver.resolve(identifier, (org.reuseware.coconut.fracol.CompositionAssociation) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getCompositionAssociation().isInstance(container)) {
			FracolFuzzyResolveResult<org.reuseware.coconut.fracol.PortType> frr = new FracolFuzzyResolveResult<org.reuseware.coconut.fracol.PortType>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("end1")) {
				compositionAssociationEnd1ReferenceResolver.resolve(identifier, (org.reuseware.coconut.fracol.CompositionAssociation) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getCompositionAssociation().isInstance(container)) {
			FracolFuzzyResolveResult<org.reuseware.coconut.fracol.FragmentRole> frr = new FracolFuzzyResolveResult<org.reuseware.coconut.fracol.FragmentRole>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("end2Role")) {
				compositionAssociationEnd2RoleReferenceResolver.resolve(identifier, (org.reuseware.coconut.fracol.CompositionAssociation) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getCompositionAssociation().isInstance(container)) {
			FracolFuzzyResolveResult<org.reuseware.coconut.fracol.PortType> frr = new FracolFuzzyResolveResult<org.reuseware.coconut.fracol.PortType>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("end2")) {
				compositionAssociationEnd2ReferenceResolver.resolve(identifier, (org.reuseware.coconut.fracol.CompositionAssociation) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
	}
	
	public org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolver<? extends org.eclipse.emf.ecore.EObject, ? extends org.eclipse.emf.ecore.EObject> getResolver(org.eclipse.emf.ecore.EStructuralFeature reference) {
		if (reference == org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getCompositionAssociation_End1Role()) {
			return getResolverChain(reference, compositionAssociationEnd1RoleReferenceResolver);
		}
		if (reference == org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getCompositionAssociation_End1()) {
			return getResolverChain(reference, compositionAssociationEnd1ReferenceResolver);
		}
		if (reference == org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getCompositionAssociation_End2Role()) {
			return getResolverChain(reference, compositionAssociationEnd2RoleReferenceResolver);
		}
		if (reference == org.reuseware.coconut.fracol.FracolPackage.eINSTANCE.getCompositionAssociation_End2()) {
			return getResolverChain(reference, compositionAssociationEnd2ReferenceResolver);
		}
		return null;
	}
	
	@SuppressWarnings({"rawtypes", "unchecked"})	
	public <ContainerType extends org.eclipse.emf.ecore.EObject, ReferenceType extends org.eclipse.emf.ecore.EObject> org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolver<ContainerType, ReferenceType> getResolverChain(org.eclipse.emf.ecore.EStructuralFeature reference, org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolver<ContainerType, ReferenceType> originalResolver) {
		if (options == null) {
			return originalResolver;
		}
		Object value = options.get(org.reuseware.coconut.fracol.resource.fracol.IFracolOptions.ADDITIONAL_REFERENCE_RESOLVERS);
		if (value == null) {
			return originalResolver;
		}
		if (!(value instanceof java.util.Map)) {
			// send this to the error log
			new org.reuseware.coconut.fracol.resource.fracol.util.FracolRuntimeUtil().logWarning("Found value with invalid type for option " + org.reuseware.coconut.fracol.resource.fracol.IFracolOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + java.util.Map.class.getName() + ", but was " + value.getClass().getName() + ")", null);
			return originalResolver;
		}
		java.util.Map<?,?> resolverMap = (java.util.Map<?,?>) value;
		Object resolverValue = resolverMap.get(reference);
		if (resolverValue == null) {
			return originalResolver;
		}
		if (resolverValue instanceof org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolver) {
			org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolver replacingResolver = (org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolver) resolverValue;
			if (replacingResolver instanceof org.reuseware.coconut.fracol.resource.fracol.IFracolDelegatingReferenceResolver) {
				// pass original resolver to the replacing one
				((org.reuseware.coconut.fracol.resource.fracol.IFracolDelegatingReferenceResolver) replacingResolver).setDelegate(originalResolver);
			}
			return replacingResolver;
		} else if (resolverValue instanceof java.util.Collection) {
			java.util.Collection replacingResolvers = (java.util.Collection) resolverValue;
			org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolver replacingResolver = originalResolver;
			for (Object next : replacingResolvers) {
				if (next instanceof org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceCache) {
					org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolver nextResolver = (org.reuseware.coconut.fracol.resource.fracol.IFracolReferenceResolver) next;
					if (nextResolver instanceof org.reuseware.coconut.fracol.resource.fracol.IFracolDelegatingReferenceResolver) {
						// pass original resolver to the replacing one
						((org.reuseware.coconut.fracol.resource.fracol.IFracolDelegatingReferenceResolver) nextResolver).setDelegate(replacingResolver);
					}
					replacingResolver = nextResolver;
				} else {
					// The collection contains a non-resolver. Send a warning to the error log.
					new org.reuseware.coconut.fracol.resource.fracol.util.FracolRuntimeUtil().logWarning("Found value with invalid type in value map for option " + org.reuseware.coconut.fracol.resource.fracol.IFracolOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + org.reuseware.coconut.fracol.resource.fracol.IFracolDelegatingReferenceResolver.class.getName() + ", but was " + next.getClass().getName() + ")", null);
				}
			}
			return replacingResolver;
		} else {
			// The value for the option ADDITIONAL_REFERENCE_RESOLVERS has an unknown type.
			new org.reuseware.coconut.fracol.resource.fracol.util.FracolRuntimeUtil().logWarning("Found value with invalid type in value map for option " + org.reuseware.coconut.fracol.resource.fracol.IFracolOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + org.reuseware.coconut.fracol.resource.fracol.IFracolDelegatingReferenceResolver.class.getName() + ", but was " + resolverValue.getClass().getName() + ")", null);
			return originalResolver;
		}
	}
	
}
