/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fragment;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>AP Match Group</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.fragment.APMatchGroup#getSingleMatches <em>Single Matches</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.fragment.FragmentPackage#getAPMatchGroup()
 * @model
 * @generated
 */
public interface APMatchGroup extends EObject
{
  /**
   * Returns the value of the '<em><b>Single Matches</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.fragment.APMatch}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fragment.APMatch#getMatchGroup <em>Match Group</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Single Matches</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Single Matches</em>' containment reference list.
   * @see org.reuseware.coconut.fragment.FragmentPackage#getAPMatchGroup_SingleMatches()
   * @see org.reuseware.coconut.fragment.APMatch#getMatchGroup
   * @model opposite="matchGroup" containment="true" ordered="false"
   * @generated
   */
  EList<APMatch> getSingleMatches();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model additionalContextMany="true"
   * @generated
   */
  void execute(Fragment composedSource, Fragment composedTarget, ComposedFragment result, EList<EObject> additionalContext);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // APMatchGroup
