/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fragment;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Addressable Point</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.fragment.AddressablePoint#getHeterogeneousPort <em>Heterogeneous Port</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.AddressablePoint#getName <em>Name</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.AddressablePoint#getVarTypedEObject <em>Var Typed EObject</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.AddressablePoint#getVarTypedEStructuralFeature <em>Var Typed EStructural Feature</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.fragment.FragmentPackage#getAddressablePoint()
 * @model abstract="true"
 * @generated
 */
public interface AddressablePoint extends EObject
{
  /**
   * Returns the value of the '<em><b>Heterogeneous Port</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fragment.HeterogeneousPort#getAddressablePoints <em>Addressable Points</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Heterogeneous Port</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Heterogeneous Port</em>' container reference.
   * @see #setHeterogeneousPort(HeterogeneousPort)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getAddressablePoint_HeterogeneousPort()
   * @see org.reuseware.coconut.fragment.HeterogeneousPort#getAddressablePoints
   * @model opposite="addressablePoints" transient="false" ordered="false"
   * @generated
   */
  HeterogeneousPort getHeterogeneousPort();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.AddressablePoint#getHeterogeneousPort <em>Heterogeneous Port</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Heterogeneous Port</em>' container reference.
   * @see #getHeterogeneousPort()
   * @generated
   */
  void setHeterogeneousPort(HeterogeneousPort value);

  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getAddressablePoint_Name()
   * @model required="true"
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.AddressablePoint#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>Var Typed EObject</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Var Typed EObject</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Var Typed EObject</em>' reference.
   * @see #setVarTypedEObject(EObject)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getAddressablePoint_VarTypedEObject()
   * @model required="true" ordered="false"
   * @generated
   */
  EObject getVarTypedEObject();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.AddressablePoint#getVarTypedEObject <em>Var Typed EObject</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Var Typed EObject</em>' reference.
   * @see #getVarTypedEObject()
   * @generated
   */
  void setVarTypedEObject(EObject value);

  /**
   * Returns the value of the '<em><b>Var Typed EStructural Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Var Typed EStructural Feature</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Var Typed EStructural Feature</em>' reference.
   * @see #setVarTypedEStructuralFeature(EStructuralFeature)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getAddressablePoint_VarTypedEStructuralFeature()
   * @model ordered="false"
   * @generated
   */
  EStructuralFeature getVarTypedEStructuralFeature();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.AddressablePoint#getVarTypedEStructuralFeature <em>Var Typed EStructural Feature</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Var Typed EStructural Feature</em>' reference.
   * @see #getVarTypedEStructuralFeature()
   * @generated
   */
  void setVarTypedEStructuralFeature(EStructuralFeature value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  APMatch match(AddressablePoint ap);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // AddressablePoint
