/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fragment;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

import org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Composition Interface</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.fragment.CompositionInterface#getFragment <em>Fragment</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.CompositionInterface#getPorts <em>Ports</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.CompositionInterface#getRoleBinding <em>Role Binding</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.fragment.FragmentPackage#getCompositionInterface()
 * @model
 * @generated
 */
public interface CompositionInterface extends EObject
{
  /**
   * Returns the value of the '<em><b>Fragment</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fragment.Fragment#getCompositionInterfaces <em>Composition Interfaces</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment</em>' container reference.
   * @see #setFragment(Fragment)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getCompositionInterface_Fragment()
   * @see org.reuseware.coconut.fragment.Fragment#getCompositionInterfaces
   * @model opposite="compositionInterfaces" transient="false" ordered="false"
   * @generated
   */
  Fragment getFragment();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.CompositionInterface#getFragment <em>Fragment</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fragment</em>' container reference.
   * @see #getFragment()
   * @generated
   */
  void setFragment(Fragment value);

  /**
   * Returns the value of the '<em><b>Ports</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.fragment.Port}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fragment.Port#getCompositionInterface <em>Composition Interface</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Ports</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Ports</em>' containment reference list.
   * @see org.reuseware.coconut.fragment.FragmentPackage#getCompositionInterface_Ports()
   * @see org.reuseware.coconut.fragment.Port#getCompositionInterface
   * @model opposite="compositionInterface" containment="true" ordered="false"
   * @generated
   */
  EList<Port> getPorts();

  /**
   * Returns the value of the '<em><b>Role Binding</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Role Binding</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Role Binding</em>' reference.
   * @see #setRoleBinding(FragmentRole2FragmentBinding)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getCompositionInterface_RoleBinding()
   * @model required="true" ordered="false"
   * @generated
   */
  FragmentRole2FragmentBinding getRoleBinding();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.CompositionInterface#getRoleBinding <em>Role Binding</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Role Binding</em>' reference.
   * @see #getRoleBinding()
   * @generated
   */
  void setRoleBinding(FragmentRole2FragmentBinding value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // CompositionInterface
