/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fragment;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

import org.reuseware.coconut.id.ID;

import org.reuseware.coconut.reuseextension.AddressablePointDerivationRule;
import org.reuseware.coconut.reuseextension.PortType2PortBinding;

import org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Fragment</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.fragment.Fragment#getUFI <em>UFI</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.Fragment#getComponentModelActivators <em>Component Model Activators</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.Fragment#getCompositionInterfaces <em>Composition Interfaces</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.Fragment#getCompositionLanguageActivators <em>Composition Language Activators</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.Fragment#getContents <em>Contents</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.Fragment#getDiagrams <em>Diagrams</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.fragment.FragmentPackage#getFragment()
 * @model abstract="true"
 * @generated
 */
public interface Fragment extends EObject
{
  /**
   * Returns the value of the '<em><b>UFI</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>UFI</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>UFI</em>' attribute list.
   * @see org.reuseware.coconut.fragment.FragmentPackage#getFragment_UFI()
   * @model unique="false" required="true"
   * @generated
   */
  EList<String> getUFI();

  /**
   * Returns the value of the '<em><b>Component Model Activators</b></em>' reference list.
   * The list contents are of type {@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Component Model Activators</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Component Model Activators</em>' reference list.
   * @see org.reuseware.coconut.fragment.FragmentPackage#getFragment_ComponentModelActivators()
   * @model transient="true" ordered="false"
   * @generated
   */
  EList<ReuseExtensionActivator> getComponentModelActivators();

  /**
   * Returns the value of the '<em><b>Composition Interfaces</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.fragment.CompositionInterface}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fragment.CompositionInterface#getFragment <em>Fragment</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Interfaces</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Interfaces</em>' containment reference list.
   * @see org.reuseware.coconut.fragment.FragmentPackage#getFragment_CompositionInterfaces()
   * @see org.reuseware.coconut.fragment.CompositionInterface#getFragment
   * @model opposite="fragment" containment="true" ordered="false"
   * @generated
   */
  EList<CompositionInterface> getCompositionInterfaces();

  /**
   * Returns the value of the '<em><b>Composition Language Activators</b></em>' reference list.
   * The list contents are of type {@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Language Activators</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Language Activators</em>' reference list.
   * @see org.reuseware.coconut.fragment.FragmentPackage#getFragment_CompositionLanguageActivators()
   * @model transient="true" ordered="false"
   * @generated
   */
  EList<ReuseExtensionActivator> getCompositionLanguageActivators();

  /**
   * Returns the value of the '<em><b>Contents</b></em>' reference list.
   * The list contents are of type {@link org.eclipse.emf.ecore.EObject}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Contents</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Contents</em>' reference list.
   * @see org.reuseware.coconut.fragment.FragmentPackage#getFragment_Contents()
   * @model ordered="false"
   * @generated
   */
  EList<EObject> getContents();

  /**
   * Returns the value of the '<em><b>Diagrams</b></em>' reference list.
   * The list contents are of type {@link org.eclipse.emf.ecore.EObject}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Diagrams</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Diagrams</em>' reference list.
   * @see org.reuseware.coconut.fragment.FragmentPackage#getFragment_Diagrams()
   * @model ordered="false"
   * @generated
   */
  EList<EObject> getDiagrams();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void computeCompositionInterface();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model copyUFIMany="true"
   * @generated
   */
  ComposedFragment copy(EList<String> copyUFI);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  HeterogeneousPort createPort(CompositionInterface ci, EObject element, AddressablePointDerivationRule apRule, PortType2PortBinding portBinding, ReuseExtensionActivator activator);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  Port createStaticPorts(CompositionInterface ci, PortType2PortBinding portBinding);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model kind="operation"
   * @generated
   */
  EList<AddressablePoint> getAllAddressablePoints();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model kind="operation"
   * @generated
   */
  ID getUFIAsID();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeEmptyInterfacesAndPorts();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // Fragment
