/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fragment;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.reuseware.coconut.fragment.FragmentPackage
 * @generated
 */
public interface FragmentFactory extends EFactory
{
  /**
   * The singleton instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  FragmentFactory eINSTANCE = org.reuseware.coconut.fragment.impl.FragmentFactoryImpl.init();

  /**
   * Returns a new object of class '<em>AP Match Group</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>AP Match Group</em>'.
   * @generated
   */
  APMatchGroup createAPMatchGroup();

  /**
   * Returns a new object of class '<em>AP Match</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>AP Match</em>'.
   * @generated
   */
  APMatch createAPMatch();

  /**
   * Returns a new object of class '<em>Anchor</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Anchor</em>'.
   * @generated
   */
  Anchor createAnchor();

  /**
   * Returns a new object of class '<em>Composed Fragment</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Composed Fragment</em>'.
   * @generated
   */
  ComposedFragment createComposedFragment();

  /**
   * Returns a new object of class '<em>Composition Interface</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Composition Interface</em>'.
   * @generated
   */
  CompositionInterface createCompositionInterface();

  /**
   * Returns a new object of class '<em>Heterogeneous Port</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Heterogeneous Port</em>'.
   * @generated
   */
  HeterogeneousPort createHeterogeneousPort();

  /**
   * Returns a new object of class '<em>Homogeneous Port</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Homogeneous Port</em>'.
   * @generated
   */
  HomogeneousPort createHomogeneousPort();

  /**
   * Returns a new object of class '<em>Hook</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Hook</em>'.
   * @generated
   */
  Hook createHook();

  /**
   * Returns a new object of class '<em>Instantiation Set</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Instantiation Set</em>'.
   * @generated
   */
  InstantiationSet createInstantiationSet();

  /**
   * Returns a new object of class '<em>Physical Fragment</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Physical Fragment</em>'.
   * @generated
   */
  PhysicalFragment createPhysicalFragment();

  /**
   * Returns a new object of class '<em>Prototype</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Prototype</em>'.
   * @generated
   */
  Prototype createPrototype();

  /**
   * Returns a new object of class '<em>Slot</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Slot</em>'.
   * @generated
   */
  Slot createSlot();

  /**
   * Returns a new object of class '<em>Value Hook</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Value Hook</em>'.
   * @generated
   */
  ValueHook createValueHook();

  /**
   * Returns a new object of class '<em>Value Prototype</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Value Prototype</em>'.
   * @generated
   */
  ValuePrototype createValuePrototype();

  /**
   * Returns the package supported by this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the package supported by this factory.
   * @generated
   */
  FragmentPackage getFragmentPackage();

} //FragmentFactory
