/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fragment;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Heterogeneous Port</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.fragment.HeterogeneousPort#getAddressablePoints <em>Addressable Points</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.HeterogeneousPort#getHomogenousPort <em>Homogenous Port</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.fragment.FragmentPackage#getHeterogeneousPort()
 * @model
 * @generated
 */
public interface HeterogeneousPort extends Port
{
  /**
   * Returns the value of the '<em><b>Addressable Points</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.fragment.AddressablePoint}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fragment.AddressablePoint#getHeterogeneousPort <em>Heterogeneous Port</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Addressable Points</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Addressable Points</em>' containment reference list.
   * @see org.reuseware.coconut.fragment.FragmentPackage#getHeterogeneousPort_AddressablePoints()
   * @see org.reuseware.coconut.fragment.AddressablePoint#getHeterogeneousPort
   * @model opposite="heterogeneousPort" containment="true" ordered="false"
   * @generated
   */
  EList<AddressablePoint> getAddressablePoints();

  /**
   * Returns the value of the '<em><b>Homogenous Port</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.fragment.HomogeneousPort#getHeterogeneousPorts <em>Heterogeneous Ports</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Homogenous Port</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Homogenous Port</em>' container reference.
   * @see #setHomogenousPort(HomogeneousPort)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getHeterogeneousPort_HomogenousPort()
   * @see org.reuseware.coconut.fragment.HomogeneousPort#getHeterogeneousPorts
   * @model opposite="heterogeneousPorts" transient="false" ordered="false"
   * @generated
   */
  HomogeneousPort getHomogenousPort();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.HeterogeneousPort#getHomogenousPort <em>Homogenous Port</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Homogenous Port</em>' container reference.
   * @see #getHomogenousPort()
   * @generated
   */
  void setHomogenousPort(HomogeneousPort value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // HeterogeneousPort
