/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fragment;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Value Hook</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.fragment.ValueHook#getBeginIndex <em>Begin Index</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.ValueHook#getEndIndex <em>End Index</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.ValueHook#getListIndex <em>List Index</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.fragment.FragmentPackage#getValueHook()
 * @model
 * @generated
 */
public interface ValueHook extends VariationPoint
{
  /**
   * Returns the value of the '<em><b>Begin Index</b></em>' attribute.
   * The default value is <code>"-1"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Begin Index</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Begin Index</em>' attribute.
   * @see #setBeginIndex(int)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getValueHook_BeginIndex()
   * @model default="-1" required="true"
   * @generated
   */
  int getBeginIndex();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.ValueHook#getBeginIndex <em>Begin Index</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Begin Index</em>' attribute.
   * @see #getBeginIndex()
   * @generated
   */
  void setBeginIndex(int value);

  /**
   * Returns the value of the '<em><b>End Index</b></em>' attribute.
   * The default value is <code>"-1"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>End Index</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>End Index</em>' attribute.
   * @see #setEndIndex(int)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getValueHook_EndIndex()
   * @model default="-1" required="true"
   * @generated
   */
  int getEndIndex();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.ValueHook#getEndIndex <em>End Index</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>End Index</em>' attribute.
   * @see #getEndIndex()
   * @generated
   */
  void setEndIndex(int value);

  /**
   * Returns the value of the '<em><b>List Index</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>List Index</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>List Index</em>' attribute.
   * @see #setListIndex(int)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getValueHook_ListIndex()
   * @model default="0" required="true"
   * @generated
   */
  int getListIndex();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.ValueHook#getListIndex <em>List Index</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>List Index</em>' attribute.
   * @see #getListIndex()
   * @generated
   */
  void setListIndex(int value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  APMatch match(AddressablePoint ap);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // ValueHook
