/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fragment;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Variation Point</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.fragment.VariationPoint#getMode <em>Mode</em>}</li>
 *   <li>{@link org.reuseware.coconut.fragment.VariationPoint#isRemove <em>Remove</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.fragment.FragmentPackage#getVariationPoint()
 * @model abstract="true"
 * @generated
 */
public interface VariationPoint extends AddressablePoint
{
  /**
   * Returns the value of the '<em><b>Mode</b></em>' attribute.
   * The default value is <code>"default"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Mode</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Mode</em>' attribute.
   * @see #setMode(String)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getVariationPoint_Mode()
   * @model default="default" required="true"
   * @generated
   */
  String getMode();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.VariationPoint#getMode <em>Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Mode</em>' attribute.
   * @see #getMode()
   * @generated
   */
  void setMode(String value);

  /**
   * Returns the value of the '<em><b>Remove</b></em>' attribute.
   * The default value is <code>"false"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Remove</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Remove</em>' attribute.
   * @see #setRemove(boolean)
   * @see org.reuseware.coconut.fragment.FragmentPackage#getVariationPoint_Remove()
   * @model default="false" required="true"
   * @generated
   */
  boolean isRemove();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.fragment.VariationPoint#isRemove <em>Remove</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Remove</em>' attribute.
   * @see #isRemove()
   * @generated
   */
  void setRemove(boolean value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void append(EObject parent, EStructuralFeature feature, EObject referenceNode, EObject variationNode);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void basicCompose(EObject parent, EStructuralFeature feature, EObject referenceNode, EObject variationNode);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void bind(EObject parent, EStructuralFeature feature, EObject referenceNode, EObject variationNode);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model contextMany="true"
   * @generated
   */
  void compose(ReferencePoint rp, EObject variationNode, EObject referenceNode, ComposedFragment result, EList<EObject> context);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void extend(EObject parent, EStructuralFeature feature, EObject referenceNode, EObject variationNode);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void prepend(EObject parent, EStructuralFeature feature, EObject referenceNode, EObject variationNode);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void primitiveCompose();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void remove(EObject parent, EStructuralFeature feature, EObject variationNode);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  boolean typeMatch(ReferencePoint rp);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // VariationPoint
