/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fragment.impl;


import org.eclipse.emf.ecore.EClass;
import org.reuseware.coconut.fragment.Anchor;
import org.reuseware.coconut.fragment.FragmentPackage;
import org.reuseware.coconut.fragment.FragmentFactory;
import org.reuseware.coconut.fragment.Slot;
import org.reuseware.coconut.fragment.APMatch;
import org.reuseware.coconut.fragment.AddressablePoint;


/**
 * @generated
 **/
public class AnchorImpl extends ReferencePointImpl implements Anchor
{


   /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AnchorImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return FragmentPackage.Literals.ANCHOR;
  }

  public APMatch match (AddressablePoint ap ){
      boolean fujaba__Success = false;
      Object _TmpObject = null;
      Slot slot = null;
      APMatch match = null;

      // story pattern 1
      try 
      {
         fujaba__Success = false; 

         _TmpObject = ap;

         // ensure correct type and really bound of object slot
         if (!( _TmpObject instanceof Slot )) {throw new Exception("SDMException");};
         slot = (Slot) _TmpObject;

         // attribute condition
         if (!( this.getName().equals(slot.getName ()) )) {throw new Exception("SDMException");};

         fujaba__Success = true;
      }
      catch ( Exception fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if (fujaba__Success)
      {
         // story pattern 2
         try 
         {
            fujaba__Success = false; 

            // check object slot is really bound
            if (!( slot != null )) {throw new Exception("SDMException");};
            // constraint slot.typeMatch(this)
            if (!( slot.typeMatch(this) )) {throw new Exception("SDMException");};
            // create object
            match = FragmentFactory.eINSTANCE.createAPMatch();
            // create link
            match.setSource(this);

            // create link
            match.setTarget(slot);

            fujaba__Success = true;
         }
         catch ( Exception fujaba__InternalException )
         {
            fujaba__Success = false;
         }

         if (fujaba__Success)
         {
            return match;

         }
         else
         {
            return null;

         }

      }
      else
      {
         return null;

      }

   }


}


