/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.fragment.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.fragment.CompositionInterface;
import org.reuseware.coconut.fragment.Fragment;
import org.reuseware.coconut.fragment.FragmentPackage;
import org.reuseware.coconut.fragment.Port;
import org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding;




/**
 * @generated
 **/
public class CompositionInterfaceImpl extends EObjectImpl implements CompositionInterface
{


   /**
   * The cached value of the '{@link #getPorts() <em>Ports</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPorts()
   * @generated
   * @ordered
   */
  protected EList<Port> ports;
  /**
   * The cached value of the '{@link #getRoleBinding() <em>Role Binding</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRoleBinding()
   * @generated
   * @ordered
   */
  protected FragmentRole2FragmentBinding roleBinding;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CompositionInterfaceImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return FragmentPackage.Literals.COMPOSITION_INTERFACE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Fragment getFragment()
  {
    if (eContainerFeatureID() != FragmentPackage.COMPOSITION_INTERFACE__FRAGMENT) return null;
    return (Fragment)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetFragment(Fragment newFragment, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newFragment, FragmentPackage.COMPOSITION_INTERFACE__FRAGMENT, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFragment(Fragment newFragment)
  {
    if (newFragment != eInternalContainer() || (eContainerFeatureID() != FragmentPackage.COMPOSITION_INTERFACE__FRAGMENT && newFragment != null))
    {
      if (EcoreUtil.isAncestor(this, newFragment))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newFragment != null)
        msgs = ((InternalEObject)newFragment).eInverseAdd(this, FragmentPackage.FRAGMENT__COMPOSITION_INTERFACES, Fragment.class, msgs);
      msgs = basicSetFragment(newFragment, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.COMPOSITION_INTERFACE__FRAGMENT, newFragment, newFragment));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Port> getPorts()
  {
    if (ports == null)
    {
      ports = new EObjectContainmentWithInverseEList<Port>(Port.class, this, FragmentPackage.COMPOSITION_INTERFACE__PORTS, FragmentPackage.PORT__COMPOSITION_INTERFACE);
    }
    return ports;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole2FragmentBinding getRoleBinding()
  {
    if (roleBinding != null && roleBinding.eIsProxy())
    {
      InternalEObject oldRoleBinding = (InternalEObject)roleBinding;
      roleBinding = (FragmentRole2FragmentBinding)eResolveProxy(oldRoleBinding);
      if (roleBinding != oldRoleBinding)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, FragmentPackage.COMPOSITION_INTERFACE__ROLE_BINDING, oldRoleBinding, roleBinding));
      }
    }
    return roleBinding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole2FragmentBinding basicGetRoleBinding()
  {
    return roleBinding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRoleBinding(FragmentRole2FragmentBinding newRoleBinding)
  {
    FragmentRole2FragmentBinding oldRoleBinding = roleBinding;
    roleBinding = newRoleBinding;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, FragmentPackage.COMPOSITION_INTERFACE__ROLE_BINDING, oldRoleBinding, roleBinding));
  }

  public void removeYou()
   {
      this.setFragment (null);
      this.getPorts().clear();
      this.setRoleBinding (null);
   }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FragmentPackage.COMPOSITION_INTERFACE__FRAGMENT:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetFragment((Fragment)otherEnd, msgs);
      case FragmentPackage.COMPOSITION_INTERFACE__PORTS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getPorts()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case FragmentPackage.COMPOSITION_INTERFACE__FRAGMENT:
        return basicSetFragment(null, msgs);
      case FragmentPackage.COMPOSITION_INTERFACE__PORTS:
        return ((InternalEList<?>)getPorts()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case FragmentPackage.COMPOSITION_INTERFACE__FRAGMENT:
        return eInternalContainer().eInverseRemove(this, FragmentPackage.FRAGMENT__COMPOSITION_INTERFACES, Fragment.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case FragmentPackage.COMPOSITION_INTERFACE__FRAGMENT:
        return getFragment();
      case FragmentPackage.COMPOSITION_INTERFACE__PORTS:
        return getPorts();
      case FragmentPackage.COMPOSITION_INTERFACE__ROLE_BINDING:
        if (resolve) return getRoleBinding();
        return basicGetRoleBinding();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case FragmentPackage.COMPOSITION_INTERFACE__FRAGMENT:
        setFragment((Fragment)newValue);
        return;
      case FragmentPackage.COMPOSITION_INTERFACE__PORTS:
        getPorts().clear();
        getPorts().addAll((Collection<? extends Port>)newValue);
        return;
      case FragmentPackage.COMPOSITION_INTERFACE__ROLE_BINDING:
        setRoleBinding((FragmentRole2FragmentBinding)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.COMPOSITION_INTERFACE__FRAGMENT:
        setFragment((Fragment)null);
        return;
      case FragmentPackage.COMPOSITION_INTERFACE__PORTS:
        getPorts().clear();
        return;
      case FragmentPackage.COMPOSITION_INTERFACE__ROLE_BINDING:
        setRoleBinding((FragmentRole2FragmentBinding)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case FragmentPackage.COMPOSITION_INTERFACE__FRAGMENT:
        return getFragment() != null;
      case FragmentPackage.COMPOSITION_INTERFACE__PORTS:
        return ports != null && !ports.isEmpty();
      case FragmentPackage.COMPOSITION_INTERFACE__ROLE_BINDING:
        return roleBinding != null;
    }
    return super.eIsSet(featureID);
  }
}


