/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.fragment.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.reuseware.coconut.fragment.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class FragmentFactoryImpl extends EFactoryImpl implements FragmentFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static FragmentFactory init()
  {
    try
    {
      FragmentFactory theFragmentFactory = (FragmentFactory)EPackage.Registry.INSTANCE.getEFactory("http://reuseware.org/coconut/fragment"); 
      if (theFragmentFactory != null)
      {
        return theFragmentFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new FragmentFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case FragmentPackage.AP_MATCH_GROUP: return createAPMatchGroup();
      case FragmentPackage.AP_MATCH: return createAPMatch();
      case FragmentPackage.ANCHOR: return createAnchor();
      case FragmentPackage.COMPOSED_FRAGMENT: return createComposedFragment();
      case FragmentPackage.COMPOSITION_INTERFACE: return createCompositionInterface();
      case FragmentPackage.HETEROGENEOUS_PORT: return createHeterogeneousPort();
      case FragmentPackage.HOMOGENEOUS_PORT: return createHomogeneousPort();
      case FragmentPackage.HOOK: return createHook();
      case FragmentPackage.INSTANTIATION_SET: return createInstantiationSet();
      case FragmentPackage.PHYSICAL_FRAGMENT: return createPhysicalFragment();
      case FragmentPackage.PROTOTYPE: return createPrototype();
      case FragmentPackage.SLOT: return createSlot();
      case FragmentPackage.VALUE_HOOK: return createValueHook();
      case FragmentPackage.VALUE_PROTOTYPE: return createValuePrototype();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public APMatchGroup createAPMatchGroup()
  {
    APMatchGroupImpl apMatchGroup = new APMatchGroupImpl();
    return apMatchGroup;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public APMatch createAPMatch()
  {
    APMatchImpl apMatch = new APMatchImpl();
    return apMatch;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Anchor createAnchor()
  {
    AnchorImpl anchor = new AnchorImpl();
    return anchor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComposedFragment createComposedFragment()
  {
    ComposedFragmentImpl composedFragment = new ComposedFragmentImpl();
    return composedFragment;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionInterface createCompositionInterface()
  {
    CompositionInterfaceImpl compositionInterface = new CompositionInterfaceImpl();
    return compositionInterface;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HeterogeneousPort createHeterogeneousPort()
  {
    HeterogeneousPortImpl heterogeneousPort = new HeterogeneousPortImpl();
    return heterogeneousPort;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HomogeneousPort createHomogeneousPort()
  {
    HomogeneousPortImpl homogeneousPort = new HomogeneousPortImpl();
    return homogeneousPort;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Hook createHook()
  {
    HookImpl hook = new HookImpl();
    return hook;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public InstantiationSet createInstantiationSet()
  {
    InstantiationSetImpl instantiationSet = new InstantiationSetImpl();
    return instantiationSet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PhysicalFragment createPhysicalFragment()
  {
    PhysicalFragmentImpl physicalFragment = new PhysicalFragmentImpl();
    return physicalFragment;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Prototype createPrototype()
  {
    PrototypeImpl prototype = new PrototypeImpl();
    return prototype;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Slot createSlot()
  {
    SlotImpl slot = new SlotImpl();
    return slot;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ValueHook createValueHook()
  {
    ValueHookImpl valueHook = new ValueHookImpl();
    return valueHook;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ValuePrototype createValuePrototype()
  {
    ValuePrototypeImpl valuePrototype = new ValuePrototypeImpl();
    return valuePrototype;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentPackage getFragmentPackage()
  {
    return (FragmentPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static FragmentPackage getPackage()
  {
    return FragmentPackage.eINSTANCE;
  }

} //FragmentFactoryImpl
