/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Composition Association2 Composition Link Binding</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getCompositionLanguageSpecification <em>Composition Language Specification</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getForEach1Expression <em>For Each1 Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getForEach2Expression <em>For Each2 Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getFragmentInstance1NameExpression <em>Fragment Instance1 Name Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getFragmentInstance2NameExpression <em>Fragment Instance2 Name Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getPortInstance1NameExpression <em>Port Instance1 Name Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getPortInstance2NameExpression <em>Port Instance2 Name Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getCompositionAssociation2CompositionLinkBinding()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='NameExpressionsSet'"
 * @generated
 */
public interface CompositionAssociation2CompositionLinkBinding extends CompositionAssociationBinding
{
  /**
   * Returns the value of the '<em><b>Composition Language Specification</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getCompositionAssociationBindings <em>Composition Association Bindings</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Language Specification</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Language Specification</em>' container reference.
   * @see #setCompositionLanguageSpecification(CompositionLanguageSpecification)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getCompositionAssociation2CompositionLinkBinding_CompositionLanguageSpecification()
   * @see org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getCompositionAssociationBindings
   * @model opposite="compositionAssociationBindings" transient="false" ordered="false"
   * @generated
   */
  CompositionLanguageSpecification getCompositionLanguageSpecification();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getCompositionLanguageSpecification <em>Composition Language Specification</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Composition Language Specification</em>' container reference.
   * @see #getCompositionLanguageSpecification()
   * @generated
   */
  void setCompositionLanguageSpecification(CompositionLanguageSpecification value);

  /**
   * Returns the value of the '<em><b>For Each1 Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>For Each1 Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>For Each1 Expression</em>' attribute.
   * @see #setForEach1Expression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getCompositionAssociation2CompositionLinkBinding_ForEach1Expression()
   * @model
   * @generated
   */
  String getForEach1Expression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getForEach1Expression <em>For Each1 Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>For Each1 Expression</em>' attribute.
   * @see #getForEach1Expression()
   * @generated
   */
  void setForEach1Expression(String value);

  /**
   * Returns the value of the '<em><b>For Each2 Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>For Each2 Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>For Each2 Expression</em>' attribute.
   * @see #setForEach2Expression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getCompositionAssociation2CompositionLinkBinding_ForEach2Expression()
   * @model
   * @generated
   */
  String getForEach2Expression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getForEach2Expression <em>For Each2 Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>For Each2 Expression</em>' attribute.
   * @see #getForEach2Expression()
   * @generated
   */
  void setForEach2Expression(String value);

  /**
   * Returns the value of the '<em><b>Fragment Instance1 Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment Instance1 Name Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment Instance1 Name Expression</em>' attribute.
   * @see #setFragmentInstance1NameExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getCompositionAssociation2CompositionLinkBinding_FragmentInstance1NameExpression()
   * @model required="true"
   * @generated
   */
  String getFragmentInstance1NameExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getFragmentInstance1NameExpression <em>Fragment Instance1 Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fragment Instance1 Name Expression</em>' attribute.
   * @see #getFragmentInstance1NameExpression()
   * @generated
   */
  void setFragmentInstance1NameExpression(String value);

  /**
   * Returns the value of the '<em><b>Fragment Instance2 Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment Instance2 Name Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment Instance2 Name Expression</em>' attribute.
   * @see #setFragmentInstance2NameExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getCompositionAssociation2CompositionLinkBinding_FragmentInstance2NameExpression()
   * @model required="true"
   * @generated
   */
  String getFragmentInstance2NameExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getFragmentInstance2NameExpression <em>Fragment Instance2 Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fragment Instance2 Name Expression</em>' attribute.
   * @see #getFragmentInstance2NameExpression()
   * @generated
   */
  void setFragmentInstance2NameExpression(String value);

  /**
   * Returns the value of the '<em><b>Port Instance1 Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Port Instance1 Name Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Port Instance1 Name Expression</em>' attribute.
   * @see #setPortInstance1NameExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getCompositionAssociation2CompositionLinkBinding_PortInstance1NameExpression()
   * @model
   * @generated
   */
  String getPortInstance1NameExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getPortInstance1NameExpression <em>Port Instance1 Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Port Instance1 Name Expression</em>' attribute.
   * @see #getPortInstance1NameExpression()
   * @generated
   */
  void setPortInstance1NameExpression(String value);

  /**
   * Returns the value of the '<em><b>Port Instance2 Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Port Instance2 Name Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Port Instance2 Name Expression</em>' attribute.
   * @see #setPortInstance2NameExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getCompositionAssociation2CompositionLinkBinding_PortInstance2NameExpression()
   * @model
   * @generated
   */
  String getPortInstance2NameExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getPortInstance2NameExpression <em>Port Instance2 Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Port Instance2 Name Expression</em>' attribute.
   * @see #getPortInstance2NameExpression()
   * @generated
   */
  void setPortInstance2NameExpression(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // CompositionAssociation2CompositionLinkBinding
