/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Composition Language Specification</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getCompositionAssociationBindings <em>Composition Association Bindings</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getCompositionProgramPhysicalLocationExpression <em>Composition Program Physical Location Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getFragmentRoleBindings <em>Fragment Role Bindings</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getUcpiExpression <em>Ucpi Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getCompositionLanguageSpecification()
 * @model
 * @generated
 */
public interface CompositionLanguageSpecification extends ReuseExtension
{
  /**
   * Returns the value of the '<em><b>Composition Association Bindings</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getCompositionLanguageSpecification <em>Composition Language Specification</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Association Bindings</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Association Bindings</em>' containment reference list.
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getCompositionLanguageSpecification_CompositionAssociationBindings()
   * @see org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding#getCompositionLanguageSpecification
   * @model opposite="compositionLanguageSpecification" containment="true" ordered="false"
   * @generated
   */
  EList<CompositionAssociation2CompositionLinkBinding> getCompositionAssociationBindings();

  /**
   * Returns the value of the '<em><b>Composition Program Physical Location Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Program Physical Location Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Program Physical Location Expression</em>' attribute.
   * @see #setCompositionProgramPhysicalLocationExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getCompositionLanguageSpecification_CompositionProgramPhysicalLocationExpression()
   * @model
   * @generated
   */
  String getCompositionProgramPhysicalLocationExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getCompositionProgramPhysicalLocationExpression <em>Composition Program Physical Location Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Composition Program Physical Location Expression</em>' attribute.
   * @see #getCompositionProgramPhysicalLocationExpression()
   * @generated
   */
  void setCompositionProgramPhysicalLocationExpression(String value);

  /**
   * Returns the value of the '<em><b>Fragment Role Bindings</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getCompositionLanguageSpecification <em>Composition Language Specification</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fragment Role Bindings</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fragment Role Bindings</em>' containment reference list.
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getCompositionLanguageSpecification_FragmentRoleBindings()
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getCompositionLanguageSpecification
   * @model opposite="compositionLanguageSpecification" containment="true" ordered="false"
   * @generated
   */
  EList<FragmentRole2FragmentInstanceBinding> getFragmentRoleBindings();

  /**
   * Returns the value of the '<em><b>Ucpi Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Ucpi Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Ucpi Expression</em>' attribute.
   * @see #setUcpiExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getCompositionLanguageSpecification_UcpiExpression()
   * @model required="true"
   * @generated
   */
  String getUcpiExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getUcpiExpression <em>Ucpi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Ucpi Expression</em>' attribute.
   * @see #getUcpiExpression()
   * @generated
   */
  void setUcpiExpression(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // CompositionLanguageSpecification
