/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Fragment Role2 Fragment Binding</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding#getComponentModelSpecification <em>Component Model Specification</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding#getIsExpression <em>Is Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding#getPortTypeBindings <em>Port Type Bindings</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2FragmentBinding()
 * @model
 * @generated
 */
public interface FragmentRole2FragmentBinding extends FragmentRoleBinding
{
  /**
   * Returns the value of the '<em><b>Component Model Specification</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.ComponentModelSpecification#getFragmentRoleBindings <em>Fragment Role Bindings</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Component Model Specification</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Component Model Specification</em>' container reference.
   * @see #setComponentModelSpecification(ComponentModelSpecification)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2FragmentBinding_ComponentModelSpecification()
   * @see org.reuseware.coconut.reuseextension.ComponentModelSpecification#getFragmentRoleBindings
   * @model opposite="fragmentRoleBindings" transient="false" ordered="false"
   * @generated
   */
  ComponentModelSpecification getComponentModelSpecification();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding#getComponentModelSpecification <em>Component Model Specification</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Component Model Specification</em>' container reference.
   * @see #getComponentModelSpecification()
   * @generated
   */
  void setComponentModelSpecification(ComponentModelSpecification value);

  /**
   * Returns the value of the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Is Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Is Expression</em>' attribute.
   * @see #setIsExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2FragmentBinding_IsExpression()
   * @model
   * @generated
   */
  String getIsExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding#getIsExpression <em>Is Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Is Expression</em>' attribute.
   * @see #getIsExpression()
   * @generated
   */
  void setIsExpression(String value);

  /**
   * Returns the value of the '<em><b>Port Type Bindings</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.reuseextension.PortType2PortBinding}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.PortType2PortBinding#getFragmentRoleBinding <em>Fragment Role Binding</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Port Type Bindings</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Port Type Bindings</em>' containment reference list.
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2FragmentBinding_PortTypeBindings()
   * @see org.reuseware.coconut.reuseextension.PortType2PortBinding#getFragmentRoleBinding
   * @model opposite="fragmentRoleBinding" containment="true" ordered="false"
   * @generated
   */
  EList<PortType2PortBinding> getPortTypeBindings();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // FragmentRole2FragmentBinding
