/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Fragment Role2 Fragment Instance Binding</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getCompositionLanguageSpecification <em>Composition Language Specification</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getNameExpression <em>Name Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getPortTypeBindings <em>Port Type Bindings</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getTargetPhysicalLocationExpression <em>Target Physical Location Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getTargetUfiExpression <em>Target Ufi Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getUfiExpression <em>Ufi Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2FragmentInstanceBinding()
 * @model
 * @generated
 */
public interface FragmentRole2FragmentInstanceBinding extends FragmentRoleBinding, RuleContext
{
  /**
   * Returns the value of the '<em><b>Composition Language Specification</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getFragmentRoleBindings <em>Fragment Role Bindings</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Language Specification</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Language Specification</em>' container reference.
   * @see #setCompositionLanguageSpecification(CompositionLanguageSpecification)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2FragmentInstanceBinding_CompositionLanguageSpecification()
   * @see org.reuseware.coconut.reuseextension.CompositionLanguageSpecification#getFragmentRoleBindings
   * @model opposite="fragmentRoleBindings" transient="false" ordered="false"
   * @generated
   */
  CompositionLanguageSpecification getCompositionLanguageSpecification();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getCompositionLanguageSpecification <em>Composition Language Specification</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Composition Language Specification</em>' container reference.
   * @see #getCompositionLanguageSpecification()
   * @generated
   */
  void setCompositionLanguageSpecification(CompositionLanguageSpecification value);

  /**
   * Returns the value of the '<em><b>Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name Expression</em>' attribute.
   * @see #setNameExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2FragmentInstanceBinding_NameExpression()
   * @model required="true"
   * @generated
   */
  String getNameExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getNameExpression <em>Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name Expression</em>' attribute.
   * @see #getNameExpression()
   * @generated
   */
  void setNameExpression(String value);

  /**
   * Returns the value of the '<em><b>Port Type Bindings</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.reuseextension.PortType2SettingBinding}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.PortType2SettingBinding#getFragmentRoleBinding <em>Fragment Role Binding</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Port Type Bindings</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Port Type Bindings</em>' containment reference list.
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2FragmentInstanceBinding_PortTypeBindings()
   * @see org.reuseware.coconut.reuseextension.PortType2SettingBinding#getFragmentRoleBinding
   * @model opposite="fragmentRoleBinding" containment="true" ordered="false"
   * @generated
   */
  EList<PortType2SettingBinding> getPortTypeBindings();

  /**
   * Returns the value of the '<em><b>Target Physical Location Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Physical Location Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Physical Location Expression</em>' attribute.
   * @see #setTargetPhysicalLocationExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2FragmentInstanceBinding_TargetPhysicalLocationExpression()
   * @model
   * @generated
   */
  String getTargetPhysicalLocationExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getTargetPhysicalLocationExpression <em>Target Physical Location Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Physical Location Expression</em>' attribute.
   * @see #getTargetPhysicalLocationExpression()
   * @generated
   */
  void setTargetPhysicalLocationExpression(String value);

  /**
   * Returns the value of the '<em><b>Target Ufi Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Ufi Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Ufi Expression</em>' attribute.
   * @see #setTargetUfiExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2FragmentInstanceBinding_TargetUfiExpression()
   * @model
   * @generated
   */
  String getTargetUfiExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getTargetUfiExpression <em>Target Ufi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Ufi Expression</em>' attribute.
   * @see #getTargetUfiExpression()
   * @generated
   */
  void setTargetUfiExpression(String value);

  /**
   * Returns the value of the '<em><b>Ufi Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Ufi Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Ufi Expression</em>' attribute.
   * @see #setUfiExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2FragmentInstanceBinding_UfiExpression()
   * @model required="true"
   * @generated
   */
  String getUfiExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding#getUfiExpression <em>Ufi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Ufi Expression</em>' attribute.
   * @see #getUfiExpression()
   * @generated
   */
  void setUfiExpression(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // FragmentRole2FragmentInstanceBinding
