/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Fragment Role2 Syntax Binding</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getCompositionLanguageSyntax <em>Composition Language Syntax</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getNameExpression <em>Name Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getPortTypeBindings <em>Port Type Bindings</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getTargetPhysicalLocationExpression <em>Target Physical Location Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getTargetUfiExpression <em>Target Ufi Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getUfiExpression <em>Ufi Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2SyntaxBinding()
 * @model
 * @generated
 */
public interface FragmentRole2SyntaxBinding extends FragmentRoleBinding, SyntaxDerivationRule
{
  /**
   * Returns the value of the '<em><b>Composition Language Syntax</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSyntaxSpecification#getFragmentRoleBindings <em>Fragment Role Bindings</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Composition Language Syntax</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Composition Language Syntax</em>' container reference.
   * @see #setCompositionLanguageSyntax(CompositionLanguageSyntaxSpecification)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2SyntaxBinding_CompositionLanguageSyntax()
   * @see org.reuseware.coconut.reuseextension.CompositionLanguageSyntaxSpecification#getFragmentRoleBindings
   * @model opposite="fragmentRoleBindings" transient="false" ordered="false"
   * @generated
   */
  CompositionLanguageSyntaxSpecification getCompositionLanguageSyntax();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getCompositionLanguageSyntax <em>Composition Language Syntax</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Composition Language Syntax</em>' container reference.
   * @see #getCompositionLanguageSyntax()
   * @generated
   */
  void setCompositionLanguageSyntax(CompositionLanguageSyntaxSpecification value);

  /**
   * Returns the value of the '<em><b>Name Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name Expression</em>' attribute.
   * @see #setNameExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2SyntaxBinding_NameExpression()
   * @model
   * @generated
   */
  String getNameExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getNameExpression <em>Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name Expression</em>' attribute.
   * @see #getNameExpression()
   * @generated
   */
  void setNameExpression(String value);

  /**
   * Returns the value of the '<em><b>Port Type Bindings</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.reuseextension.PortType2SyntaxBinding}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.PortType2SyntaxBinding#getFragmentRole2SyntaxBinding <em>Fragment Role2 Syntax Binding</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Port Type Bindings</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Port Type Bindings</em>' containment reference list.
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2SyntaxBinding_PortTypeBindings()
   * @see org.reuseware.coconut.reuseextension.PortType2SyntaxBinding#getFragmentRole2SyntaxBinding
   * @model opposite="fragmentRole2SyntaxBinding" containment="true" ordered="false"
   * @generated
   */
  EList<PortType2SyntaxBinding> getPortTypeBindings();

  /**
   * Returns the value of the '<em><b>Target Physical Location Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Physical Location Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Physical Location Expression</em>' attribute.
   * @see #setTargetPhysicalLocationExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2SyntaxBinding_TargetPhysicalLocationExpression()
   * @model
   * @generated
   */
  String getTargetPhysicalLocationExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getTargetPhysicalLocationExpression <em>Target Physical Location Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Physical Location Expression</em>' attribute.
   * @see #getTargetPhysicalLocationExpression()
   * @generated
   */
  void setTargetPhysicalLocationExpression(String value);

  /**
   * Returns the value of the '<em><b>Target Ufi Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Ufi Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Ufi Expression</em>' attribute.
   * @see #setTargetUfiExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2SyntaxBinding_TargetUfiExpression()
   * @model
   * @generated
   */
  String getTargetUfiExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getTargetUfiExpression <em>Target Ufi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Ufi Expression</em>' attribute.
   * @see #getTargetUfiExpression()
   * @generated
   */
  void setTargetUfiExpression(String value);

  /**
   * Returns the value of the '<em><b>Ufi Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Ufi Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Ufi Expression</em>' attribute.
   * @see #setUfiExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getFragmentRole2SyntaxBinding_UfiExpression()
   * @model
   * @generated
   */
  String getUfiExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding#getUfiExpression <em>Ufi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Ufi Expression</em>' attribute.
   * @see #getUfiExpression()
   * @generated
   */
  void setUfiExpression(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // FragmentRole2SyntaxBinding
