/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.reuseware.coconut.fracol.FragmentCollaboration;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Reuse Extension</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.ReuseExtension#getEPackages <em>EPackages</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.ReuseExtension#getFracolNamespace <em>Fracol Namespace</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.ReuseExtension#getFracol <em>Fracol</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.ReuseExtension#getParameters <em>Parameters</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.ReuseExtension#getRexName <em>Rex Name</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.ReuseExtension#getRexNamespace <em>Rex Namespace</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.ReuseExtension#getRootElementContexts <em>Root Element Contexts</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getReuseExtension()
 * @model abstract="true"
 * @generated
 */
public interface ReuseExtension extends EObject
{
  /**
   * Returns the value of the '<em><b>EPackages</b></em>' reference list.
   * The list contents are of type {@link org.eclipse.emf.ecore.EPackage}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>EPackages</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>EPackages</em>' reference list.
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getReuseExtension_EPackages()
   * @model ordered="false"
   * @generated
   */
  EList<EPackage> getEPackages();

  /**
   * Returns the value of the '<em><b>Fracol Namespace</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fracol Namespace</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fracol Namespace</em>' attribute list.
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getReuseExtension_FracolNamespace()
   * @model unique="false"
   * @generated
   */
  EList<String> getFracolNamespace();

  /**
   * Returns the value of the '<em><b>Fracol</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fracol</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fracol</em>' reference.
   * @see #setFracol(FragmentCollaboration)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getReuseExtension_Fracol()
   * @model required="true" ordered="false"
   * @generated
   */
  FragmentCollaboration getFracol();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.ReuseExtension#getFracol <em>Fracol</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fracol</em>' reference.
   * @see #getFracol()
   * @generated
   */
  void setFracol(FragmentCollaboration value);

  /**
   * Returns the value of the '<em><b>Parameters</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Parameters</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Parameters</em>' attribute list.
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getReuseExtension_Parameters()
   * @model unique="false"
   * @generated
   */
  EList<String> getParameters();

  /**
   * Returns the value of the '<em><b>Rex Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Rex Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Rex Name</em>' attribute.
   * @see #setRexName(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getReuseExtension_RexName()
   * @model required="true"
   * @generated
   */
  String getRexName();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.ReuseExtension#getRexName <em>Rex Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Rex Name</em>' attribute.
   * @see #getRexName()
   * @generated
   */
  void setRexName(String value);

  /**
   * Returns the value of the '<em><b>Rex Namespace</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Rex Namespace</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Rex Namespace</em>' attribute list.
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getReuseExtension_RexNamespace()
   * @model unique="false"
   * @generated
   */
  EList<String> getRexNamespace();

  /**
   * Returns the value of the '<em><b>Root Element Contexts</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.reuseextension.RootElementContext}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextension.RootElementContext#getReuseExtension <em>Reuse Extension</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Root Element Contexts</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Root Element Contexts</em>' containment reference list.
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getReuseExtension_RootElementContexts()
   * @see org.reuseware.coconut.reuseextension.RootElementContext#getReuseExtension
   * @model opposite="reuseExtension" containment="true" ordered="false"
   * @generated
   */
  EList<RootElementContext> getRootElementContexts();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // ReuseExtension
