/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Rule Context</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.RuleContext#getEBoundClass <em>EBound Class</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.RuleContext#getEBoundFeature <em>EBound Feature</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.RuleContext#getIsExpression <em>Is Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getRuleContext()
 * @model interface="true" abstract="true"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore constraints='AllExpressions'"
 * @generated
 */
public interface RuleContext extends EObject
{
  /**
   * Returns the value of the '<em><b>EBound Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>EBound Class</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>EBound Class</em>' reference.
   * @see #setEBoundClass(EClass)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getRuleContext_EBoundClass()
   * @model required="true" ordered="false"
   * @generated
   */
  EClass getEBoundClass();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.RuleContext#getEBoundClass <em>EBound Class</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>EBound Class</em>' reference.
   * @see #getEBoundClass()
   * @generated
   */
  void setEBoundClass(EClass value);

  /**
   * Returns the value of the '<em><b>EBound Feature</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>EBound Feature</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>EBound Feature</em>' reference.
   * @see #setEBoundFeature(EStructuralFeature)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getRuleContext_EBoundFeature()
   * @model ordered="false"
   * @generated
   */
  EStructuralFeature getEBoundFeature();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.RuleContext#getEBoundFeature <em>EBound Feature</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>EBound Feature</em>' reference.
   * @see #getEBoundFeature()
   * @generated
   */
  void setEBoundFeature(EStructuralFeature value);

  /**
   * Returns the value of the '<em><b>Is Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Is Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Is Expression</em>' attribute.
   * @see #setIsExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getRuleContext_IsExpression()
   * @model
   * @generated
   */
  String getIsExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.RuleContext#getIsExpression <em>Is Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Is Expression</em>' attribute.
   * @see #getIsExpression()
   * @generated
   */
  void setIsExpression(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // RuleContext
