/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Syntax Derivation Rule</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getHeightExpression <em>Height Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getIconExpression <em>Icon Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getVisibleExpression <em>Visible Expression</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getWidthExpression <em>Width Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getSyntaxDerivationRule()
 * @model abstract="true"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore constraints='AllExpressions'"
 * @generated
 */
public interface SyntaxDerivationRule extends EObject
{
  /**
   * Returns the value of the '<em><b>Height Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Height Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Height Expression</em>' attribute.
   * @see #setHeightExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getSyntaxDerivationRule_HeightExpression()
   * @model
   * @generated
   */
  String getHeightExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getHeightExpression <em>Height Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Height Expression</em>' attribute.
   * @see #getHeightExpression()
   * @generated
   */
  void setHeightExpression(String value);

  /**
   * Returns the value of the '<em><b>Icon Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Icon Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Icon Expression</em>' attribute.
   * @see #setIconExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getSyntaxDerivationRule_IconExpression()
   * @model
   * @generated
   */
  String getIconExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getIconExpression <em>Icon Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Icon Expression</em>' attribute.
   * @see #getIconExpression()
   * @generated
   */
  void setIconExpression(String value);

  /**
   * Returns the value of the '<em><b>Visible Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Visible Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Visible Expression</em>' attribute.
   * @see #setVisibleExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getSyntaxDerivationRule_VisibleExpression()
   * @model
   * @generated
   */
  String getVisibleExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getVisibleExpression <em>Visible Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Visible Expression</em>' attribute.
   * @see #getVisibleExpression()
   * @generated
   */
  void setVisibleExpression(String value);

  /**
   * Returns the value of the '<em><b>Width Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Width Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Width Expression</em>' attribute.
   * @see #setWidthExpression(String)
   * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage#getSyntaxDerivationRule_WidthExpression()
   * @model
   * @generated
   */
  String getWidthExpression();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule#getWidthExpression <em>Width Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Width Expression</em>' attribute.
   * @see #getWidthExpression()
   * @generated
   */
  void setWidthExpression(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // SyntaxDerivationRule
