/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.reuseware.coconut.reuseextension.AddressablePointDerivationRule;
import org.reuseware.coconut.reuseextension.PortType2PortBinding;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;




/**
 * @generated
 **/
public abstract class AddressablePointDerivationRuleImpl extends EObjectImpl implements AddressablePointDerivationRule
{


   /**
   * The cached value of the '{@link #getEBoundClass() <em>EBound Class</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEBoundClass()
   * @generated
   * @ordered
   */
  protected EClass eBoundClass;
  /**
   * The cached value of the '{@link #getEBoundFeature() <em>EBound Feature</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEBoundFeature()
   * @generated
   * @ordered
   */
  protected EStructuralFeature eBoundFeature;
  /**
   * The default value of the '{@link #getIsExpression() <em>Is Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIsExpression()
   * @generated
   * @ordered
   */
  protected static final String IS_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getIsExpression() <em>Is Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIsExpression()
   * @generated
   * @ordered
   */
  protected String isExpression = IS_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getForEachExpression() <em>For Each Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getForEachExpression()
   * @generated
   * @ordered
   */
  protected static final String FOR_EACH_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getForEachExpression() <em>For Each Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getForEachExpression()
   * @generated
   * @ordered
   */
  protected String forEachExpression = FOR_EACH_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getHomoPortNameExpression() <em>Homo Port Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHomoPortNameExpression()
   * @generated
   * @ordered
   */
  protected static final String HOMO_PORT_NAME_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getHomoPortNameExpression() <em>Homo Port Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHomoPortNameExpression()
   * @generated
   * @ordered
   */
  protected String homoPortNameExpression = HOMO_PORT_NAME_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getPointNameExpression() <em>Point Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPointNameExpression()
   * @generated
   * @ordered
   */
  protected static final String POINT_NAME_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getPointNameExpression() <em>Point Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPointNameExpression()
   * @generated
   * @ordered
   */
  protected String pointNameExpression = POINT_NAME_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getPortNameExpression() <em>Port Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPortNameExpression()
   * @generated
   * @ordered
   */
  protected static final String PORT_NAME_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getPortNameExpression() <em>Port Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPortNameExpression()
   * @generated
   * @ordered
   */
  protected String portNameExpression = PORT_NAME_EXPRESSION_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AddressablePointDerivationRuleImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.ADDRESSABLE_POINT_DERIVATION_RULE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getEBoundClass()
  {
    if (eBoundClass != null && eBoundClass.eIsProxy())
    {
      InternalEObject oldEBoundClass = (InternalEObject)eBoundClass;
      eBoundClass = (EClass)eResolveProxy(oldEBoundClass);
      if (eBoundClass != oldEBoundClass)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_CLASS, oldEBoundClass, eBoundClass));
      }
    }
    return eBoundClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass basicGetEBoundClass()
  {
    return eBoundClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEBoundClass(EClass newEBoundClass)
  {
    EClass oldEBoundClass = eBoundClass;
    eBoundClass = newEBoundClass;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_CLASS, oldEBoundClass, eBoundClass));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EStructuralFeature getEBoundFeature()
  {
    if (eBoundFeature != null && eBoundFeature.eIsProxy())
    {
      InternalEObject oldEBoundFeature = (InternalEObject)eBoundFeature;
      eBoundFeature = (EStructuralFeature)eResolveProxy(oldEBoundFeature);
      if (eBoundFeature != oldEBoundFeature)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_FEATURE, oldEBoundFeature, eBoundFeature));
      }
    }
    return eBoundFeature;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EStructuralFeature basicGetEBoundFeature()
  {
    return eBoundFeature;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEBoundFeature(EStructuralFeature newEBoundFeature)
  {
    EStructuralFeature oldEBoundFeature = eBoundFeature;
    eBoundFeature = newEBoundFeature;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_FEATURE, oldEBoundFeature, eBoundFeature));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getIsExpression()
  {
    return isExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setIsExpression(String newIsExpression)
  {
    String oldIsExpression = isExpression;
    isExpression = newIsExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__IS_EXPRESSION, oldIsExpression, isExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getForEachExpression()
  {
    return forEachExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setForEachExpression(String newForEachExpression)
  {
    String oldForEachExpression = forEachExpression;
    forEachExpression = newForEachExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION, oldForEachExpression, forEachExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getHomoPortNameExpression()
  {
    return homoPortNameExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHomoPortNameExpression(String newHomoPortNameExpression)
  {
    String oldHomoPortNameExpression = homoPortNameExpression;
    homoPortNameExpression = newHomoPortNameExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION, oldHomoPortNameExpression, homoPortNameExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getPointNameExpression()
  {
    return pointNameExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPointNameExpression(String newPointNameExpression)
  {
    String oldPointNameExpression = pointNameExpression;
    pointNameExpression = newPointNameExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION, oldPointNameExpression, pointNameExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getPortNameExpression()
  {
    return portNameExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPortNameExpression(String newPortNameExpression)
  {
    String oldPortNameExpression = portNameExpression;
    portNameExpression = newPortNameExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION, oldPortNameExpression, portNameExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PortType2PortBinding getPortTypeBinding()
  {
    if (eContainerFeatureID() != ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING) return null;
    return (PortType2PortBinding)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetPortTypeBinding(PortType2PortBinding newPortTypeBinding, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newPortTypeBinding, ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPortTypeBinding(PortType2PortBinding newPortTypeBinding)
  {
    if (newPortTypeBinding != eInternalContainer() || (eContainerFeatureID() != ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING && newPortTypeBinding != null))
    {
      if (EcoreUtil.isAncestor(this, newPortTypeBinding))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newPortTypeBinding != null)
        msgs = ((InternalEObject)newPortTypeBinding).eInverseAdd(this, ReuseextensionPackage.PORT_TYPE2_PORT_BINDING__DERIVATION_RULES, PortType2PortBinding.class, msgs);
      msgs = basicSetPortTypeBinding(newPortTypeBinding, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING, newPortTypeBinding, newPortTypeBinding));
  }

  public void removeYou()
   {
      this.setEBoundClass (null);
      this.setEBoundFeature (null);
      this.setPortTypeBinding (null);
   }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetPortTypeBinding((PortType2PortBinding)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING:
        return basicSetPortTypeBinding(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING:
        return eInternalContainer().eInverseRemove(this, ReuseextensionPackage.PORT_TYPE2_PORT_BINDING__DERIVATION_RULES, PortType2PortBinding.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_CLASS:
        if (resolve) return getEBoundClass();
        return basicGetEBoundClass();
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_FEATURE:
        if (resolve) return getEBoundFeature();
        return basicGetEBoundFeature();
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__IS_EXPRESSION:
        return getIsExpression();
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION:
        return getForEachExpression();
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION:
        return getHomoPortNameExpression();
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION:
        return getPointNameExpression();
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION:
        return getPortNameExpression();
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING:
        return getPortTypeBinding();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_CLASS:
        setEBoundClass((EClass)newValue);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_FEATURE:
        setEBoundFeature((EStructuralFeature)newValue);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__IS_EXPRESSION:
        setIsExpression((String)newValue);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION:
        setForEachExpression((String)newValue);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION:
        setHomoPortNameExpression((String)newValue);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION:
        setPointNameExpression((String)newValue);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION:
        setPortNameExpression((String)newValue);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING:
        setPortTypeBinding((PortType2PortBinding)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_CLASS:
        setEBoundClass((EClass)null);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_FEATURE:
        setEBoundFeature((EStructuralFeature)null);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__IS_EXPRESSION:
        setIsExpression(IS_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION:
        setForEachExpression(FOR_EACH_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION:
        setHomoPortNameExpression(HOMO_PORT_NAME_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION:
        setPointNameExpression(POINT_NAME_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION:
        setPortNameExpression(PORT_NAME_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING:
        setPortTypeBinding((PortType2PortBinding)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_CLASS:
        return eBoundClass != null;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__EBOUND_FEATURE:
        return eBoundFeature != null;
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__IS_EXPRESSION:
        return IS_EXPRESSION_EDEFAULT == null ? isExpression != null : !IS_EXPRESSION_EDEFAULT.equals(isExpression);
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__FOR_EACH_EXPRESSION:
        return FOR_EACH_EXPRESSION_EDEFAULT == null ? forEachExpression != null : !FOR_EACH_EXPRESSION_EDEFAULT.equals(forEachExpression);
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__HOMO_PORT_NAME_EXPRESSION:
        return HOMO_PORT_NAME_EXPRESSION_EDEFAULT == null ? homoPortNameExpression != null : !HOMO_PORT_NAME_EXPRESSION_EDEFAULT.equals(homoPortNameExpression);
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__POINT_NAME_EXPRESSION:
        return POINT_NAME_EXPRESSION_EDEFAULT == null ? pointNameExpression != null : !POINT_NAME_EXPRESSION_EDEFAULT.equals(pointNameExpression);
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_NAME_EXPRESSION:
        return PORT_NAME_EXPRESSION_EDEFAULT == null ? portNameExpression != null : !PORT_NAME_EXPRESSION_EDEFAULT.equals(portNameExpression);
      case ReuseextensionPackage.ADDRESSABLE_POINT_DERIVATION_RULE__PORT_TYPE_BINDING:
        return getPortTypeBinding() != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (isExpression: ");
    result.append(isExpression);
    result.append(", forEachExpression: ");
    result.append(forEachExpression);
    result.append(", homoPortNameExpression: ");
    result.append(homoPortNameExpression);
    result.append(", pointNameExpression: ");
    result.append(pointNameExpression);
    result.append(", portNameExpression: ");
    result.append(portNameExpression);
    result.append(')');
    return result.toString();
  }
}


