/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.reuseextension.CompositionLanguageSyntaxSpecification;
import org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;




/**
 * @generated
 **/
public class CompositionLanguageSyntaxSpecificationImpl extends ReuseExtensionImpl implements CompositionLanguageSyntaxSpecification
{


   /**
   * The cached value of the '{@link #getFragmentRoleBindings() <em>Fragment Role Bindings</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFragmentRoleBindings()
   * @generated
   * @ordered
   */
  protected EList<FragmentRole2SyntaxBinding> fragmentRoleBindings;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CompositionLanguageSyntaxSpecificationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<FragmentRole2SyntaxBinding> getFragmentRoleBindings()
  {
    if (fragmentRoleBindings == null)
    {
      fragmentRoleBindings = new EObjectContainmentWithInverseEList<FragmentRole2SyntaxBinding>(FragmentRole2SyntaxBinding.class, this, ReuseextensionPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRAGMENT_ROLE_BINDINGS, ReuseextensionPackage.FRAGMENT_ROLE2_SYNTAX_BINDING__COMPOSITION_LANGUAGE_SYNTAX);
    }
    return fragmentRoleBindings;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRAGMENT_ROLE_BINDINGS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getFragmentRoleBindings()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRAGMENT_ROLE_BINDINGS:
        return ((InternalEList<?>)getFragmentRoleBindings()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRAGMENT_ROLE_BINDINGS:
        return getFragmentRoleBindings();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRAGMENT_ROLE_BINDINGS:
        getFragmentRoleBindings().clear();
        getFragmentRoleBindings().addAll((Collection<? extends FragmentRole2SyntaxBinding>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRAGMENT_ROLE_BINDINGS:
        getFragmentRoleBindings().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION__FRAGMENT_ROLE_BINDINGS:
        return fragmentRoleBindings != null && !fragmentRoleBindings.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  public void removeYou()
   {
      this.getFragmentRoleBindings().clear();
super.removeYou ();   }
}


