/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.reuseextension.CompositionLanguageSpecification;
import org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding;
import org.reuseware.coconut.reuseextension.PortType2SettingBinding;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;
import org.reuseware.coconut.reuseextension.RuleContext;




/**
 * @generated
 **/
public class FragmentRole2FragmentInstanceBindingImpl extends FragmentRoleBindingImpl implements FragmentRole2FragmentInstanceBinding
{


   /**
   * The cached value of the '{@link #getEBoundClass() <em>EBound Class</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEBoundClass()
   * @generated
   * @ordered
   */
  protected EClass eBoundClass;
  /**
   * The cached value of the '{@link #getEBoundFeature() <em>EBound Feature</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEBoundFeature()
   * @generated
   * @ordered
   */
  protected EStructuralFeature eBoundFeature;
  /**
   * The default value of the '{@link #getIsExpression() <em>Is Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIsExpression()
   * @generated
   * @ordered
   */
  protected static final String IS_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getIsExpression() <em>Is Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIsExpression()
   * @generated
   * @ordered
   */
  protected String isExpression = IS_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getNameExpression() <em>Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNameExpression()
   * @generated
   * @ordered
   */
  protected static final String NAME_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getNameExpression() <em>Name Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNameExpression()
   * @generated
   * @ordered
   */
  protected String nameExpression = NAME_EXPRESSION_EDEFAULT;
  /**
   * The cached value of the '{@link #getPortTypeBindings() <em>Port Type Bindings</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPortTypeBindings()
   * @generated
   * @ordered
   */
  protected EList<PortType2SettingBinding> portTypeBindings;
  /**
   * The default value of the '{@link #getTargetPhysicalLocationExpression() <em>Target Physical Location Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetPhysicalLocationExpression()
   * @generated
   * @ordered
   */
  protected static final String TARGET_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getTargetPhysicalLocationExpression() <em>Target Physical Location Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetPhysicalLocationExpression()
   * @generated
   * @ordered
   */
  protected String targetPhysicalLocationExpression = TARGET_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getTargetUfiExpression() <em>Target Ufi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetUfiExpression()
   * @generated
   * @ordered
   */
  protected static final String TARGET_UFI_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getTargetUfiExpression() <em>Target Ufi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetUfiExpression()
   * @generated
   * @ordered
   */
  protected String targetUfiExpression = TARGET_UFI_EXPRESSION_EDEFAULT;
  /**
   * The default value of the '{@link #getUfiExpression() <em>Ufi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUfiExpression()
   * @generated
   * @ordered
   */
  protected static final String UFI_EXPRESSION_EDEFAULT = null;
  /**
   * The cached value of the '{@link #getUfiExpression() <em>Ufi Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUfiExpression()
   * @generated
   * @ordered
   */
  protected String ufiExpression = UFI_EXPRESSION_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FragmentRole2FragmentInstanceBindingImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getEBoundClass()
  {
    if (eBoundClass != null && eBoundClass.eIsProxy())
    {
      InternalEObject oldEBoundClass = (InternalEObject)eBoundClass;
      eBoundClass = (EClass)eResolveProxy(oldEBoundClass);
      if (eBoundClass != oldEBoundClass)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_CLASS, oldEBoundClass, eBoundClass));
      }
    }
    return eBoundClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass basicGetEBoundClass()
  {
    return eBoundClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEBoundClass(EClass newEBoundClass)
  {
    EClass oldEBoundClass = eBoundClass;
    eBoundClass = newEBoundClass;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_CLASS, oldEBoundClass, eBoundClass));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EStructuralFeature getEBoundFeature()
  {
    if (eBoundFeature != null && eBoundFeature.eIsProxy())
    {
      InternalEObject oldEBoundFeature = (InternalEObject)eBoundFeature;
      eBoundFeature = (EStructuralFeature)eResolveProxy(oldEBoundFeature);
      if (eBoundFeature != oldEBoundFeature)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_FEATURE, oldEBoundFeature, eBoundFeature));
      }
    }
    return eBoundFeature;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EStructuralFeature basicGetEBoundFeature()
  {
    return eBoundFeature;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEBoundFeature(EStructuralFeature newEBoundFeature)
  {
    EStructuralFeature oldEBoundFeature = eBoundFeature;
    eBoundFeature = newEBoundFeature;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_FEATURE, oldEBoundFeature, eBoundFeature));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getIsExpression()
  {
    return isExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setIsExpression(String newIsExpression)
  {
    String oldIsExpression = isExpression;
    isExpression = newIsExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__IS_EXPRESSION, oldIsExpression, isExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CompositionLanguageSpecification getCompositionLanguageSpecification()
  {
    if (eContainerFeatureID() != ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION) return null;
    return (CompositionLanguageSpecification)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetCompositionLanguageSpecification(CompositionLanguageSpecification newCompositionLanguageSpecification, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newCompositionLanguageSpecification, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCompositionLanguageSpecification(CompositionLanguageSpecification newCompositionLanguageSpecification)
  {
    if (newCompositionLanguageSpecification != eInternalContainer() || (eContainerFeatureID() != ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION && newCompositionLanguageSpecification != null))
    {
      if (EcoreUtil.isAncestor(this, newCompositionLanguageSpecification))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newCompositionLanguageSpecification != null)
        msgs = ((InternalEObject)newCompositionLanguageSpecification).eInverseAdd(this, ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__FRAGMENT_ROLE_BINDINGS, CompositionLanguageSpecification.class, msgs);
      msgs = basicSetCompositionLanguageSpecification(newCompositionLanguageSpecification, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION, newCompositionLanguageSpecification, newCompositionLanguageSpecification));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNameExpression()
  {
    return nameExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNameExpression(String newNameExpression)
  {
    String oldNameExpression = nameExpression;
    nameExpression = newNameExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__NAME_EXPRESSION, oldNameExpression, nameExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<PortType2SettingBinding> getPortTypeBindings()
  {
    if (portTypeBindings == null)
    {
      portTypeBindings = new EObjectContainmentWithInverseEList<PortType2SettingBinding>(PortType2SettingBinding.class, this, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__PORT_TYPE_BINDINGS, ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING);
    }
    return portTypeBindings;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getTargetPhysicalLocationExpression()
  {
    return targetPhysicalLocationExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetPhysicalLocationExpression(String newTargetPhysicalLocationExpression)
  {
    String oldTargetPhysicalLocationExpression = targetPhysicalLocationExpression;
    targetPhysicalLocationExpression = newTargetPhysicalLocationExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION, oldTargetPhysicalLocationExpression, targetPhysicalLocationExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getTargetUfiExpression()
  {
    return targetUfiExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetUfiExpression(String newTargetUfiExpression)
  {
    String oldTargetUfiExpression = targetUfiExpression;
    targetUfiExpression = newTargetUfiExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_UFI_EXPRESSION, oldTargetUfiExpression, targetUfiExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getUfiExpression()
  {
    return ufiExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUfiExpression(String newUfiExpression)
  {
    String oldUfiExpression = ufiExpression;
    ufiExpression = newUfiExpression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__UFI_EXPRESSION, oldUfiExpression, ufiExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetCompositionLanguageSpecification((CompositionLanguageSpecification)otherEnd, msgs);
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__PORT_TYPE_BINDINGS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getPortTypeBindings()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION:
        return basicSetCompositionLanguageSpecification(null, msgs);
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__PORT_TYPE_BINDINGS:
        return ((InternalEList<?>)getPortTypeBindings()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION:
        return eInternalContainer().eInverseRemove(this, ReuseextensionPackage.COMPOSITION_LANGUAGE_SPECIFICATION__FRAGMENT_ROLE_BINDINGS, CompositionLanguageSpecification.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_CLASS:
        if (resolve) return getEBoundClass();
        return basicGetEBoundClass();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_FEATURE:
        if (resolve) return getEBoundFeature();
        return basicGetEBoundFeature();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__IS_EXPRESSION:
        return getIsExpression();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION:
        return getCompositionLanguageSpecification();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__NAME_EXPRESSION:
        return getNameExpression();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__PORT_TYPE_BINDINGS:
        return getPortTypeBindings();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION:
        return getTargetPhysicalLocationExpression();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_UFI_EXPRESSION:
        return getTargetUfiExpression();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__UFI_EXPRESSION:
        return getUfiExpression();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_CLASS:
        setEBoundClass((EClass)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_FEATURE:
        setEBoundFeature((EStructuralFeature)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__IS_EXPRESSION:
        setIsExpression((String)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION:
        setCompositionLanguageSpecification((CompositionLanguageSpecification)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__NAME_EXPRESSION:
        setNameExpression((String)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__PORT_TYPE_BINDINGS:
        getPortTypeBindings().clear();
        getPortTypeBindings().addAll((Collection<? extends PortType2SettingBinding>)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION:
        setTargetPhysicalLocationExpression((String)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_UFI_EXPRESSION:
        setTargetUfiExpression((String)newValue);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__UFI_EXPRESSION:
        setUfiExpression((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_CLASS:
        setEBoundClass((EClass)null);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_FEATURE:
        setEBoundFeature((EStructuralFeature)null);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__IS_EXPRESSION:
        setIsExpression(IS_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION:
        setCompositionLanguageSpecification((CompositionLanguageSpecification)null);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__NAME_EXPRESSION:
        setNameExpression(NAME_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__PORT_TYPE_BINDINGS:
        getPortTypeBindings().clear();
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION:
        setTargetPhysicalLocationExpression(TARGET_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_UFI_EXPRESSION:
        setTargetUfiExpression(TARGET_UFI_EXPRESSION_EDEFAULT);
        return;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__UFI_EXPRESSION:
        setUfiExpression(UFI_EXPRESSION_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_CLASS:
        return eBoundClass != null;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_FEATURE:
        return eBoundFeature != null;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__IS_EXPRESSION:
        return IS_EXPRESSION_EDEFAULT == null ? isExpression != null : !IS_EXPRESSION_EDEFAULT.equals(isExpression);
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__COMPOSITION_LANGUAGE_SPECIFICATION:
        return getCompositionLanguageSpecification() != null;
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__NAME_EXPRESSION:
        return NAME_EXPRESSION_EDEFAULT == null ? nameExpression != null : !NAME_EXPRESSION_EDEFAULT.equals(nameExpression);
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__PORT_TYPE_BINDINGS:
        return portTypeBindings != null && !portTypeBindings.isEmpty();
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_PHYSICAL_LOCATION_EXPRESSION:
        return TARGET_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT == null ? targetPhysicalLocationExpression != null : !TARGET_PHYSICAL_LOCATION_EXPRESSION_EDEFAULT.equals(targetPhysicalLocationExpression);
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__TARGET_UFI_EXPRESSION:
        return TARGET_UFI_EXPRESSION_EDEFAULT == null ? targetUfiExpression != null : !TARGET_UFI_EXPRESSION_EDEFAULT.equals(targetUfiExpression);
      case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__UFI_EXPRESSION:
        return UFI_EXPRESSION_EDEFAULT == null ? ufiExpression != null : !UFI_EXPRESSION_EDEFAULT.equals(ufiExpression);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == RuleContext.class)
    {
      switch (derivedFeatureID)
      {
        case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_CLASS: return ReuseextensionPackage.RULE_CONTEXT__EBOUND_CLASS;
        case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_FEATURE: return ReuseextensionPackage.RULE_CONTEXT__EBOUND_FEATURE;
        case ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__IS_EXPRESSION: return ReuseextensionPackage.RULE_CONTEXT__IS_EXPRESSION;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == RuleContext.class)
    {
      switch (baseFeatureID)
      {
        case ReuseextensionPackage.RULE_CONTEXT__EBOUND_CLASS: return ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_CLASS;
        case ReuseextensionPackage.RULE_CONTEXT__EBOUND_FEATURE: return ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__EBOUND_FEATURE;
        case ReuseextensionPackage.RULE_CONTEXT__IS_EXPRESSION: return ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__IS_EXPRESSION;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (isExpression: ");
    result.append(isExpression);
    result.append(", nameExpression: ");
    result.append(nameExpression);
    result.append(", targetPhysicalLocationExpression: ");
    result.append(targetPhysicalLocationExpression);
    result.append(", targetUfiExpression: ");
    result.append(targetUfiExpression);
    result.append(", ufiExpression: ");
    result.append(ufiExpression);
    result.append(')');
    return result.toString();
  }

  public void removeYou()
   {
      this.setCompositionLanguageSpecification (null);
      this.setEBoundClass (null);
      this.setEBoundFeature (null);
      this.getPortTypeBindings().clear();
super.removeYou ();   }
}


