/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/
package org.reuseware.coconut.reuseextension.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding;
import org.reuseware.coconut.reuseextension.PortType2SettingBinding;
import org.reuseware.coconut.reuseextension.ReuseextensionPackage;
import org.reuseware.coconut.reuseextension.SettingDerivationRule;




/**
 * @generated
 **/
public class PortType2SettingBindingImpl extends PortTypeBindingImpl implements PortType2SettingBinding
{


   /**
   * The cached value of the '{@link #getDerivationRules() <em>Derivation Rules</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDerivationRules()
   * @generated
   * @ordered
   */
  protected EList<SettingDerivationRule> derivationRules;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PortType2SettingBindingImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ReuseextensionPackage.Literals.PORT_TYPE2_SETTING_BINDING;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SettingDerivationRule> getDerivationRules()
  {
    if (derivationRules == null)
    {
      derivationRules = new EObjectContainmentWithInverseEList<SettingDerivationRule>(SettingDerivationRule.class, this, ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__DERIVATION_RULES, ReuseextensionPackage.SETTING_DERIVATION_RULE__PORT_TYPE_BINDING);
    }
    return derivationRules;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FragmentRole2FragmentInstanceBinding getFragmentRoleBinding()
  {
    if (eContainerFeatureID() != ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING) return null;
    return (FragmentRole2FragmentInstanceBinding)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetFragmentRoleBinding(FragmentRole2FragmentInstanceBinding newFragmentRoleBinding, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newFragmentRoleBinding, ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFragmentRoleBinding(FragmentRole2FragmentInstanceBinding newFragmentRoleBinding)
  {
    if (newFragmentRoleBinding != eInternalContainer() || (eContainerFeatureID() != ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING && newFragmentRoleBinding != null))
    {
      if (EcoreUtil.isAncestor(this, newFragmentRoleBinding))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newFragmentRoleBinding != null)
        msgs = ((InternalEObject)newFragmentRoleBinding).eInverseAdd(this, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__PORT_TYPE_BINDINGS, FragmentRole2FragmentInstanceBinding.class, msgs);
      msgs = basicSetFragmentRoleBinding(newFragmentRoleBinding, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING, newFragmentRoleBinding, newFragmentRoleBinding));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__DERIVATION_RULES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getDerivationRules()).basicAdd(otherEnd, msgs);
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetFragmentRoleBinding((FragmentRole2FragmentInstanceBinding)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__DERIVATION_RULES:
        return ((InternalEList<?>)getDerivationRules()).basicRemove(otherEnd, msgs);
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING:
        return basicSetFragmentRoleBinding(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID())
    {
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING:
        return eInternalContainer().eInverseRemove(this, ReuseextensionPackage.FRAGMENT_ROLE2_FRAGMENT_INSTANCE_BINDING__PORT_TYPE_BINDINGS, FragmentRole2FragmentInstanceBinding.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__DERIVATION_RULES:
        return getDerivationRules();
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING:
        return getFragmentRoleBinding();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__DERIVATION_RULES:
        getDerivationRules().clear();
        getDerivationRules().addAll((Collection<? extends SettingDerivationRule>)newValue);
        return;
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING:
        setFragmentRoleBinding((FragmentRole2FragmentInstanceBinding)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__DERIVATION_RULES:
        getDerivationRules().clear();
        return;
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING:
        setFragmentRoleBinding((FragmentRole2FragmentInstanceBinding)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__DERIVATION_RULES:
        return derivationRules != null && !derivationRules.isEmpty();
      case ReuseextensionPackage.PORT_TYPE2_SETTING_BINDING__FRAGMENT_ROLE_BINDING:
        return getFragmentRoleBinding() != null;
    }
    return super.eIsSet(featureID);
  }

  public void removeYou()
   {
      this.getDerivationRules().clear();
      this.setFragmentRoleBinding (null);
super.removeYou ();   }
}


