/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.reuseextension.resource.rex.mopp;

/**
 * Abstract super class for all expected elements. Provides methods to add
 * followers.
 */
public abstract class RexAbstractExpectedElement implements org.reuseware.coconut.reuseextension.resource.rex.IRexExpectedElement {
	
	private org.eclipse.emf.ecore.EClass ruleMetaclass;
	
	private java.util.Set<org.reuseware.coconut.reuseextension.resource.rex.util.RexPair<org.reuseware.coconut.reuseextension.resource.rex.IRexExpectedElement, org.reuseware.coconut.reuseextension.resource.rex.mopp.RexContainedFeature[]>> followers = new java.util.LinkedHashSet<org.reuseware.coconut.reuseextension.resource.rex.util.RexPair<org.reuseware.coconut.reuseextension.resource.rex.IRexExpectedElement, org.reuseware.coconut.reuseextension.resource.rex.mopp.RexContainedFeature[]>>();
	
	public RexAbstractExpectedElement(org.eclipse.emf.ecore.EClass ruleMetaclass) {
		super();
		this.ruleMetaclass = ruleMetaclass;
	}
	
	public org.eclipse.emf.ecore.EClass getRuleMetaclass() {
		return ruleMetaclass;
	}
	
	public void addFollower(org.reuseware.coconut.reuseextension.resource.rex.IRexExpectedElement follower, org.reuseware.coconut.reuseextension.resource.rex.mopp.RexContainedFeature[] path) {
		followers.add(new org.reuseware.coconut.reuseextension.resource.rex.util.RexPair<org.reuseware.coconut.reuseextension.resource.rex.IRexExpectedElement, org.reuseware.coconut.reuseextension.resource.rex.mopp.RexContainedFeature[]>(follower, path));
	}
	
	public java.util.Collection<org.reuseware.coconut.reuseextension.resource.rex.util.RexPair<org.reuseware.coconut.reuseextension.resource.rex.IRexExpectedElement, org.reuseware.coconut.reuseextension.resource.rex.mopp.RexContainedFeature[]>> getFollowers() {
		return followers;
	}
	
}
