/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.reuseextension.resource.rex.mopp;

public class RexMetaInformation implements org.reuseware.coconut.reuseextension.resource.rex.IRexMetaInformation {
	
	public String getSyntaxName() {
		return "rex";
	}
	
	public String getURI() {
		return "http://reuseware.org/coconut/reuseextension";
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexTextScanner createLexer() {
		return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexAntlrScanner(new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexLexer());
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexTextParser createParser(java.io.InputStream inputStream, String encoding) {
		return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexParser().createInstance(inputStream, encoding);
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexTextPrinter createPrinter(java.io.OutputStream outputStream, org.reuseware.coconut.reuseextension.resource.rex.IRexTextResource resource) {
		return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexPrinter2(outputStream, resource);
	}
	
	public org.eclipse.emf.ecore.EClass[] getClassesWithSyntax() {
		return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexSyntaxCoverageInformationProvider().getClassesWithSyntax();
	}
	
	public org.eclipse.emf.ecore.EClass[] getStartSymbols() {
		return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexSyntaxCoverageInformationProvider().getStartSymbols();
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexReferenceResolverSwitch getReferenceResolverSwitch() {
		return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexReferenceResolverSwitch();
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexTokenResolverFactory getTokenResolverFactory() {
		return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenResolverFactory();
	}
	
	public String getPathToCSDefinition() {
		return "org.reuseware.coconut.reuseextension/model/rex.cs";
	}
	
	public String[] getTokenNames() {
		return org.reuseware.coconut.reuseextension.resource.rex.mopp.RexParser.tokenNames;
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexTokenStyle getDefaultTokenStyle(String tokenName) {
		return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyleInformationProvider().getDefaultTokenStyle(tokenName);
	}
	
	public java.util.Collection<org.reuseware.coconut.reuseextension.resource.rex.IRexBracketPair> getBracketPairs() {
		return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexBracketInformationProvider().getBracketPairs();
	}
	
	public org.eclipse.emf.ecore.EClass[] getFoldableClasses() {
		return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexFoldingInformationProvider().getFoldableClasses();
	}
	
	public org.eclipse.emf.ecore.resource.Resource.Factory createResourceFactory() {
		return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexResourceFactory();
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.mopp.RexNewFileContentProvider getNewFileContentProvider() {
		return new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexNewFileContentProvider();
	}
	
	public void registerResourceFactory() {
		org.eclipse.emf.ecore.resource.Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put(getSyntaxName(), new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexResourceFactory());
	}
	
	/**
	 * Returns the key of the option that can be used to register a preprocessor that
	 * is used as a pipe when loading resources. This key is language-specific. To
	 * register one preprocessor for multiple resource types, it must be registered
	 * individually using all keys.
	 */
	public String getInputStreamPreprocessorProviderOptionKey() {
		return getSyntaxName() + "_" + "INPUT_STREAM_PREPROCESSOR_PROVIDER";
	}
	
	/**
	 * Returns the key of the option that can be used to register a post-processors
	 * that are invoked after loading resources. This key is language-specific. To
	 * register one post-processor for multiple resource types, it must be registered
	 * individually using all keys.
	 */
	public String getResourcePostProcessorProviderOptionKey() {
		return getSyntaxName() + "_" + "RESOURCE_POSTPROCESSOR_PROVIDER";
	}
	
	public String getLaunchConfigurationType() {
		return "org.reuseware.comogen.reuseextension.ui.launchConfigurationType";
	}
	
	public org.reuseware.coconut.reuseextension.resource.rex.IRexNameProvider createNameProvider() {
		return new org.reuseware.coconut.reuseextension.resource.rex.analysis.RexDefaultNameProvider();
	}
	
	public String[] getSyntaxHighlightableTokenNames() {
		org.reuseware.coconut.reuseextension.resource.rex.mopp.RexAntlrTokenHelper tokenHelper = new org.reuseware.coconut.reuseextension.resource.rex.mopp.RexAntlrTokenHelper();
		java.util.List<String> highlightableTokens = new java.util.ArrayList<String>();
		String[] parserTokenNames = getTokenNames();
		for (int i = 0; i < parserTokenNames.length; i++) {
			// If ANTLR is used we need to normalize the token names
			if (!tokenHelper.canBeUsedForSyntaxHighlighting(i)) {
				continue;
			}
			String tokenName = tokenHelper.getTokenName(parserTokenNames, i);
			if (tokenName == null) {
				continue;
			}
			highlightableTokens.add(tokenName);
		}
		highlightableTokens.add(org.reuseware.coconut.reuseextension.resource.rex.mopp.RexTokenStyleInformationProvider.TASK_ITEM_TOKEN_NAME);
		return highlightableTokens.toArray(new String[highlightableTokens.size()]);
	}
	
}
