/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextension.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import org.reuseware.coconut.reuseextension.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see org.reuseware.coconut.reuseextension.ReuseextensionPackage
 * @generated
 */
public class ReuseextensionAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static ReuseextensionPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReuseextensionAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = ReuseextensionPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch that delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ReuseextensionSwitch<Adapter> modelSwitch =
    new ReuseextensionSwitch<Adapter>()
    {
      @Override
      public Adapter caseAddressablePointDerivationRule(AddressablePointDerivationRule object)
      {
        return createAddressablePointDerivationRuleAdapter();
      }
      @Override
      public Adapter caseAnchorDerivationRule(AnchorDerivationRule object)
      {
        return createAnchorDerivationRuleAdapter();
      }
      @Override
      public Adapter caseComponentModelSpecification(ComponentModelSpecification object)
      {
        return createComponentModelSpecificationAdapter();
      }
      @Override
      public Adapter caseCompositionAssociation2CompositionLinkBinding(CompositionAssociation2CompositionLinkBinding object)
      {
        return createCompositionAssociation2CompositionLinkBindingAdapter();
      }
      @Override
      public Adapter caseCompositionAssociationBinding(CompositionAssociationBinding object)
      {
        return createCompositionAssociationBindingAdapter();
      }
      @Override
      public Adapter caseCompositionLanguageSpecification(CompositionLanguageSpecification object)
      {
        return createCompositionLanguageSpecificationAdapter();
      }
      @Override
      public Adapter caseCompositionLanguageSyntaxSpecification(CompositionLanguageSyntaxSpecification object)
      {
        return createCompositionLanguageSyntaxSpecificationAdapter();
      }
      @Override
      public Adapter caseFragmentRole2FragmentBinding(FragmentRole2FragmentBinding object)
      {
        return createFragmentRole2FragmentBindingAdapter();
      }
      @Override
      public Adapter caseFragmentRole2FragmentInstanceBinding(FragmentRole2FragmentInstanceBinding object)
      {
        return createFragmentRole2FragmentInstanceBindingAdapter();
      }
      @Override
      public Adapter caseFragmentRole2FragmentReferenceBinding(FragmentRole2FragmentReferenceBinding object)
      {
        return createFragmentRole2FragmentReferenceBindingAdapter();
      }
      @Override
      public Adapter caseFragmentRole2SyntaxBinding(FragmentRole2SyntaxBinding object)
      {
        return createFragmentRole2SyntaxBindingAdapter();
      }
      @Override
      public Adapter caseFragmentRoleBinding(FragmentRoleBinding object)
      {
        return createFragmentRoleBindingAdapter();
      }
      @Override
      public Adapter caseHookDerivationRule(HookDerivationRule object)
      {
        return createHookDerivationRuleAdapter();
      }
      @Override
      public Adapter casePortType2HeterogeneousPortBinding(PortType2HeterogeneousPortBinding object)
      {
        return createPortType2HeterogeneousPortBindingAdapter();
      }
      @Override
      public Adapter casePortType2HomogenousPortBinding(PortType2HomogenousPortBinding object)
      {
        return createPortType2HomogenousPortBindingAdapter();
      }
      @Override
      public Adapter casePortType2PortBinding(PortType2PortBinding object)
      {
        return createPortType2PortBindingAdapter();
      }
      @Override
      public Adapter casePortType2SettingBinding(PortType2SettingBinding object)
      {
        return createPortType2SettingBindingAdapter();
      }
      @Override
      public Adapter casePortType2SyntaxBinding(PortType2SyntaxBinding object)
      {
        return createPortType2SyntaxBindingAdapter();
      }
      @Override
      public Adapter casePortTypeBinding(PortTypeBinding object)
      {
        return createPortTypeBindingAdapter();
      }
      @Override
      public Adapter casePrototypeDerivationRule(PrototypeDerivationRule object)
      {
        return createPrototypeDerivationRuleAdapter();
      }
      @Override
      public Adapter caseReferencePointDerivationRule(ReferencePointDerivationRule object)
      {
        return createReferencePointDerivationRuleAdapter();
      }
      @Override
      public Adapter caseReuseExtension(ReuseExtension object)
      {
        return createReuseExtensionAdapter();
      }
      @Override
      public Adapter caseRootElementContext(RootElementContext object)
      {
        return createRootElementContextAdapter();
      }
      @Override
      public Adapter caseRuleContext(RuleContext object)
      {
        return createRuleContextAdapter();
      }
      @Override
      public Adapter caseSettingDerivationRule(SettingDerivationRule object)
      {
        return createSettingDerivationRuleAdapter();
      }
      @Override
      public Adapter caseSlotDerivationRule(SlotDerivationRule object)
      {
        return createSlotDerivationRuleAdapter();
      }
      @Override
      public Adapter caseSyntaxDerivationRule(SyntaxDerivationRule object)
      {
        return createSyntaxDerivationRuleAdapter();
      }
      @Override
      public Adapter caseValueHookDerivationRule(ValueHookDerivationRule object)
      {
        return createValueHookDerivationRuleAdapter();
      }
      @Override
      public Adapter caseValuePrototypeDerivationRule(ValuePrototypeDerivationRule object)
      {
        return createValuePrototypeDerivationRuleAdapter();
      }
      @Override
      public Adapter caseVariationPointDerivationRule(VariationPointDerivationRule object)
      {
        return createVariationPointDerivationRuleAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.AddressablePointDerivationRule <em>Addressable Point Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.AddressablePointDerivationRule
   * @generated
   */
  public Adapter createAddressablePointDerivationRuleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.AnchorDerivationRule <em>Anchor Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.AnchorDerivationRule
   * @generated
   */
  public Adapter createAnchorDerivationRuleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.ComponentModelSpecification <em>Component Model Specification</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.ComponentModelSpecification
   * @generated
   */
  public Adapter createComponentModelSpecificationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding <em>Composition Association2 Composition Link Binding</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.CompositionAssociation2CompositionLinkBinding
   * @generated
   */
  public Adapter createCompositionAssociation2CompositionLinkBindingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.CompositionAssociationBinding <em>Composition Association Binding</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.CompositionAssociationBinding
   * @generated
   */
  public Adapter createCompositionAssociationBindingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSpecification <em>Composition Language Specification</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.CompositionLanguageSpecification
   * @generated
   */
  public Adapter createCompositionLanguageSpecificationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.CompositionLanguageSyntaxSpecification <em>Composition Language Syntax Specification</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.CompositionLanguageSyntaxSpecification
   * @generated
   */
  public Adapter createCompositionLanguageSyntaxSpecificationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding <em>Fragment Role2 Fragment Binding</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentBinding
   * @generated
   */
  public Adapter createFragmentRole2FragmentBindingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding <em>Fragment Role2 Fragment Instance Binding</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentInstanceBinding
   * @generated
   */
  public Adapter createFragmentRole2FragmentInstanceBindingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.FragmentRole2FragmentReferenceBinding <em>Fragment Role2 Fragment Reference Binding</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2FragmentReferenceBinding
   * @generated
   */
  public Adapter createFragmentRole2FragmentReferenceBindingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding <em>Fragment Role2 Syntax Binding</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.FragmentRole2SyntaxBinding
   * @generated
   */
  public Adapter createFragmentRole2SyntaxBindingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.FragmentRoleBinding <em>Fragment Role Binding</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.FragmentRoleBinding
   * @generated
   */
  public Adapter createFragmentRoleBindingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.HookDerivationRule <em>Hook Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.HookDerivationRule
   * @generated
   */
  public Adapter createHookDerivationRuleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.PortType2HeterogeneousPortBinding <em>Port Type2 Heterogeneous Port Binding</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.PortType2HeterogeneousPortBinding
   * @generated
   */
  public Adapter createPortType2HeterogeneousPortBindingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.PortType2HomogenousPortBinding <em>Port Type2 Homogenous Port Binding</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.PortType2HomogenousPortBinding
   * @generated
   */
  public Adapter createPortType2HomogenousPortBindingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.PortType2PortBinding <em>Port Type2 Port Binding</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.PortType2PortBinding
   * @generated
   */
  public Adapter createPortType2PortBindingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.PortType2SettingBinding <em>Port Type2 Setting Binding</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.PortType2SettingBinding
   * @generated
   */
  public Adapter createPortType2SettingBindingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.PortType2SyntaxBinding <em>Port Type2 Syntax Binding</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.PortType2SyntaxBinding
   * @generated
   */
  public Adapter createPortType2SyntaxBindingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.PortTypeBinding <em>Port Type Binding</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.PortTypeBinding
   * @generated
   */
  public Adapter createPortTypeBindingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.PrototypeDerivationRule <em>Prototype Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.PrototypeDerivationRule
   * @generated
   */
  public Adapter createPrototypeDerivationRuleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.ReferencePointDerivationRule <em>Reference Point Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.ReferencePointDerivationRule
   * @generated
   */
  public Adapter createReferencePointDerivationRuleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.ReuseExtension <em>Reuse Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.ReuseExtension
   * @generated
   */
  public Adapter createReuseExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.RootElementContext <em>Root Element Context</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.RootElementContext
   * @generated
   */
  public Adapter createRootElementContextAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.RuleContext <em>Rule Context</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.RuleContext
   * @generated
   */
  public Adapter createRuleContextAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.SettingDerivationRule <em>Setting Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.SettingDerivationRule
   * @generated
   */
  public Adapter createSettingDerivationRuleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.SlotDerivationRule <em>Slot Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.SlotDerivationRule
   * @generated
   */
  public Adapter createSlotDerivationRuleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.SyntaxDerivationRule <em>Syntax Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.SyntaxDerivationRule
   * @generated
   */
  public Adapter createSyntaxDerivationRuleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.ValueHookDerivationRule <em>Value Hook Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.ValueHookDerivationRule
   * @generated
   */
  public Adapter createValueHookDerivationRuleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.ValuePrototypeDerivationRule <em>Value Prototype Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.ValuePrototypeDerivationRule
   * @generated
   */
  public Adapter createValuePrototypeDerivationRuleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextension.VariationPointDerivationRule <em>Variation Point Derivation Rule</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextension.VariationPointDerivationRule
   * @generated
   */
  public Adapter createVariationPointDerivationRuleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //ReuseextensionAdapterFactory
