/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextensionactivator;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Argument</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextensionactivator.Argument#getParameter <em>Parameter</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextensionactivator.Argument#getReuseExtensionActivator <em>Reuse Extension Activator</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextensionactivator.Argument#getValue <em>Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage#getArgument()
 * @model
 * @generated
 */
public interface Argument extends EObject
{
  /**
   * Returns the value of the '<em><b>Parameter</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Parameter</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Parameter</em>' attribute.
   * @see #setParameter(String)
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage#getArgument_Parameter()
   * @model required="true"
   * @generated
   */
  String getParameter();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextensionactivator.Argument#getParameter <em>Parameter</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Parameter</em>' attribute.
   * @see #getParameter()
   * @generated
   */
  void setParameter(String value);

  /**
   * Returns the value of the '<em><b>Reuse Extension Activator</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getArguments <em>Arguments</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Reuse Extension Activator</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Reuse Extension Activator</em>' container reference.
   * @see #setReuseExtensionActivator(ReuseExtensionActivator)
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage#getArgument_ReuseExtensionActivator()
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getArguments
   * @model opposite="arguments" transient="false" ordered="false"
   * @generated
   */
  ReuseExtensionActivator getReuseExtensionActivator();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextensionactivator.Argument#getReuseExtensionActivator <em>Reuse Extension Activator</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Reuse Extension Activator</em>' container reference.
   * @see #getReuseExtensionActivator()
   * @generated
   */
  void setReuseExtensionActivator(ReuseExtensionActivator value);

  /**
   * Returns the value of the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Value</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Value</em>' attribute.
   * @see #setValue(String)
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage#getArgument_Value()
   * @model required="true"
   * @generated
   */
  String getValue();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextensionactivator.Argument#getValue <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Value</em>' attribute.
   * @see #getValue()
   * @generated
   */
  void setValue(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // Argument
