/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextensionactivator;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

import org.reuseware.coconut.reuseextension.ReuseExtension;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Reuse Extension Activator</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getActivatorList <em>Activator List</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getArguments <em>Arguments</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getReuseExtension <em>Reuse Extension</em>}</li>
 *   <li>{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getRexNamespace <em>Rex Namespace</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage#getReuseExtensionActivator()
 * @model abstract="true"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore constraints='AllArgumentsDefined'"
 * @generated
 */
public interface ReuseExtensionActivator extends EObject
{
  /**
   * Returns the value of the '<em><b>Activator List</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivatorList#getActivators <em>Activators</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Activator List</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Activator List</em>' container reference.
   * @see #setActivatorList(ReuseExtensionActivatorList)
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage#getReuseExtensionActivator_ActivatorList()
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivatorList#getActivators
   * @model opposite="activators" transient="false" ordered="false"
   * @generated
   */
  ReuseExtensionActivatorList getActivatorList();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getActivatorList <em>Activator List</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Activator List</em>' container reference.
   * @see #getActivatorList()
   * @generated
   */
  void setActivatorList(ReuseExtensionActivatorList value);

  /**
   * Returns the value of the '<em><b>Arguments</b></em>' containment reference list.
   * The list contents are of type {@link org.reuseware.coconut.reuseextensionactivator.Argument}.
   * It is bidirectional and its opposite is '{@link org.reuseware.coconut.reuseextensionactivator.Argument#getReuseExtensionActivator <em>Reuse Extension Activator</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Arguments</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Arguments</em>' containment reference list.
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage#getReuseExtensionActivator_Arguments()
   * @see org.reuseware.coconut.reuseextensionactivator.Argument#getReuseExtensionActivator
   * @model opposite="reuseExtensionActivator" containment="true" ordered="false"
   * @generated
   */
  EList<Argument> getArguments();

  /**
   * Returns the value of the '<em><b>Reuse Extension</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Reuse Extension</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Reuse Extension</em>' reference.
   * @see #setReuseExtension(ReuseExtension)
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage#getReuseExtensionActivator_ReuseExtension()
   * @model required="true" ordered="false"
   * @generated
   */
  ReuseExtension getReuseExtension();

  /**
   * Sets the value of the '{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator#getReuseExtension <em>Reuse Extension</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Reuse Extension</em>' reference.
   * @see #getReuseExtension()
   * @generated
   */
  void setReuseExtension(ReuseExtension value);

  /**
   * Returns the value of the '<em><b>Rex Namespace</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Rex Namespace</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Rex Namespace</em>' attribute list.
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage#getReuseExtensionActivator_RexNamespace()
   * @model unique="false"
   * @generated
   */
  EList<String> getRexNamespace();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model
   * @generated
   */
  void removeYou();

} // ReuseExtensionActivator
