/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextensionactivator;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage
 * @generated
 */
public interface ReuseextensionactivatorFactory extends EFactory
{
  /**
   * The singleton instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  ReuseextensionactivatorFactory eINSTANCE = org.reuseware.coconut.reuseextensionactivator.impl.ReuseextensionactivatorFactoryImpl.init();

  /**
   * Returns a new object of class '<em>Argument</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Argument</em>'.
   * @generated
   */
  Argument createArgument();

  /**
   * Returns a new object of class '<em>Component Model Specification Activator</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Component Model Specification Activator</em>'.
   * @generated
   */
  ComponentModelSpecificationActivator createComponentModelSpecificationActivator();

  /**
   * Returns a new object of class '<em>Composition Language Specification Activator</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Composition Language Specification Activator</em>'.
   * @generated
   */
  CompositionLanguageSpecificationActivator createCompositionLanguageSpecificationActivator();

  /**
   * Returns a new object of class '<em>Composition Language Syntax Specification Activator</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Composition Language Syntax Specification Activator</em>'.
   * @generated
   */
  CompositionLanguageSyntaxSpecificationActivator createCompositionLanguageSyntaxSpecificationActivator();

  /**
   * Returns a new object of class '<em>Reuse Extension Activator List</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Reuse Extension Activator List</em>'.
   * @generated
   */
  ReuseExtensionActivatorList createReuseExtensionActivatorList();

  /**
   * Returns the package supported by this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the package supported by this factory.
   * @generated
   */
  ReuseextensionactivatorPackage getReuseextensionactivatorPackage();

} //ReuseextensionactivatorFactory
