/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.grammar;

public class Rex_activatorContainment extends org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.grammar.Rex_activatorTerminal {
	
	private final org.eclipse.emf.ecore.EClass[] allowedTypes;
	
	public Rex_activatorContainment(org.eclipse.emf.ecore.EStructuralFeature feature, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.grammar.Rex_activatorCardinality cardinality, org.eclipse.emf.ecore.EClass[] allowedTypes, int mandatoryOccurencesAfter) {
		super(feature, cardinality, mandatoryOccurencesAfter);
		this.allowedTypes = allowedTypes;
	}
	
	public org.eclipse.emf.ecore.EClass[] getAllowedTypes() {
		return allowedTypes;
	}
	
	public String toString() {
		String typeRestrictions = null;
		if (allowedTypes != null && allowedTypes.length > 0) {
			typeRestrictions = org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.util.Rex_activatorStringUtil.explode(allowedTypes, ", ", new org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorFunction1<String, org.eclipse.emf.ecore.EClass>() {
				public String execute(org.eclipse.emf.ecore.EClass eClass) {
					return eClass.getName();
				}
			});
		}
		return getFeature().getName() + (typeRestrictions == null ? "" : "[" + typeRestrictions + "]");
	}
	
}
