/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp;

/**
 * Abstract super class for all expected elements. Provides methods to add
 * followers.
 */
public abstract class Rex_activatorAbstractExpectedElement implements org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorExpectedElement {
	
	private org.eclipse.emf.ecore.EClass ruleMetaclass;
	
	private java.util.Set<org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.util.Rex_activatorPair<org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorExpectedElement, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp.Rex_activatorContainedFeature[]>> followers = new java.util.LinkedHashSet<org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.util.Rex_activatorPair<org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorExpectedElement, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp.Rex_activatorContainedFeature[]>>();
	
	public Rex_activatorAbstractExpectedElement(org.eclipse.emf.ecore.EClass ruleMetaclass) {
		super();
		this.ruleMetaclass = ruleMetaclass;
	}
	
	public org.eclipse.emf.ecore.EClass getRuleMetaclass() {
		return ruleMetaclass;
	}
	
	public void addFollower(org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorExpectedElement follower, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp.Rex_activatorContainedFeature[] path) {
		followers.add(new org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.util.Rex_activatorPair<org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorExpectedElement, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp.Rex_activatorContainedFeature[]>(follower, path));
	}
	
	public java.util.Collection<org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.util.Rex_activatorPair<org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorExpectedElement, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp.Rex_activatorContainedFeature[]>> getFollowers() {
		return followers;
	}
	
}
