/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp;

public class Rex_activatorPrinter implements org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTextPrinter {
	
	protected org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTokenResolverFactory tokenResolverFactory = new org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp.Rex_activatorTokenResolverFactory();
	
	protected java.io.OutputStream outputStream;
	
	/**
	 * Holds the resource that is associated with this printer. This may be null if
	 * the printer is used stand alone.
	 */
	private org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTextResource resource;
	
	private java.util.Map<?, ?> options;
	private String encoding = System.getProperty("file.encoding");
	
	public Rex_activatorPrinter(java.io.OutputStream outputStream, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTextResource resource) {
		super();
		this.outputStream = outputStream;
		this.resource = resource;
	}
	
	protected int matchCount(java.util.Map<String, Integer> featureCounter, java.util.Collection<String> needed) {
		int pos = 0;
		int neg = 0;
		
		for (String featureName : featureCounter.keySet()) {
			if (needed.contains(featureName)) {
				int value = featureCounter.get(featureName);
				if (value == 0) {
					neg += 1;
				} else {
					pos += 1;
				}
			}
		}
		return neg > 0 ? -neg : pos;
	}
	
	protected void doPrint(org.eclipse.emf.ecore.EObject element, java.io.PrintWriter out, String globaltab) {
		if (element == null) {
			throw new java.lang.IllegalArgumentException("Nothing to write.");
		}
		if (out == null) {
			throw new java.lang.IllegalArgumentException("Nothing to write on.");
		}
		
		if (element instanceof org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivatorList) {
			print_org_reuseware_coconut_reuseextensionactivator_ReuseExtensionActivatorList((org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivatorList) element, globaltab, out);
			return;
		}
		if (element instanceof org.reuseware.coconut.reuseextensionactivator.ComponentModelSpecificationActivator) {
			print_org_reuseware_coconut_reuseextensionactivator_ComponentModelSpecificationActivator((org.reuseware.coconut.reuseextensionactivator.ComponentModelSpecificationActivator) element, globaltab, out);
			return;
		}
		if (element instanceof org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSpecificationActivator) {
			print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSpecificationActivator((org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSpecificationActivator) element, globaltab, out);
			return;
		}
		if (element instanceof org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSyntaxSpecificationActivator) {
			print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSyntaxSpecificationActivator((org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSyntaxSpecificationActivator) element, globaltab, out);
			return;
		}
		if (element instanceof org.reuseware.coconut.reuseextensionactivator.Argument) {
			print_org_reuseware_coconut_reuseextensionactivator_Argument((org.reuseware.coconut.reuseextensionactivator.Argument) element, globaltab, out);
			return;
		}
		
		addWarningToResource("The printer can not handle " + element.eClass().getName() + " elements", element);
	}
	
	protected org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp.Rex_activatorReferenceResolverSwitch getReferenceResolverSwitch() {
		return (org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp.Rex_activatorReferenceResolverSwitch) new org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp.Rex_activatorMetaInformation().getReferenceResolverSwitch();
	}
	
	protected void addWarningToResource(final String errorMessage, org.eclipse.emf.ecore.EObject cause) {
		org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTextResource resource = getResource();
		if (resource == null) {
			// the resource can be null if the printer is used stand alone
			return;
		}
		resource.addProblem(new org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp.Rex_activatorProblem(errorMessage, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.Rex_activatorEProblemType.PRINT_PROBLEM, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.Rex_activatorEProblemSeverity.WARNING), cause);
	}
	
	public void setOptions(java.util.Map<?,?> options) {
		this.options = options;
	}
	
	public java.util.Map<?,?> getOptions() {
		return options;
	}
	
	public void setEncoding(String encoding) {
		if (encoding != null) {
			this.encoding = encoding;
		}
	}
	
	public String getEncoding() {
		return encoding;
	}
	
	public org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTextResource getResource() {
		return resource;
	}
	
	/**
	 * Calls {@link #doPrint(EObject, PrintWriter, String)} and writes the result to
	 * the underlying output stream.
	 */
	public void print(org.eclipse.emf.ecore.EObject element) throws java.io.IOException {
		java.io.PrintWriter out = new java.io.PrintWriter(new java.io.OutputStreamWriter(new java.io.BufferedOutputStream(outputStream), encoding));
		doPrint(element, out, "");
		out.flush();
		out.close();
	}
	
	public void print_org_reuseware_coconut_reuseextensionactivator_ReuseExtensionActivatorList(org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivatorList element, String outertab, java.io.PrintWriter out) {
		String localtab = outertab;
		// The printCountingMap contains a mapping from feature names to the number of
		// remaining elements that still need to be printed. The map is initialized with
		// the number of elements stored in each structural feature. For lists this is the
		// list size. For non-multiple features it is either 1 (if the feature is set) or
		// 0 (if the feature is null).
		java.util.Map<String, Integer> printCountingMap = new java.util.LinkedHashMap<String, Integer>(1);
		Object temp;
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR_LIST__ACTIVATORS));
		printCountingMap.put("activators", temp == null ? 0 : ((java.util.Collection<?>) temp).size());
		// print collected hidden tokens
		int count;
		// DEFINITION PART BEGINS (Containment)
		count = printCountingMap.get("activators");
		if (count > 0) {
			java.util.List<?> list = (java.util.List<?>)element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR_LIST__ACTIVATORS));
			int index  = list.size() - count;
			if (index < 0) {
				index = 0;
			}
			java.util.ListIterator<?> it  = list.listIterator(index);
			while (it.hasNext()) {
				Object o = it.next();
				doPrint((org.eclipse.emf.ecore.EObject) o, out, localtab);
			}
			printCountingMap.put("activators", 0);
		}
	}
	
	
	public void print_org_reuseware_coconut_reuseextensionactivator_ComponentModelSpecificationActivator(org.reuseware.coconut.reuseextensionactivator.ComponentModelSpecificationActivator element, String outertab, java.io.PrintWriter out) {
		String localtab = outertab;
		// The printCountingMap contains a mapping from feature names to the number of
		// remaining elements that still need to be printed. The map is initialized with
		// the number of elements stored in each structural feature. For lists this is the
		// list size. For non-multiple features it is either 1 (if the feature is set) or
		// 0 (if the feature is null).
		java.util.Map<String, Integer> printCountingMap = new java.util.LinkedHashMap<String, Integer>(4);
		Object temp;
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__ACTIVATOR_LIST));
		printCountingMap.put("activatorList", temp == null ? 0 : 1);
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__ARGUMENTS));
		printCountingMap.put("arguments", temp == null ? 0 : ((java.util.Collection<?>) temp).size());
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION));
		printCountingMap.put("reuseExtension", temp == null ? 0 : 1);
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__REX_NAMESPACE));
		printCountingMap.put("rexNamespace", temp == null ? 0 : ((java.util.Collection<?>) temp).size());
		// print collected hidden tokens
		int count;
		boolean iterate = true;
		java.io.StringWriter sWriter = null;
		java.io.PrintWriter out1 = null;
		java.util.Map<String, Integer> printCountingMap1 = null;
		// DEFINITION PART BEGINS (CsString)
		out.print("componentmodel");
		out.print(" ");
		// DEFINITION PART BEGINS (CompoundDefinition)
		iterate = true;
		while (iterate) {
			sWriter = new java.io.StringWriter();
			out1 = new java.io.PrintWriter(sWriter);
			printCountingMap1 = new java.util.LinkedHashMap<String, Integer>(printCountingMap);
			print_org_reuseware_coconut_reuseextensionactivator_ComponentModelSpecificationActivator_0(element, localtab, out1, printCountingMap1);
			if (printCountingMap.equals(printCountingMap1)) {
				iterate = false;
				out1.close();
			} else {
				out1.flush();
				out1.close();
				out.print(sWriter.toString());
				printCountingMap.putAll(printCountingMap1);
			}
		}
		// DEFINITION PART BEGINS (PlaceholderUsingDefaultToken)
		count = printCountingMap.get("reuseExtension");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION));
			if (o != null) {
				org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTokenResolver resolver = tokenResolverFactory.createTokenResolver("TEXT");
				resolver.setOptions(getOptions());
				out.print(resolver.deResolve(getReferenceResolverSwitch() == null ? null : getReferenceResolverSwitch().getReuseExtensionActivatorReuseExtensionReferenceResolver().deResolve((org.reuseware.coconut.reuseextension.ReuseExtension) o, element, (org.eclipse.emf.ecore.EReference) element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION)), element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION), element));
				out.print(" ");
			}
			printCountingMap.put("reuseExtension", count - 1);
		}
		// DEFINITION PART BEGINS (CompoundDefinition)
		sWriter = new java.io.StringWriter();
		out1 = new java.io.PrintWriter(sWriter);
		printCountingMap1 = new java.util.LinkedHashMap<String, Integer>(printCountingMap);
		print_org_reuseware_coconut_reuseextensionactivator_ComponentModelSpecificationActivator_1(element, localtab, out1, printCountingMap1);
		if (printCountingMap.equals(printCountingMap1)) {
			out1.close();
		} else {
			out1.flush();
			out1.close();
			out.print(sWriter.toString());
			printCountingMap.putAll(printCountingMap1);
		}
		// DEFINITION PART BEGINS (LineBreak)
		out.println();
		out.print(localtab);
	}
	
	public void print_org_reuseware_coconut_reuseextensionactivator_ComponentModelSpecificationActivator_0(org.reuseware.coconut.reuseextensionactivator.ComponentModelSpecificationActivator element, String outertab, java.io.PrintWriter out, java.util.Map<String, Integer> printCountingMap) {
		int count;
		// DEFINITION PART BEGINS (PlaceholderUsingDefaultToken)
		count = printCountingMap.get("rexNamespace");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__REX_NAMESPACE));
			java.util.List<?> list = (java.util.List<?>) o;
			int index = list.size() - count;
			if (index >= 0) {
				o = list.get(index);
			} else {
				o = null;
			}
			if (o != null) {
				org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTokenResolver resolver = tokenResolverFactory.createTokenResolver("TEXT");
				resolver.setOptions(getOptions());
				out.print(resolver.deResolve((Object) o, element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__REX_NAMESPACE), element));
				out.print(" ");
			}
			printCountingMap.put("rexNamespace", count - 1);
		}
		// DEFINITION PART BEGINS (CsString)
		out.print(".");
		out.print(" ");
	}
	
	public void print_org_reuseware_coconut_reuseextensionactivator_ComponentModelSpecificationActivator_1(org.reuseware.coconut.reuseextensionactivator.ComponentModelSpecificationActivator element, String outertab, java.io.PrintWriter out, java.util.Map<String, Integer> printCountingMap) {
		String localtab = outertab;
		int count;
		boolean iterate = true;
		java.io.StringWriter sWriter = null;
		java.io.PrintWriter out1 = null;
		java.util.Map<String, Integer> printCountingMap1 = null;
		// DEFINITION PART BEGINS (CsString)
		out.print("(");
		out.print(" ");
		// DEFINITION PART BEGINS (Containment)
		count = printCountingMap.get("arguments");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__ARGUMENTS));
			java.util.List<?> list = (java.util.List<?>) o;
			int index = list.size() - count;
			if (index >= 0) {
				o = list.get(index);
			} else {
				o = null;
			}
			if (o != null) {
				doPrint((org.eclipse.emf.ecore.EObject) o, out, localtab);
			}
			printCountingMap.put("arguments", count - 1);
		}
		// DEFINITION PART BEGINS (CompoundDefinition)
		iterate = true;
		while (iterate) {
			sWriter = new java.io.StringWriter();
			out1 = new java.io.PrintWriter(sWriter);
			printCountingMap1 = new java.util.LinkedHashMap<String, Integer>(printCountingMap);
			print_org_reuseware_coconut_reuseextensionactivator_ComponentModelSpecificationActivator_1_0(element, localtab, out1, printCountingMap1);
			if (printCountingMap.equals(printCountingMap1)) {
				iterate = false;
				out1.close();
			} else {
				out1.flush();
				out1.close();
				out.print(sWriter.toString());
				printCountingMap.putAll(printCountingMap1);
			}
		}
		// DEFINITION PART BEGINS (CsString)
		out.print(")");
		out.print(" ");
	}
	
	public void print_org_reuseware_coconut_reuseextensionactivator_ComponentModelSpecificationActivator_1_0(org.reuseware.coconut.reuseextensionactivator.ComponentModelSpecificationActivator element, String outertab, java.io.PrintWriter out, java.util.Map<String, Integer> printCountingMap) {
		String localtab = outertab;
		int count;
		// DEFINITION PART BEGINS (CsString)
		out.print(",");
		// DEFINITION PART BEGINS (WhiteSpaces)
		out.print(" ");
		// DEFINITION PART BEGINS (Containment)
		count = printCountingMap.get("arguments");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPONENT_MODEL_SPECIFICATION_ACTIVATOR__ARGUMENTS));
			java.util.List<?> list = (java.util.List<?>) o;
			int index = list.size() - count;
			if (index >= 0) {
				o = list.get(index);
			} else {
				o = null;
			}
			if (o != null) {
				doPrint((org.eclipse.emf.ecore.EObject) o, out, localtab);
			}
			printCountingMap.put("arguments", count - 1);
		}
	}
	
	
	public void print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSpecificationActivator(org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSpecificationActivator element, String outertab, java.io.PrintWriter out) {
		String localtab = outertab;
		// The printCountingMap contains a mapping from feature names to the number of
		// remaining elements that still need to be printed. The map is initialized with
		// the number of elements stored in each structural feature. For lists this is the
		// list size. For non-multiple features it is either 1 (if the feature is set) or
		// 0 (if the feature is null).
		java.util.Map<String, Integer> printCountingMap = new java.util.LinkedHashMap<String, Integer>(4);
		Object temp;
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__ACTIVATOR_LIST));
		printCountingMap.put("activatorList", temp == null ? 0 : 1);
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__ARGUMENTS));
		printCountingMap.put("arguments", temp == null ? 0 : ((java.util.Collection<?>) temp).size());
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION));
		printCountingMap.put("reuseExtension", temp == null ? 0 : 1);
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__REX_NAMESPACE));
		printCountingMap.put("rexNamespace", temp == null ? 0 : ((java.util.Collection<?>) temp).size());
		// print collected hidden tokens
		int count;
		boolean iterate = true;
		java.io.StringWriter sWriter = null;
		java.io.PrintWriter out1 = null;
		java.util.Map<String, Integer> printCountingMap1 = null;
		// DEFINITION PART BEGINS (CsString)
		out.print("compositionlanguage");
		out.print(" ");
		// DEFINITION PART BEGINS (CompoundDefinition)
		iterate = true;
		while (iterate) {
			sWriter = new java.io.StringWriter();
			out1 = new java.io.PrintWriter(sWriter);
			printCountingMap1 = new java.util.LinkedHashMap<String, Integer>(printCountingMap);
			print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSpecificationActivator_0(element, localtab, out1, printCountingMap1);
			if (printCountingMap.equals(printCountingMap1)) {
				iterate = false;
				out1.close();
			} else {
				out1.flush();
				out1.close();
				out.print(sWriter.toString());
				printCountingMap.putAll(printCountingMap1);
			}
		}
		// DEFINITION PART BEGINS (PlaceholderUsingDefaultToken)
		count = printCountingMap.get("reuseExtension");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION));
			if (o != null) {
				org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTokenResolver resolver = tokenResolverFactory.createTokenResolver("TEXT");
				resolver.setOptions(getOptions());
				out.print(resolver.deResolve(getReferenceResolverSwitch() == null ? null : getReferenceResolverSwitch().getReuseExtensionActivatorReuseExtensionReferenceResolver().deResolve((org.reuseware.coconut.reuseextension.ReuseExtension) o, element, (org.eclipse.emf.ecore.EReference) element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION)), element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION), element));
				out.print(" ");
			}
			printCountingMap.put("reuseExtension", count - 1);
		}
		// DEFINITION PART BEGINS (CompoundDefinition)
		sWriter = new java.io.StringWriter();
		out1 = new java.io.PrintWriter(sWriter);
		printCountingMap1 = new java.util.LinkedHashMap<String, Integer>(printCountingMap);
		print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSpecificationActivator_1(element, localtab, out1, printCountingMap1);
		if (printCountingMap.equals(printCountingMap1)) {
			out1.close();
		} else {
			out1.flush();
			out1.close();
			out.print(sWriter.toString());
			printCountingMap.putAll(printCountingMap1);
		}
		// DEFINITION PART BEGINS (LineBreak)
		out.println();
		out.print(localtab);
	}
	
	public void print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSpecificationActivator_0(org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSpecificationActivator element, String outertab, java.io.PrintWriter out, java.util.Map<String, Integer> printCountingMap) {
		int count;
		// DEFINITION PART BEGINS (PlaceholderUsingDefaultToken)
		count = printCountingMap.get("rexNamespace");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__REX_NAMESPACE));
			java.util.List<?> list = (java.util.List<?>) o;
			int index = list.size() - count;
			if (index >= 0) {
				o = list.get(index);
			} else {
				o = null;
			}
			if (o != null) {
				org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTokenResolver resolver = tokenResolverFactory.createTokenResolver("TEXT");
				resolver.setOptions(getOptions());
				out.print(resolver.deResolve((Object) o, element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__REX_NAMESPACE), element));
				out.print(" ");
			}
			printCountingMap.put("rexNamespace", count - 1);
		}
		// DEFINITION PART BEGINS (CsString)
		out.print(".");
		out.print(" ");
	}
	
	public void print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSpecificationActivator_1(org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSpecificationActivator element, String outertab, java.io.PrintWriter out, java.util.Map<String, Integer> printCountingMap) {
		String localtab = outertab;
		int count;
		boolean iterate = true;
		java.io.StringWriter sWriter = null;
		java.io.PrintWriter out1 = null;
		java.util.Map<String, Integer> printCountingMap1 = null;
		// DEFINITION PART BEGINS (CsString)
		out.print("(");
		out.print(" ");
		// DEFINITION PART BEGINS (Containment)
		count = printCountingMap.get("arguments");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__ARGUMENTS));
			java.util.List<?> list = (java.util.List<?>) o;
			int index = list.size() - count;
			if (index >= 0) {
				o = list.get(index);
			} else {
				o = null;
			}
			if (o != null) {
				doPrint((org.eclipse.emf.ecore.EObject) o, out, localtab);
			}
			printCountingMap.put("arguments", count - 1);
		}
		// DEFINITION PART BEGINS (CompoundDefinition)
		iterate = true;
		while (iterate) {
			sWriter = new java.io.StringWriter();
			out1 = new java.io.PrintWriter(sWriter);
			printCountingMap1 = new java.util.LinkedHashMap<String, Integer>(printCountingMap);
			print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSpecificationActivator_1_0(element, localtab, out1, printCountingMap1);
			if (printCountingMap.equals(printCountingMap1)) {
				iterate = false;
				out1.close();
			} else {
				out1.flush();
				out1.close();
				out.print(sWriter.toString());
				printCountingMap.putAll(printCountingMap1);
			}
		}
		// DEFINITION PART BEGINS (CsString)
		out.print(")");
		out.print(" ");
	}
	
	public void print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSpecificationActivator_1_0(org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSpecificationActivator element, String outertab, java.io.PrintWriter out, java.util.Map<String, Integer> printCountingMap) {
		String localtab = outertab;
		int count;
		// DEFINITION PART BEGINS (CsString)
		out.print(",");
		// DEFINITION PART BEGINS (WhiteSpaces)
		out.print(" ");
		// DEFINITION PART BEGINS (Containment)
		count = printCountingMap.get("arguments");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR__ARGUMENTS));
			java.util.List<?> list = (java.util.List<?>) o;
			int index = list.size() - count;
			if (index >= 0) {
				o = list.get(index);
			} else {
				o = null;
			}
			if (o != null) {
				doPrint((org.eclipse.emf.ecore.EObject) o, out, localtab);
			}
			printCountingMap.put("arguments", count - 1);
		}
	}
	
	
	public void print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSyntaxSpecificationActivator(org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSyntaxSpecificationActivator element, String outertab, java.io.PrintWriter out) {
		String localtab = outertab;
		// The printCountingMap contains a mapping from feature names to the number of
		// remaining elements that still need to be printed. The map is initialized with
		// the number of elements stored in each structural feature. For lists this is the
		// list size. For non-multiple features it is either 1 (if the feature is set) or
		// 0 (if the feature is null).
		java.util.Map<String, Integer> printCountingMap = new java.util.LinkedHashMap<String, Integer>(4);
		Object temp;
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__ACTIVATOR_LIST));
		printCountingMap.put("activatorList", temp == null ? 0 : 1);
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__ARGUMENTS));
		printCountingMap.put("arguments", temp == null ? 0 : ((java.util.Collection<?>) temp).size());
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION));
		printCountingMap.put("reuseExtension", temp == null ? 0 : 1);
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__REX_NAMESPACE));
		printCountingMap.put("rexNamespace", temp == null ? 0 : ((java.util.Collection<?>) temp).size());
		// print collected hidden tokens
		int count;
		boolean iterate = true;
		java.io.StringWriter sWriter = null;
		java.io.PrintWriter out1 = null;
		java.util.Map<String, Integer> printCountingMap1 = null;
		// DEFINITION PART BEGINS (CsString)
		out.print("compositionlanguagesyntax");
		out.print(" ");
		// DEFINITION PART BEGINS (CompoundDefinition)
		iterate = true;
		while (iterate) {
			sWriter = new java.io.StringWriter();
			out1 = new java.io.PrintWriter(sWriter);
			printCountingMap1 = new java.util.LinkedHashMap<String, Integer>(printCountingMap);
			print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSyntaxSpecificationActivator_0(element, localtab, out1, printCountingMap1);
			if (printCountingMap.equals(printCountingMap1)) {
				iterate = false;
				out1.close();
			} else {
				out1.flush();
				out1.close();
				out.print(sWriter.toString());
				printCountingMap.putAll(printCountingMap1);
			}
		}
		// DEFINITION PART BEGINS (PlaceholderUsingDefaultToken)
		count = printCountingMap.get("reuseExtension");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION));
			if (o != null) {
				org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTokenResolver resolver = tokenResolverFactory.createTokenResolver("TEXT");
				resolver.setOptions(getOptions());
				out.print(resolver.deResolve(getReferenceResolverSwitch() == null ? null : getReferenceResolverSwitch().getReuseExtensionActivatorReuseExtensionReferenceResolver().deResolve((org.reuseware.coconut.reuseextension.ReuseExtension) o, element, (org.eclipse.emf.ecore.EReference) element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION)), element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__REUSE_EXTENSION), element));
				out.print(" ");
			}
			printCountingMap.put("reuseExtension", count - 1);
		}
		// DEFINITION PART BEGINS (CompoundDefinition)
		sWriter = new java.io.StringWriter();
		out1 = new java.io.PrintWriter(sWriter);
		printCountingMap1 = new java.util.LinkedHashMap<String, Integer>(printCountingMap);
		print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSyntaxSpecificationActivator_1(element, localtab, out1, printCountingMap1);
		if (printCountingMap.equals(printCountingMap1)) {
			out1.close();
		} else {
			out1.flush();
			out1.close();
			out.print(sWriter.toString());
			printCountingMap.putAll(printCountingMap1);
		}
		// DEFINITION PART BEGINS (LineBreak)
		out.println();
		out.print(localtab);
	}
	
	public void print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSyntaxSpecificationActivator_0(org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSyntaxSpecificationActivator element, String outertab, java.io.PrintWriter out, java.util.Map<String, Integer> printCountingMap) {
		int count;
		// DEFINITION PART BEGINS (PlaceholderUsingDefaultToken)
		count = printCountingMap.get("rexNamespace");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__REX_NAMESPACE));
			java.util.List<?> list = (java.util.List<?>) o;
			int index = list.size() - count;
			if (index >= 0) {
				o = list.get(index);
			} else {
				o = null;
			}
			if (o != null) {
				org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTokenResolver resolver = tokenResolverFactory.createTokenResolver("TEXT");
				resolver.setOptions(getOptions());
				out.print(resolver.deResolve((Object) o, element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__REX_NAMESPACE), element));
				out.print(" ");
			}
			printCountingMap.put("rexNamespace", count - 1);
		}
		// DEFINITION PART BEGINS (CsString)
		out.print(".");
		out.print(" ");
	}
	
	public void print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSyntaxSpecificationActivator_1(org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSyntaxSpecificationActivator element, String outertab, java.io.PrintWriter out, java.util.Map<String, Integer> printCountingMap) {
		String localtab = outertab;
		int count;
		boolean iterate = true;
		java.io.StringWriter sWriter = null;
		java.io.PrintWriter out1 = null;
		java.util.Map<String, Integer> printCountingMap1 = null;
		// DEFINITION PART BEGINS (CsString)
		out.print("(");
		out.print(" ");
		// DEFINITION PART BEGINS (Containment)
		count = printCountingMap.get("arguments");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__ARGUMENTS));
			java.util.List<?> list = (java.util.List<?>) o;
			int index = list.size() - count;
			if (index >= 0) {
				o = list.get(index);
			} else {
				o = null;
			}
			if (o != null) {
				doPrint((org.eclipse.emf.ecore.EObject) o, out, localtab);
			}
			printCountingMap.put("arguments", count - 1);
		}
		// DEFINITION PART BEGINS (CompoundDefinition)
		iterate = true;
		while (iterate) {
			sWriter = new java.io.StringWriter();
			out1 = new java.io.PrintWriter(sWriter);
			printCountingMap1 = new java.util.LinkedHashMap<String, Integer>(printCountingMap);
			print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSyntaxSpecificationActivator_1_0(element, localtab, out1, printCountingMap1);
			if (printCountingMap.equals(printCountingMap1)) {
				iterate = false;
				out1.close();
			} else {
				out1.flush();
				out1.close();
				out.print(sWriter.toString());
				printCountingMap.putAll(printCountingMap1);
			}
		}
		// DEFINITION PART BEGINS (CsString)
		out.print(")");
		out.print(" ");
	}
	
	public void print_org_reuseware_coconut_reuseextensionactivator_CompositionLanguageSyntaxSpecificationActivator_1_0(org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSyntaxSpecificationActivator element, String outertab, java.io.PrintWriter out, java.util.Map<String, Integer> printCountingMap) {
		String localtab = outertab;
		int count;
		// DEFINITION PART BEGINS (CsString)
		out.print(",");
		// DEFINITION PART BEGINS (WhiteSpaces)
		out.print(" ");
		// DEFINITION PART BEGINS (Containment)
		count = printCountingMap.get("arguments");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR__ARGUMENTS));
			java.util.List<?> list = (java.util.List<?>) o;
			int index = list.size() - count;
			if (index >= 0) {
				o = list.get(index);
			} else {
				o = null;
			}
			if (o != null) {
				doPrint((org.eclipse.emf.ecore.EObject) o, out, localtab);
			}
			printCountingMap.put("arguments", count - 1);
		}
	}
	
	
	public void print_org_reuseware_coconut_reuseextensionactivator_Argument(org.reuseware.coconut.reuseextensionactivator.Argument element, String outertab, java.io.PrintWriter out) {
		// The printCountingMap contains a mapping from feature names to the number of
		// remaining elements that still need to be printed. The map is initialized with
		// the number of elements stored in each structural feature. For lists this is the
		// list size. For non-multiple features it is either 1 (if the feature is set) or
		// 0 (if the feature is null).
		java.util.Map<String, Integer> printCountingMap = new java.util.LinkedHashMap<String, Integer>(3);
		Object temp;
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.ARGUMENT__PARAMETER));
		printCountingMap.put("parameter", temp == null ? 0 : 1);
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.ARGUMENT__REUSE_EXTENSION_ACTIVATOR));
		printCountingMap.put("reuseExtensionActivator", temp == null ? 0 : 1);
		temp = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.ARGUMENT__VALUE));
		printCountingMap.put("value", temp == null ? 0 : 1);
		// print collected hidden tokens
		int count;
		// DEFINITION PART BEGINS (PlaceholderUsingDefaultToken)
		count = printCountingMap.get("parameter");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.ARGUMENT__PARAMETER));
			if (o != null) {
				org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTokenResolver resolver = tokenResolverFactory.createTokenResolver("TEXT");
				resolver.setOptions(getOptions());
				out.print(resolver.deResolve((Object) o, element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.ARGUMENT__PARAMETER), element));
				out.print(" ");
			}
			printCountingMap.put("parameter", count - 1);
		}
		// DEFINITION PART BEGINS (CsString)
		out.print("=");
		out.print(" ");
		// DEFINITION PART BEGINS (PlaceholderInQuotes)
		count = printCountingMap.get("value");
		if (count > 0) {
			Object o = element.eGet(element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.ARGUMENT__VALUE));
			if (o != null) {
				org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorTokenResolver resolver = tokenResolverFactory.createTokenResolver("QUOTED_39_39");
				resolver.setOptions(getOptions());
				out.print(resolver.deResolve((Object) o, element.eClass().getEStructuralFeature(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.ARGUMENT__VALUE), element));
				out.print(" ");
			}
			printCountingMap.put("value", count - 1);
		}
	}
	
	
}
