/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp;

public class Rex_activatorProblem implements org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorProblem {
	
	private String message;
	private org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.Rex_activatorEProblemType type;
	private org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.Rex_activatorEProblemSeverity severity;
	private java.util.Collection<org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorQuickFix> quickFixes;
	
	public Rex_activatorProblem(String message, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.Rex_activatorEProblemType type, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.Rex_activatorEProblemSeverity severity) {
		this(message, type, severity, java.util.Collections.<org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorQuickFix>emptySet());
	}
	
	public Rex_activatorProblem(String message, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.Rex_activatorEProblemType type, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.Rex_activatorEProblemSeverity severity, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorQuickFix quickFix) {
		this(message, type, severity, java.util.Collections.singleton(quickFix));
	}
	
	public Rex_activatorProblem(String message, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.Rex_activatorEProblemType type, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.Rex_activatorEProblemSeverity severity, java.util.Collection<org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorQuickFix> quickFixes) {
		super();
		this.message = message;
		this.type = type;
		this.severity = severity;
		this.quickFixes = new java.util.LinkedHashSet<org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorQuickFix>();
		this.quickFixes.addAll(quickFixes);
	}
	
	public org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.Rex_activatorEProblemType getType() {
		return type;
	}
	
	public org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.Rex_activatorEProblemSeverity getSeverity() {
		return severity;
	}
	
	public String getMessage() {
		return message;
	}
	
	public java.util.Collection<org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorQuickFix> getQuickFixes() {
		return quickFixes;
	}
	
}
