/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.mopp;

public class Rex_activatorReferenceResolverSwitch implements org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorReferenceResolverSwitch {
	
	/**
	 * This map stores a copy of the options the were set for loading the resource.
	 */
	private java.util.Map<Object, Object> options;
	
	protected org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.analysis.ReuseExtensionActivatorReuseExtensionReferenceResolver reuseExtensionActivatorReuseExtensionReferenceResolver = new org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.analysis.ReuseExtensionActivatorReuseExtensionReferenceResolver();
	
	public org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorReferenceResolver<org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator, org.reuseware.coconut.reuseextension.ReuseExtension> getReuseExtensionActivatorReuseExtensionReferenceResolver() {
		return getResolverChain(org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.eINSTANCE.getReuseExtensionActivator_ReuseExtension(), reuseExtensionActivatorReuseExtensionReferenceResolver);
	}
	
	public void setOptions(java.util.Map<?, ?> options) {
		if (options != null) {
			this.options = new java.util.LinkedHashMap<Object, Object>();
			this.options.putAll(options);
		}
		reuseExtensionActivatorReuseExtensionReferenceResolver.setOptions(options);
	}
	
	public void resolveFuzzy(String identifier, org.eclipse.emf.ecore.EObject container, org.eclipse.emf.ecore.EReference reference, int position, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorReferenceResolveResult<org.eclipse.emf.ecore.EObject> result) {
		if (container == null) {
			return;
		}
		if (org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.eINSTANCE.getReuseExtensionActivator().isInstance(container)) {
			Rex_activatorFuzzyResolveResult<org.reuseware.coconut.reuseextension.ReuseExtension> frr = new Rex_activatorFuzzyResolveResult<org.reuseware.coconut.reuseextension.ReuseExtension>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("reuseExtension")) {
				reuseExtensionActivatorReuseExtensionReferenceResolver.resolve(identifier, (org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
	}
	
	public org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorReferenceResolver<? extends org.eclipse.emf.ecore.EObject, ? extends org.eclipse.emf.ecore.EObject> getResolver(org.eclipse.emf.ecore.EStructuralFeature reference) {
		if (reference == org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage.eINSTANCE.getReuseExtensionActivator_ReuseExtension()) {
			return getResolverChain(reference, reuseExtensionActivatorReuseExtensionReferenceResolver);
		}
		return null;
	}
	
	@SuppressWarnings({"rawtypes", "unchecked"})	
	public <ContainerType extends org.eclipse.emf.ecore.EObject, ReferenceType extends org.eclipse.emf.ecore.EObject> org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorReferenceResolver<ContainerType, ReferenceType> getResolverChain(org.eclipse.emf.ecore.EStructuralFeature reference, org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorReferenceResolver<ContainerType, ReferenceType> originalResolver) {
		if (options == null) {
			return originalResolver;
		}
		Object value = options.get(org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorOptions.ADDITIONAL_REFERENCE_RESOLVERS);
		if (value == null) {
			return originalResolver;
		}
		if (!(value instanceof java.util.Map)) {
			// send this to the error log
			new org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.util.Rex_activatorRuntimeUtil().logWarning("Found value with invalid type for option " + org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + java.util.Map.class.getName() + ", but was " + value.getClass().getName() + ")", null);
			return originalResolver;
		}
		java.util.Map<?,?> resolverMap = (java.util.Map<?,?>) value;
		Object resolverValue = resolverMap.get(reference);
		if (resolverValue == null) {
			return originalResolver;
		}
		if (resolverValue instanceof org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorReferenceResolver) {
			org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorReferenceResolver replacingResolver = (org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorReferenceResolver) resolverValue;
			if (replacingResolver instanceof org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorDelegatingReferenceResolver) {
				// pass original resolver to the replacing one
				((org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorDelegatingReferenceResolver) replacingResolver).setDelegate(originalResolver);
			}
			return replacingResolver;
		} else if (resolverValue instanceof java.util.Collection) {
			java.util.Collection replacingResolvers = (java.util.Collection) resolverValue;
			org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorReferenceResolver replacingResolver = originalResolver;
			for (Object next : replacingResolvers) {
				if (next instanceof org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorReferenceCache) {
					org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorReferenceResolver nextResolver = (org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorReferenceResolver) next;
					if (nextResolver instanceof org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorDelegatingReferenceResolver) {
						// pass original resolver to the replacing one
						((org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorDelegatingReferenceResolver) nextResolver).setDelegate(replacingResolver);
					}
					replacingResolver = nextResolver;
				} else {
					// The collection contains a non-resolver. Send a warning to the error log.
					new org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.util.Rex_activatorRuntimeUtil().logWarning("Found value with invalid type in value map for option " + org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorDelegatingReferenceResolver.class.getName() + ", but was " + next.getClass().getName() + ")", null);
				}
			}
			return replacingResolver;
		} else {
			// The value for the option ADDITIONAL_REFERENCE_RESOLVERS has an unknown type.
			new org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.util.Rex_activatorRuntimeUtil().logWarning("Found value with invalid type in value map for option " + org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + org.reuseware.coconut.reuseextensionactivator.resource.rexactivator.IRex_activatorDelegatingReferenceResolver.class.getName() + ", but was " + resolverValue.getClass().getName() + ")", null);
			return originalResolver;
		}
	}
	
}
