/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.reuseware.coconut.reuseextensionactivator.ui;

public abstract class AbstractRex_activatorOutlinePageAction extends org.eclipse.jface.action.Action {
	
	private String preferenceKey = this.getClass().getSimpleName() + ".isChecked";
	
	private org.reuseware.coconut.reuseextensionactivator.ui.Rex_activatorOutlinePageTreeViewer treeViewer;
	
	public AbstractRex_activatorOutlinePageAction(org.reuseware.coconut.reuseextensionactivator.ui.Rex_activatorOutlinePageTreeViewer treeViewer, String text, int style) {
		super(text, style);
		this.treeViewer = treeViewer;
	}
	
	public void initialize(String imagePath) {
		org.eclipse.jface.resource.ImageDescriptor descriptor = org.reuseware.coconut.reuseextensionactivator.ui.Rex_activatorImageProvider.INSTANCE.getImageDescriptor(imagePath);
		setDisabledImageDescriptor(descriptor);
		setImageDescriptor(descriptor);
		setHoverImageDescriptor(descriptor);
		boolean checked = org.reuseware.coconut.reuseextensionactivator.ui.Rex_activatorUIPlugin.getDefault().getPreferenceStore().getBoolean(preferenceKey);
		valueChanged(checked, false);
	}
	
	@Override	
	public void run() {
		if (keepState()) {
			valueChanged(isChecked(), true);
		} else {
			runBusy(true);
		}
	}
	
	public void runBusy(final boolean on) {
		org.eclipse.swt.custom.BusyIndicator.showWhile(org.eclipse.swt.widgets.Display.getCurrent(), new Runnable() {
			public void run() {
				runInternal(on);
			}
		});
	}
	
	public abstract void runInternal(boolean on);
	
	private void valueChanged(boolean on, boolean store) {
		setChecked(on);
		runBusy(on);
		if (store) {
			org.reuseware.coconut.reuseextensionactivator.ui.Rex_activatorUIPlugin.getDefault().getPreferenceStore().setValue(preferenceKey, on);
		}
	}
	
	public boolean keepState() {
		return true;
	}
	
	public org.reuseware.coconut.reuseextensionactivator.ui.Rex_activatorOutlinePageTreeViewer getTreeViewer() {
		return treeViewer;
	}
	
	public org.reuseware.coconut.reuseextensionactivator.ui.Rex_activatorOutlinePageTreeViewerComparator getTreeViewerComparator() {
		return (org.reuseware.coconut.reuseextensionactivator.ui.Rex_activatorOutlinePageTreeViewerComparator) treeViewer.getComparator();
	}
	
}
