/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextensionactivator.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import org.reuseware.coconut.reuseextensionactivator.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage
 * @generated
 */
public class ReuseextensionactivatorAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static ReuseextensionactivatorPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReuseextensionactivatorAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = ReuseextensionactivatorPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch that delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ReuseextensionactivatorSwitch<Adapter> modelSwitch =
    new ReuseextensionactivatorSwitch<Adapter>()
    {
      @Override
      public Adapter caseArgument(Argument object)
      {
        return createArgumentAdapter();
      }
      @Override
      public Adapter caseComponentModelSpecificationActivator(ComponentModelSpecificationActivator object)
      {
        return createComponentModelSpecificationActivatorAdapter();
      }
      @Override
      public Adapter caseCompositionLanguageSpecificationActivator(CompositionLanguageSpecificationActivator object)
      {
        return createCompositionLanguageSpecificationActivatorAdapter();
      }
      @Override
      public Adapter caseCompositionLanguageSyntaxSpecificationActivator(CompositionLanguageSyntaxSpecificationActivator object)
      {
        return createCompositionLanguageSyntaxSpecificationActivatorAdapter();
      }
      @Override
      public Adapter caseReuseExtensionActivatorList(ReuseExtensionActivatorList object)
      {
        return createReuseExtensionActivatorListAdapter();
      }
      @Override
      public Adapter caseReuseExtensionActivator(ReuseExtensionActivator object)
      {
        return createReuseExtensionActivatorAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextensionactivator.Argument <em>Argument</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextensionactivator.Argument
   * @generated
   */
  public Adapter createArgumentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextensionactivator.ComponentModelSpecificationActivator <em>Component Model Specification Activator</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextensionactivator.ComponentModelSpecificationActivator
   * @generated
   */
  public Adapter createComponentModelSpecificationActivatorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSpecificationActivator <em>Composition Language Specification Activator</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSpecificationActivator
   * @generated
   */
  public Adapter createCompositionLanguageSpecificationActivatorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSyntaxSpecificationActivator <em>Composition Language Syntax Specification Activator</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextensionactivator.CompositionLanguageSyntaxSpecificationActivator
   * @generated
   */
  public Adapter createCompositionLanguageSyntaxSpecificationActivatorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivatorList <em>Reuse Extension Activator List</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivatorList
   * @generated
   */
  public Adapter createReuseExtensionActivatorListAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator <em>Reuse Extension Activator</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.reuseware.coconut.reuseextensionactivator.ReuseExtensionActivator
   * @generated
   */
  public Adapter createReuseExtensionActivatorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //ReuseextensionactivatorAdapterFactory
