/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.reuseware.coconut.reuseextensionactivator.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

import org.reuseware.coconut.reuseextensionactivator.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.reuseware.coconut.reuseextensionactivator.ReuseextensionactivatorPackage
 * @generated
 */
public class ReuseextensionactivatorSwitch<T> extends Switch<T>
{
  /**
   * The cached model package
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static ReuseextensionactivatorPackage modelPackage;

  /**
   * Creates an instance of the switch.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ReuseextensionactivatorSwitch()
  {
    if (modelPackage == null)
    {
      modelPackage = ReuseextensionactivatorPackage.eINSTANCE;
    }
  }

  /**
   * Checks whether this is a switch for the given package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @parameter ePackage the package in question.
   * @return whether this is a switch for the given package.
   * @generated
   */
  @Override
  protected boolean isSwitchFor(EPackage ePackage)
  {
    return ePackage == modelPackage;
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  @Override
  protected T doSwitch(int classifierID, EObject theEObject)
  {
    switch (classifierID)
    {
      case ReuseextensionactivatorPackage.ARGUMENT:
      {
        Argument argument = (Argument)theEObject;
        T result = caseArgument(argument);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ReuseextensionactivatorPackage.COMPONENT_MODEL_SPECIFICATION_ACTIVATOR:
      {
        ComponentModelSpecificationActivator componentModelSpecificationActivator = (ComponentModelSpecificationActivator)theEObject;
        T result = caseComponentModelSpecificationActivator(componentModelSpecificationActivator);
        if (result == null) result = caseReuseExtensionActivator(componentModelSpecificationActivator);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SPECIFICATION_ACTIVATOR:
      {
        CompositionLanguageSpecificationActivator compositionLanguageSpecificationActivator = (CompositionLanguageSpecificationActivator)theEObject;
        T result = caseCompositionLanguageSpecificationActivator(compositionLanguageSpecificationActivator);
        if (result == null) result = caseReuseExtensionActivator(compositionLanguageSpecificationActivator);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ReuseextensionactivatorPackage.COMPOSITION_LANGUAGE_SYNTAX_SPECIFICATION_ACTIVATOR:
      {
        CompositionLanguageSyntaxSpecificationActivator compositionLanguageSyntaxSpecificationActivator = (CompositionLanguageSyntaxSpecificationActivator)theEObject;
        T result = caseCompositionLanguageSyntaxSpecificationActivator(compositionLanguageSyntaxSpecificationActivator);
        if (result == null) result = caseReuseExtensionActivator(compositionLanguageSyntaxSpecificationActivator);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR_LIST:
      {
        ReuseExtensionActivatorList reuseExtensionActivatorList = (ReuseExtensionActivatorList)theEObject;
        T result = caseReuseExtensionActivatorList(reuseExtensionActivatorList);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case ReuseextensionactivatorPackage.REUSE_EXTENSION_ACTIVATOR:
      {
        ReuseExtensionActivator reuseExtensionActivator = (ReuseExtensionActivator)theEObject;
        T result = caseReuseExtensionActivator(reuseExtensionActivator);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      default: return defaultCase(theEObject);
    }
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Argument</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Argument</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseArgument(Argument object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Component Model Specification Activator</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Component Model Specification Activator</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseComponentModelSpecificationActivator(ComponentModelSpecificationActivator object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Composition Language Specification Activator</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Composition Language Specification Activator</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseCompositionLanguageSpecificationActivator(CompositionLanguageSpecificationActivator object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Composition Language Syntax Specification Activator</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Composition Language Syntax Specification Activator</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseCompositionLanguageSyntaxSpecificationActivator(CompositionLanguageSyntaxSpecificationActivator object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Reuse Extension Activator List</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Reuse Extension Activator List</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseReuseExtensionActivatorList(ReuseExtensionActivatorList object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Reuse Extension Activator</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Reuse Extension Activator</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseReuseExtensionActivator(ReuseExtensionActivator object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch, but this is the last case anyway.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject)
   * @generated
   */
  @Override
  public T defaultCase(EObject object)
  {
    return null;
  }

} //ReuseextensionactivatorSwitch
